/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.commons.util;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * array util.
 * 
 * @author yosuke
 * 
 */
public class ArrayUtil {

    /**
     * string array to integer array.
     * 
     * @param values
     * @return
     */
    public static Integer[] stringArrayToIntegerArray(List<String> values) {
        List<Integer> list = new ArrayList<Integer>();
        Iterator<String> i = values.iterator();
        while (i.hasNext()) {
            list.add(new Integer(i.next()));
        }
        return list.toArray(new Integer[list.size()]);
    }

    /**
     * string array to long array.
     * 
     * @param values
     * @return
     */
    public static Long[] stringArrayToLongArray(List<String> values) {
        List<Long> list = new ArrayList<Long>();
        Iterator<String> i = values.iterator();
        while (i.hasNext()) {
            list.add(new Long(i.next()));
        }
        return list.toArray(new Long[list.size()]);
    }

    /**
     * string array to short array.
     * 
     * @param values
     * @return
     */
    public static Short[] stringArrayToShortArray(List<String> values) {
        List<Short> list = new ArrayList<Short>();
        Iterator<String> i = values.iterator();
        while (i.hasNext()) {
            list.add(new Short(i.next()));
        }
        return list.toArray(new Short[list.size()]);
    }

    /**
     * string array to float array.
     * 
     * @param values
     * @return
     */
    public static Float[] stringArrayToFloatArray(List<String> values) {
        List<Float> list = new ArrayList<Float>();
        Iterator<String> i = values.iterator();
        while (i.hasNext()) {
            list.add(new Float(i.next()));
        }
        return list.toArray(new Float[list.size()]);
    }

    /**
     * string array to double array.
     * 
     * @param values
     * @return
     */
    public static Double[] stringArrayToDoubleArray(List<String> values) {
        List<Double> list = new ArrayList<Double>();
        Iterator<String> i = values.iterator();
        while (i.hasNext()) {
            list.add(new Double(i.next()));
        }
        return list.toArray(new Double[list.size()]);
    }

    /**
     * string array to boolean array.
     * 
     * @param values
     * @return
     */
    public static Boolean[] stringArrayToBooleanArray(List<String> values) {
        List<Boolean> list = new ArrayList<Boolean>();
        Iterator<String> i = values.iterator();
        while (i.hasNext()) {
            list.add(new Boolean(i.next()));
        }
        return list.toArray(new Boolean[list.size()]);
    }

    /**
     * string array to float array.
     * 
     * @param values
     * @return
     */
    public static Object[] stringArrayToObjectArray(List<String> values) {
        List<Object> list = new ArrayList<Object>();
        Iterator<?> i = values.iterator();
        while (i.hasNext()) {
            list.add(i.next());
        }
        return list.toArray(new Object[list.size()]);
    }

}
