/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.container.annotation;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * Page Control Annotation
 * 
 * @author yousuke.hara
 */
@Retention(RetentionPolicy.RUNTIME)
public @interface FormAnnotation {

    /**
     * form id
     * 
     * @return
     */
    String formId();

    /**
     * form description
     * 
     * @return
     */
    String description() default "";

    /**
     * Is authorization check.
     * 
     * @return
     */
    boolean isAuthorizationCheck() default true;

    /**
     * is direct access check.
     * 
     * @return
     */
    boolean isDirectAccessCheck();

    /**
     * error page arias.
     * 
     * @return
     */
    String errorPage() default "";

    /**
     * is admin tool.
     * 
     * @return
     */
    boolean isAdminTool() default false;
}
