/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.container.dto;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * browse info dto.
 * 
 * @author yosuke
 * 
 */
public class BrowseInfoDto implements Serializable {
    private static final long serialVersionUID = 6945351390739415018L;
    
    /* type */
    String type_;

    public String getType() {
        return type_;
    }

    public void setType(String type) {
        this.type_ = type;
    }

    /* pid */
    String pid_;

    public String getPid() {
        return pid_;
    }

    public void setPid(String pid) {
        this.pid_ = pid;
    }

    /* url */
    String url_;

    public String getUrl() {
        return url_;
    }

    public void setUrl(String url) {
        this.url_ = url;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((pid_ == null) ? 0 : pid_.hashCode());
        result = prime * result + ((type_ == null) ? 0 : type_.hashCode());
        result = prime * result + ((url_ == null) ? 0 : url_.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final BrowseInfoDto other = (BrowseInfoDto) obj;
        if (pid_ == null) {
            if (other.pid_ != null)
                return false;
        } else if (!pid_.equals(other.pid_))
            return false;
        if (type_ == null) {
            if (other.type_ != null)
                return false;
        } else if (!type_.equals(other.type_))
            return false;
        if (url_ == null) {
            if (other.url_ != null)
                return false;
        } else if (!url_.equals(other.url_))
            return false;
        return true;
    }
    
}
