/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.container.dto;

import java.io.Serializable;
import java.util.Arrays;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * search condition dto.
 * 
 * @author yousuke.hara
 * 
 */
public class SearchConditionDto implements Serializable {
    private static final long serialVersionUID = 8313699198900962430L;

    public SearchConditionDto() {
    }

    /**
     * 
     * @param keyword
     */
    public SearchConditionDto(String keyword) {
        this.keyword_ = keyword;
    }

    /* keyword */
    String keyword_;

    public String getKeyword() {
        return this.keyword_;
    }

    public void setKeyword(String keyword) {
        this.keyword_ = keyword;
    }

    boolean previous;

    public boolean hasPrevious() {
        return previous;
    }

    public void setPrevious(boolean previous) {
        this.previous = previous;
    }

    boolean next;

    public boolean hasNext() {
        return next;
    }

    public void setNext(boolean next) {
        this.next = next;
    }

    /* activity id */
    String[] activityIds;

    public String[] getActivityIds() {
        return activityIds;
    }

    public void setActivityIds(String[] activityIds) {
        this.activityIds = activityIds;
    }

    int count;

    public int getCount() {
        return count;
    }

    public void setCount(int count) {
        this.count = count;
    }

    int offset;

    public int getOffset() {
        return offset;
    }

    public void setOffset(int offset) {
        this.offset = offset;
    }

    int totalPage;

    public int getTotalPage() {
        return totalPage;
    }

    public void setTotalPage(int totalPage) {
        this.totalPage = totalPage;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + Arrays.hashCode(activityIds);
        result = prime * result + count;
        result = prime * result
                + ((keyword_ == null) ? 0 : keyword_.hashCode());
        result = prime * result + (next ? 1231 : 1237);
        result = prime * result + offset;
        result = prime * result + (previous ? 1231 : 1237);
        result = prime * result + totalPage;
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final SearchConditionDto other = (SearchConditionDto) obj;
        if (!Arrays.equals(activityIds, other.activityIds))
            return false;
        if (count != other.count)
            return false;
        if (keyword_ == null) {
            if (other.keyword_ != null)
                return false;
        } else if (!keyword_.equals(other.keyword_))
            return false;
        if (next != other.next)
            return false;
        if (offset != other.offset)
            return false;
        if (previous != other.previous)
            return false;
        if (totalPage != other.totalPage)
            return false;
        return true;
    }
    
}
