/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.container.dto;

import java.io.Serializable;
import java.util.Arrays;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * Search result info dto.
 * 
 * @author yousuke.hara
 * 
 */
public class SearchResultInfoDto implements Serializable {
    private static final long serialVersionUID = -1883121134730038167L;
    
    /* search processing time */
    float processingTime_;

    public float getProcessingTime() {
        return processingTime_;
    }

    public void setProcessingTime(float processingTime) {
        this.processingTime_ = processingTime;
    }

    /* count */
    long count_;

    public long getCount() {
        return count_;
    }

    public void setCount(long count) {
        this.count_ = count;
    }

    /* keyword */
    String keyword_;

    public String getKeyword() {
        return this.keyword_;
    }

    public void setKeyword(String keyword) {
        this.keyword_ = keyword;
    }

    /* search result */
    SearchDto[] searchResultDtos_;

    public SearchDto[] getSearchResultDtos() {
        return searchResultDtos_;
    }

    public void setSearchResultDtos(SearchDto[] searchResultDtos) {
        this.searchResultDtos_ = searchResultDtos;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (count_ ^ (count_ >>> 32));
        result = prime * result
                + ((keyword_ == null) ? 0 : keyword_.hashCode());
        result = prime * result + Float.floatToIntBits(processingTime_);
        result = prime * result + Arrays.hashCode(searchResultDtos_);
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final SearchResultInfoDto other = (SearchResultInfoDto) obj;
        if (count_ != other.count_)
            return false;
        if (keyword_ == null) {
            if (other.keyword_ != null)
                return false;
        } else if (!keyword_.equals(other.keyword_))
            return false;
        if (Float.floatToIntBits(processingTime_) != Float
                .floatToIntBits(other.processingTime_))
            return false;
        if (!Arrays.equals(searchResultDtos_, other.searchResultDtos_))
            return false;
        return true;
    }
    
}
