/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.container.dto;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * Page Control Annotation.
 * 
 * @author yousuke.hara
 */
public class SecurityDto implements Serializable {
    private static final long serialVersionUID = -4649125184263004898L;

    public SecurityDto() {
        super();
    }

    /* form id */
    String formId_;

    public String getFormId() {
        return formId_;
    }

    public void setFormId(String formId) {
        this.formId_ = formId;
    }

    /* description */
    String description_;

    public String getDescription() {
        return description_;
    }

    public void setDescription(String description) {
        this.description_ = description;
    }

    /* is authorization check */
    boolean isAuthorizationCheck_;

    public boolean isAuthorizationCheck() {
        return isAuthorizationCheck_;
    }

    public void setAuthorizationCheck(boolean isAuthorizationCheck) {
        this.isAuthorizationCheck_ = isAuthorizationCheck;
    }

    /* is direct access check */
    boolean isDirectAccessCheck_;

    public boolean isDirectAccessCheck() {
        return isDirectAccessCheck_;
    }

    public void setDirectAccessCheck(boolean isDirectAccessCheck) {
        this.isDirectAccessCheck_ = isDirectAccessCheck;
    }

    /* error page */
    String errorPage_;

    public String getErrorPage() {
        return errorPage_;
    }

    public void setErrorPage(String errorPage) {
        this.errorPage_ = errorPage;
    }

    /* is admin tool */
    boolean isAdminTool_ = false;

    public boolean getIsAdminTool() {
        return isAdminTool_;
    }

    public void setIsAdminTool(boolean isAdminTool) {
        this.isAdminTool_ = isAdminTool;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result
                + ((description_ == null) ? 0 : description_.hashCode());
        result = prime * result
                + ((errorPage_ == null) ? 0 : errorPage_.hashCode());
        result = prime * result + ((formId_ == null) ? 0 : formId_.hashCode());
        result = prime * result + (isAdminTool_ ? 1231 : 1237);
        result = prime * result + (isAuthorizationCheck_ ? 1231 : 1237);
        result = prime * result + (isDirectAccessCheck_ ? 1231 : 1237);
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final SecurityDto other = (SecurityDto) obj;
        if (description_ == null) {
            if (other.description_ != null)
                return false;
        } else if (!description_.equals(other.description_))
            return false;
        if (errorPage_ == null) {
            if (other.errorPage_ != null)
                return false;
        } else if (!errorPage_.equals(other.errorPage_))
            return false;
        if (formId_ == null) {
            if (other.formId_ != null)
                return false;
        } else if (!formId_.equals(other.formId_))
            return false;
        if (isAdminTool_ != other.isAdminTool_)
            return false;
        if (isAuthorizationCheck_ != other.isAuthorizationCheck_)
            return false;
        if (isDirectAccessCheck_ != other.isDirectAccessCheck_)
            return false;
        return true;
    }
    
}
