/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.container.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * webservice security.
 * 
 * @author yosuke
 * 
 */
@Bean(table = "web_service_securities")
public class WebServiceSecurity implements Serializable {
    private static final long serialVersionUID = 62951767054826647L;
    
    /* id */
    int id_;

    @Column("ID")
    public int getId() {
        return id_;
    }

    public void setId(int id) {
        this.id_ = id;
    }

    /* client address */
    String clientAddress_;

    @Column("CLIENT_ADDRESS")
    public String getClientAddress() {
        return clientAddress_;
    }

    public void setClientAddress(String clientAddress) {
        this.clientAddress_ = clientAddress;
    }

    /* nonce */
    String nonce_;

    @Column("NONCE")
    public String getNonce() {
        return nonce_;
    }

    public void setNonce(String nonce) {
        this.nonce_ = nonce;
    }

    /* created at */
    String createdAt_;

    @Column("CREATED_AT")
    public String getCreatedAt() {
        return createdAt_;
    }

    public void setCreatedAt(String createdAt) {
        this.createdAt_ = createdAt;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result
                + ((clientAddress_ == null) ? 0 : clientAddress_.hashCode());
        result = prime * result
                + ((createdAt_ == null) ? 0 : createdAt_.hashCode());
        result = prime * result + id_;
        result = prime * result + ((nonce_ == null) ? 0 : nonce_.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final WebServiceSecurity other = (WebServiceSecurity) obj;
        if (clientAddress_ == null) {
            if (other.clientAddress_ != null)
                return false;
        } else if (!clientAddress_.equals(other.clientAddress_))
            return false;
        if (createdAt_ == null) {
            if (other.createdAt_ != null)
                return false;
        } else if (!createdAt_.equals(other.createdAt_))
            return false;
        if (id_ != other.id_)
            return false;
        if (nonce_ == null) {
            if (other.nonce_ != null)
                return false;
        } else if (!nonce_.equals(other.nonce_))
            return false;
        return true;
    }
    
}
