/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.container.exception;

/**
 * User Already Exist Runtime Exception
 * 
 * @author yousuke.hara
 * 
 */
public class UserAlreadyExistRuntimeException extends AppRuntimeException {
    private static final long serialVersionUID = 1305281142735643545L;

    /**
     * 
     * @param messageId
     */
    public UserAlreadyExistRuntimeException(String messageId) {
        super(messageId);
    }

    /**
     * 
     * @param messageId
     * @param args
     */
    public UserAlreadyExistRuntimeException(String messageId, Object[] args) {
        super(messageId, args);
    }

    /**
     * 
     * @param messageId
     * @param args
     * @param cause
     */
    public UserAlreadyExistRuntimeException(String messageId, Object[] args, Throwable cause) {
        super(messageId, args, cause);
    }

    String loginId_;

    String email_;

    /**
     * 
     * @param loginId
     * @param email
     */
    public UserAlreadyExistRuntimeException(String loginId, String email) {
        super("validator.errors.userAlreadyExist", new Object[] { loginId, email });

        this.loginId_ = loginId;
        this.email_ = email;
    }

    /**
     * Get Login ID
     * 
     * @return
     */
    public String getLoginId() {
        return this.loginId_;
    }

    /**
     * Get Email
     * 
     * @return
     */
    public String getEmail() {
        return this.email_;
    }
}
