/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.activity.dto;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.tugboat.gtd.contents.activity.entity.Activity;

/**
 * Activity DTO
 * 
 * @author yousuke.hara
 * 
 */
public class ActivityDto extends Activity {
    private static final long serialVersionUID = 2646445095159480437L;
    
    List<ActivityMemberDto> memberList_ = new ArrayList<ActivityMemberDto>();

    public ActivityDto() {
        super();
    }

    /**
     * add member
     * 
     * @param member
     */
    public synchronized void addMember(ActivityMemberDto member) {
        memberList_.add(member);
    }

    /**
     * get member list.
     * 
     * @return
     */
    public synchronized List<ActivityMemberDto> getMembers() {
        return memberList_;
    }

    /* member user id */
    private int[] memberUserId_;

    public int[] getMemberUserId() {
        return memberUserId_;
    }

    public void setMemberUserId(int[] memberUserId) {
        this.memberUserId_ = memberUserId;
    }

    /* member role id */
    private int[] memberRoleId_;

    public int[] getMemberRoleId() {
        return memberRoleId_;
    }

    public void setMemberRoleId(int[] memberRoleId) {
        this.memberRoleId_ = memberRoleId;
    }

    /* keyword */
    private String keyword_;

    public String getKeyword() {
        return keyword_;
    }

    public void setKeyword(String keyword) {
        this.keyword_ = keyword;
    }

    /* registered formated string */
    private String registeredFormated_;

    public String getRegisteredFormated() {
        return registeredFormated_;
    }

    public void setRegisteredFormated(String registeredFormated) {
        this.registeredFormated_ = registeredFormated;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime * result
                + ((keyword_ == null) ? 0 : keyword_.hashCode());
        result = prime * result
                + ((memberList_ == null) ? 0 : memberList_.hashCode());
        result = prime * result + Arrays.hashCode(memberRoleId_);
        result = prime * result + Arrays.hashCode(memberUserId_);
        result = prime
                * result
                + ((registeredFormated_ == null) ? 0 : registeredFormated_
                        .hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!super.equals(obj))
            return false;
        if (getClass() != obj.getClass())
            return false;
        final ActivityDto other = (ActivityDto) obj;
        if (keyword_ == null) {
            if (other.keyword_ != null)
                return false;
        } else if (!keyword_.equals(other.keyword_))
            return false;
        if (memberList_ == null) {
            if (other.memberList_ != null)
                return false;
        } else if (!memberList_.equals(other.memberList_))
            return false;
        if (!Arrays.equals(memberRoleId_, other.memberRoleId_))
            return false;
        if (!Arrays.equals(memberUserId_, other.memberUserId_))
            return false;
        if (registeredFormated_ == null) {
            if (other.registeredFormated_ != null)
                return false;
        } else if (!registeredFormated_.equals(other.registeredFormated_))
            return false;
        return true;
    }
    
}
