/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.activity.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * Activity.
 * 
 * @author yousuke.hara
 * 
 */
@Bean(table = "activities")
public class Activity implements Serializable {
    private static final long serialVersionUID = 606566087038211570L;

    public Activity() {
        super();
    }

    /* Id */
    private long id_;

    @Column("ID")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* Index */
    private String index_ = "";

    public String getIndex() {
        return index_;
    }

    public void setIndex(String index) {
        this.index_ = index;
    }

    /* Name */
    private String name_ = "";

    @Column("NAME")
    public String getName() {
        return name_;
    }

    public void setName(String name) {
        this.name_ = name;
    }

    /* Abbreviation */
    private String abbreviation_ = "";

    @Column("ABBREVIATION")
    public String getAbbreviation() {
        return abbreviation_;
    }

    public void setAbbreviation(String abbreviation) {
        this.abbreviation_ = abbreviation;
    }

    /* Start Date */
    private String startDate_ = "";

    @Column("START_DATE")
    public String getStartDate() {
        return startDate_;
    }

    public void setStartDate(String startDate) {
        this.startDate_ = startDate;
    }

    /* End Date */
    private String endDate_ = "";

    @Column("END_DATE")
    public String getEndDate() {
        return endDate_;
    }

    public void setEndDate(String endDate) {
        this.endDate_ = endDate;
    }

    /* Status Id */
    private int statusId_;

    @Column("STATUS")
    public int getStatusId() {
        return statusId_;
    }

    public void setStatusId(int statusId) {
        this.statusId_ = statusId;
    }

    /* Status Label */
    private String statusLabel_ = "";

    public String getStatusLabel() {
        return statusLabel_;
    }

    public void setStatusLabel(String statusLabel) {
        this.statusLabel_ = statusLabel;
    }

    /* description */
    private String description_ = "";

    @Column("DESCRIPTION")
    public String getDescription() {
        return description_;
    }

    public void setDescription(String description) {
        this.description_ = description;
    }

    /* registered */
    private String registered_;

    @Column("REGISTERED")
    public String getRegistered() {
        return registered_;
    }

    public void setRegistered(String registered) {
        this.registered_ = registered;
    }

    /* modified datetime */
    private String modified_;

    @Column("MODIFIED")
    public String getModified() {
        return modified_;
    }

    public void setModified(String modified) {
        this.modified_ = modified;
    }

    /* modified user id */
    private long modifiedUserId_;

    @Column("MODIFIED_USER_ID")
    public long getModifiedUserId() {
        return modifiedUserId_;
    }

    public void setModifiedUserId(long modifiedUserId) {
        this.modifiedUserId_ = modifiedUserId;
    }

    /* class id */
    private int classId_;

    @Column("CLASS_ID")
    public int getClassId() {
        return classId_;
    }

    public void setClassId(int classId) {
        this.classId_ = classId;
    }

    /* class name */
    private String className_;

    @Column("CLASS_NAME")
    public String getClassName() {
        return className_;
    }

    public void setClassName(String className) {
        this.className_ = className;
    }

    /* color id */
    private int colorId_;

    @Column("COLOR_ID")
    public int getColorId() {
        return colorId_;
    }

    public void setColorId(int colorId) {
        this.colorId_ = colorId;
    }

    /* color */
    private String colorValue_;

    @Column("COLOR_VALUE")
    public String getColorValue() {
        return colorValue_;
    }

    public void setColorValue(String colorValue) {
        this.colorValue_ = colorValue;
    }

    /* color name */
    private String colorName_;

    @Column("COLOR_NAME")
    public String getColorName() {
        return colorName_;
    }

    public void setColorName(String colorName) {
        this.colorName_ = colorName;
    }

    /* is send mail flag ("0" is not send, "1" is send) */
    private String isSendMail_ = "0";

    @Column("IS_SEND_MAIL")
    public String getIsSendMail() {
        return isSendMail_;
    }

    public void setIsSendMail(String isSendMail) {
        this.isSendMail_ = isSendMail;
    }

    /* feed token */
    private String feedToken_;

    @Column("FEED_TOKEN")
    public String getFeedToken() {
        return feedToken_;
    }

    public void setFeedToken(String feedToken) {
        this.feedToken_ = feedToken;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result
                + ((abbreviation_ == null) ? 0 : abbreviation_.hashCode());
        result = prime * result + classId_;
        result = prime * result
                + ((className_ == null) ? 0 : className_.hashCode());
        result = prime * result + colorId_;
        result = prime * result
                + ((colorName_ == null) ? 0 : colorName_.hashCode());
        result = prime * result
                + ((colorValue_ == null) ? 0 : colorValue_.hashCode());
        result = prime * result
                + ((description_ == null) ? 0 : description_.hashCode());
        result = prime * result
                + ((endDate_ == null) ? 0 : endDate_.hashCode());
        result = prime * result
                + ((feedToken_ == null) ? 0 : feedToken_.hashCode());
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result + ((index_ == null) ? 0 : index_.hashCode());
        result = prime * result
                + ((isSendMail_ == null) ? 0 : isSendMail_.hashCode());
        result = prime * result
                + (int) (modifiedUserId_ ^ (modifiedUserId_ >>> 32));
        result = prime * result
                + ((modified_ == null) ? 0 : modified_.hashCode());
        result = prime * result + ((name_ == null) ? 0 : name_.hashCode());
        result = prime * result
                + ((registered_ == null) ? 0 : registered_.hashCode());
        result = prime * result
                + ((startDate_ == null) ? 0 : startDate_.hashCode());
        result = prime * result + statusId_;
        result = prime * result
                + ((statusLabel_ == null) ? 0 : statusLabel_.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final Activity other = (Activity) obj;
        if (abbreviation_ == null) {
            if (other.abbreviation_ != null)
                return false;
        } else if (!abbreviation_.equals(other.abbreviation_))
            return false;
        if (classId_ != other.classId_)
            return false;
        if (className_ == null) {
            if (other.className_ != null)
                return false;
        } else if (!className_.equals(other.className_))
            return false;
        if (colorId_ != other.colorId_)
            return false;
        if (colorName_ == null) {
            if (other.colorName_ != null)
                return false;
        } else if (!colorName_.equals(other.colorName_))
            return false;
        if (colorValue_ == null) {
            if (other.colorValue_ != null)
                return false;
        } else if (!colorValue_.equals(other.colorValue_))
            return false;
        if (description_ == null) {
            if (other.description_ != null)
                return false;
        } else if (!description_.equals(other.description_))
            return false;
        if (endDate_ == null) {
            if (other.endDate_ != null)
                return false;
        } else if (!endDate_.equals(other.endDate_))
            return false;
        if (feedToken_ == null) {
            if (other.feedToken_ != null)
                return false;
        } else if (!feedToken_.equals(other.feedToken_))
            return false;
        if (id_ != other.id_)
            return false;
        if (index_ == null) {
            if (other.index_ != null)
                return false;
        } else if (!index_.equals(other.index_))
            return false;
        if (isSendMail_ == null) {
            if (other.isSendMail_ != null)
                return false;
        } else if (!isSendMail_.equals(other.isSendMail_))
            return false;
        if (modifiedUserId_ != other.modifiedUserId_)
            return false;
        if (modified_ == null) {
            if (other.modified_ != null)
                return false;
        } else if (!modified_.equals(other.modified_))
            return false;
        if (name_ == null) {
            if (other.name_ != null)
                return false;
        } else if (!name_.equals(other.name_))
            return false;
        if (registered_ == null) {
            if (other.registered_ != null)
                return false;
        } else if (!registered_.equals(other.registered_))
            return false;
        if (startDate_ == null) {
            if (other.startDate_ != null)
                return false;
        } else if (!startDate_.equals(other.startDate_))
            return false;
        if (statusId_ != other.statusId_)
            return false;
        if (statusLabel_ == null) {
            if (other.statusLabel_ != null)
                return false;
        } else if (!statusLabel_.equals(other.statusLabel_))
            return false;
        return true;
    }
    
}
