/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.activity.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * activity members
 * 
 * @author naoya.saito
 * 
 */
@Bean(table = "activity_members")
public class ActivityMember implements Serializable {
    private static final long serialVersionUID = -3267886282126613035L;

    public static final String DELETE = "1";

    public static final String NOT_DELETED = "0";

    /* calendar livemeeting topic id */
    private long id_;

    @Column("ID")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* activity id */
    private long activityId_;

    @Column("ACTIVITY_ID")
    public long getActivityId() {
        return activityId_;
    }

    public void setActivityId(long activityId) {
        this.activityId_ = activityId;
    }

    /* user id */
    private long userId_;

    @Column("USER_ID")
    public long getUserId() {
        return userId_;
    }

    public void setUserId(long userId) {
        this.userId_ = userId;
    }

    /* role id */
    private int roleId_;

    @Column("ROLE_ID")
    public int getRoleId() {
        return roleId_;
    }

    public void setRoleId(int roleId) {
        this.roleId_ = roleId;
    }

    /* role name */
    private String roleName_;

    @Column("ROLE_NAME")
    public String getRoleName() {
        return roleName_;
    }

    public void setRoleName(String roleName) {
        this.roleName_ = roleName;
    }

    /* start date */
    private String startDate_;

    @Column("START_DATE")
    public String getStartDate() {
        return startDate_;
    }

    public void setStartDate(String startDate) {
        this.startDate_ = startDate;
    }

    /* end date */
    private String endDate_;

    @Column("END_DATE")
    public String getEndDate() {
        return endDate_;
    }

    public void setEndDate(String endDate) {
        this.endDate_ = endDate;
    }

    /* delete */
    private String deleteFlag_;

    @Column("DEL_FALG")
    public String getDeleteFlag() {
        return deleteFlag_;
    }

    public void setDeleteFlag(String deleteFlag) {
        this.deleteFlag_ = deleteFlag;
    }

    private String registered_;

    @Column("REGISTERED")
    public String getRegistered() {
        return registered_;
    }

    public void setRegistered(String registered) {
        this.registered_ = registered;
    }

    /* calendar livemeeting topic modified */
    private String modified_;

    @Column("MODIFIED")
    public String getModified() {
        return modified_;
    }

    public void setModified(String modified) {
        this.modified_ = modified;
    }

    private long modifiedUserId_;

    @Column("MODIFIED_USER_ID")
    public long getModifiedUserId() {
        return modifiedUserId_;
    }

    public void setModifiedUserId(long modifiedUserId) {
        this.modifiedUserId_ = modifiedUserId;
    }

    /* m_user id */
    private String firstName_;

    @Column("FIRST_NAME")
    public String getFirstName() {
        return firstName_;
    }

    public void setFirstName(String firstName) {
        this.firstName_ = firstName;
    }

    /* m_user last name */
    private String lastName_;

    @Column("LAST_NAME")
    public String getLastName() {
        return lastName_;
    }

    public void setLastName(String lastName) {
        this.lastName_ = lastName;
    }

    /* m_user middle name */
    private String middleName_;

    @Column("MIDDLE_NAME")
    public String getMiddleName() {
        return middleName_;
    }

    public void setMiddleName(String middleName) {
        this.middleName_ = middleName;
    }

    /* m_user photo img url */
    private String photoImgUrl_;

    @Column("PHOTO_IMG_URL")
    public String getPhotoImgUrl() {
        return photoImgUrl_;
    }

    public void setPhotoImgUrl(String photoImgUrl) {
        this.photoImgUrl_ = photoImgUrl;
    }

    /* email */
    private String email_;

    @Column("EMAIL")
    public String getEmail() {
        return email_;
    }

    public void setEmail(String email) {
        this.email_ = email;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (activityId_ ^ (activityId_ >>> 32));
        result = prime * result
                + ((deleteFlag_ == null) ? 0 : deleteFlag_.hashCode());
        result = prime * result + ((email_ == null) ? 0 : email_.hashCode());
        result = prime * result
                + ((endDate_ == null) ? 0 : endDate_.hashCode());
        result = prime * result
                + ((firstName_ == null) ? 0 : firstName_.hashCode());
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result
                + ((lastName_ == null) ? 0 : lastName_.hashCode());
        result = prime * result
                + ((middleName_ == null) ? 0 : middleName_.hashCode());
        result = prime * result
                + (int) (modifiedUserId_ ^ (modifiedUserId_ >>> 32));
        result = prime * result
                + ((modified_ == null) ? 0 : modified_.hashCode());
        result = prime * result
                + ((photoImgUrl_ == null) ? 0 : photoImgUrl_.hashCode());
        result = prime * result
                + ((registered_ == null) ? 0 : registered_.hashCode());
        result = prime * result + roleId_;
        result = prime * result
                + ((roleName_ == null) ? 0 : roleName_.hashCode());
        result = prime * result
                + ((startDate_ == null) ? 0 : startDate_.hashCode());
        result = prime * result + (int) (userId_ ^ (userId_ >>> 32));
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final ActivityMember other = (ActivityMember) obj;
        if (activityId_ != other.activityId_)
            return false;
        if (deleteFlag_ == null) {
            if (other.deleteFlag_ != null)
                return false;
        } else if (!deleteFlag_.equals(other.deleteFlag_))
            return false;
        if (email_ == null) {
            if (other.email_ != null)
                return false;
        } else if (!email_.equals(other.email_))
            return false;
        if (endDate_ == null) {
            if (other.endDate_ != null)
                return false;
        } else if (!endDate_.equals(other.endDate_))
            return false;
        if (firstName_ == null) {
            if (other.firstName_ != null)
                return false;
        } else if (!firstName_.equals(other.firstName_))
            return false;
        if (id_ != other.id_)
            return false;
        if (lastName_ == null) {
            if (other.lastName_ != null)
                return false;
        } else if (!lastName_.equals(other.lastName_))
            return false;
        if (middleName_ == null) {
            if (other.middleName_ != null)
                return false;
        } else if (!middleName_.equals(other.middleName_))
            return false;
        if (modifiedUserId_ != other.modifiedUserId_)
            return false;
        if (modified_ == null) {
            if (other.modified_ != null)
                return false;
        } else if (!modified_.equals(other.modified_))
            return false;
        if (photoImgUrl_ == null) {
            if (other.photoImgUrl_ != null)
                return false;
        } else if (!photoImgUrl_.equals(other.photoImgUrl_))
            return false;
        if (registered_ == null) {
            if (other.registered_ != null)
                return false;
        } else if (!registered_.equals(other.registered_))
            return false;
        if (roleId_ != other.roleId_)
            return false;
        if (roleName_ == null) {
            if (other.roleName_ != null)
                return false;
        } else if (!roleName_.equals(other.roleName_))
            return false;
        if (startDate_ == null) {
            if (other.startDate_ != null)
                return false;
        } else if (!startDate_.equals(other.startDate_))
            return false;
        if (userId_ != other.userId_)
            return false;
        return true;
    }
    
}
