package org.seasar.tugboat.gtd.contents.activity.entity;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.pager.DefaultPagerCondition;

/**
 * activity page condition.
 * 
 * @author yosuke
 * 
 */
public class ActivityPageCondition extends DefaultPagerCondition {
    private static final long serialVersionUID = 1813923509315731428L;
    
    /* activity id */
    private long activityId_;

    public long getActivityId() {
        return activityId_;
    }

    public void setActivityId(long activityId) {
        this.activityId_ = activityId;
    }

    /* user id */
    private long userId_;

    public long getUserId() {
        return userId_;
    }

    public void setUserId(long userId) {
        this.userId_ = userId;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (activityId_ ^ (activityId_ >>> 32));
        result = prime * result + (int) (userId_ ^ (userId_ >>> 32));
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final ActivityPageCondition other = (ActivityPageCondition) obj;
        if (activityId_ != other.activityId_)
            return false;
        if (userId_ != other.userId_)
            return false;
        return true;
    }
    
}
