/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.common.dxo;

import org.seasar.tugboat.gtd.contents.common.dto.PreferenceDto;
import org.seasar.tugboat.gtd.contents.common.dto.VersionDto;
import org.seasar.tugboat.gtd.contents.common.entity.Preference;
import org.seasar.tugboat.gtd.contents.common.entity.Version;

/**
 * common dxo.
 * 
 * @author yosuke
 * 
 */
public interface CommonDxo {
    /**
     * convert calendar preference to calendar preference dto.
     * 
     * @param preference
     * @return
     */
    PreferenceDto convertCalendarPreferenceDto(Preference preference);
    
    /**
     * convert version to version dto.
     * 
     * @param version
     * @return
     */
    VersionDto convertVersionDto(Version version);
}
