/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.common.dxo.impl;

import org.apache.commons.beanutils.BeanUtils;
import org.seasar.tugboat.gtd.container.exception.SystemUnexpectedRuntimeException;
import org.seasar.tugboat.gtd.contents.common.dto.RoleDto;
import org.seasar.tugboat.gtd.contents.common.dxo.RoleDxo;
import org.seasar.tugboat.gtd.contents.common.entity.Role;

/**
 * Role dxp implement.
 * @author yosuke
 *
 */
public class RoleDxoImpl implements RoleDxo{

    /*
     * (non-Javadoc)
     * @see org.seasar.tugboat.gtd.contents.common.dxo.RoleDxo#convertRole(
     *   org.seasar.tugboat.gtd.contents.common.dto.RoleDto)
     */
    public Role convertRole(RoleDto roleDto) {
        if (roleDto == null) return null;
        try {
            Role role = new Role();
            BeanUtils.copyProperties(role, roleDto);
            return role;
        } catch (Exception e) {
            throw new SystemUnexpectedRuntimeException(e);
        }
     }

    /*
     * (non-Javadoc)
     * @see org.seasar.tugboat.gtd.contents.common.dxo.RoleDxo#convertRoleDto(
     *   org.seasar.tugboat.gtd.contents.common.entity.Role)
     */
    public RoleDto convertRoleDto(Role role) {
        if (role == null) return null;
        try {
            RoleDto roleDto = new RoleDto();
            BeanUtils.copyProperties(roleDto, role);
            return roleDto;
        } catch (Exception e) {
            throw new SystemUnexpectedRuntimeException(e);
        }
    }

}
