/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.common.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Column;

/**
 * version
 * 
 * @author yousuke
 *
 */
public class Version implements Serializable {
    private static final long serialVersionUID = -1693727123618646458L;

    /* id */
    private long id_;
    
    @Column("id")
    public long getId() {
        return id_;
    }
    public void setId(long id) {
        this.id_ = id;
    }
    
    /* majour num */
    private int majourNum_;
    
    @Column("majour_num")
    public int getMajourNum() {
        return majourNum_;
    }
    public void setMajourNum(int majourNum) {
        this.majourNum_ = majourNum;
    }
    
    /* minor num */
    private int minorNum_;
    
    @Column("minor_num")
    public int getMinorNum() {
        return minorNum_;
    }
    public void setMinorNum(int minorNum) {
        this.minorNum_ = minorNum;
    }
    
    /* maintenance num */
    private int maintenanceNum_;
    
    @Column("maintenance_num")
    public int getMaintenanceNum() {
        return maintenanceNum_;
    }
    public void setMaintenanceNum(int maintenanceNum) {
        this.maintenanceNum_ = maintenanceNum;
    }
    
    /* maintenance sub */
    private int maintenanceSub_;
    
    @Column("maintenance_sub")
    public int getMaintenanceSub() {
        return maintenanceSub_;
    }
    public void setMaintenanceSub(int maintenanceSub) {
        this.maintenanceSub_ = maintenanceSub;
    }
    
    /* registered */
    private String registered_;
    
    @Column("registered")
    public String getRegistered() {
        return registered_;
    }
    public void setRegistered(String registered) {
        this.registered_ = registered;
    }
    
    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result + maintenanceNum_;
        result = prime * result + maintenanceSub_;
        result = prime * result + majourNum_;
        result = prime * result + minorNum_;
        result = prime * result
                + ((registered_ == null) ? 0 : registered_.hashCode());
        return result;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final Version other = (Version) obj;
        if (id_ != other.id_)
            return false;
        if (maintenanceNum_ != other.maintenanceNum_)
            return false;
        if (maintenanceSub_ != other.maintenanceSub_)
            return false;
        if (majourNum_ != other.majourNum_)
            return false;
        if (minorNum_ != other.minorNum_)
            return false;
        if (registered_ == null) {
            if (other.registered_ != null)
                return false;
        } else if (!registered_.equals(other.registered_))
            return false;
        return true;
    }
}
