/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.login.dao;

import org.seasar.dao.annotation.tiger.Arguments;
import org.seasar.dao.annotation.tiger.S2Dao;
import org.seasar.tugboat.gtd.container.entity.WebServiceSecurity;

/**
 * web service securities dao.
 * 
 * @author yosuke
 * 
 */
@S2Dao(bean = WebServiceSecurity.class)
public interface WebServiceSecuritiesDao {

    /**
     * insert.
     * 
     * @param entity
     * @return
     */
    @Arguments("entity")
    int insert(WebServiceSecurity entity);

    /**
     * delete.
     * 
     * @param createdAt
     * @return
     */
    @Arguments("createdAt")
    int delete(String createdAt);

    /**
     * find by nonce and created.
     * 
     * @param nonce
     * @param created
     * @return
     */
    @Arguments( { "nonce", "created" })
    WebServiceSecurity findByNonceAndCreated(String nonce, String created);
}
