/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.login.page.impl;

import org.seasar.framework.container.S2Container;
import org.seasar.framework.container.factory.SingletonS2ContainerFactory;
import org.seasar.framework.log.Logger;
import org.seasar.tugboat.gtd.contents.login.page.LoginAction;
import org.seasar.tugboat.gtd.contents.user.dto.UserDto;

/**
 * Login action impl
 * 
 * @author yousuke.hara
 * 
 */
public class LoginActionImpl implements LoginAction {
    /* Logger */
    Logger logger_ = Logger.getLogger(LoginActionImpl.class);

    public LoginActionImpl() {
        super();
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.contents.login.action.LoginAction#initialize()
     */
    public String initialize() {
        return null;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.contents.login.page.LoginAction#logout()
     */
    public String logout() {
        S2Container container = SingletonS2ContainerFactory.getContainer();
        UserDto sessionLoginUser = 
        	(UserDto) container.getComponent(UserDto.LOGIN_USER_SESSION_ATTRIBUTE_NAME);

        sessionLoginUser.setUserId(0);
        return null;
    }
}
