/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.login.service.impl;

import org.seasar.framework.log.Logger;
import org.seasar.tugboat.gtd.contents.login.service.LoginService;
import org.seasar.tugboat.gtd.contents.user.dao.UsersDao;
import org.seasar.tugboat.gtd.contents.user.dto.UserDto;
import org.seasar.tugboat.gtd.contents.user.dxo.UserDxo;
import org.seasar.tugboat.gtd.contents.user.entity.User;

/**
 * Login Service implement.
 * 
 * @author yousuke.hara
 * 
 */
public class LoginServiceImpl implements LoginService {
    /* LOGGER */
    Logger logger_ = Logger.getLogger(LoginServiceImpl.class);

    public LoginServiceImpl() {
        super();
    }

    /* users dao */
    UsersDao usersDao_;
    
    public void setUsersDao(UsersDao usersDao) {
        this.usersDao_ = usersDao;
    }

    /* user dxo */
    UserDxo userDxo_;
    
    public void setUserDxo(UserDxo userDxo) {
        this.userDxo_ = userDxo;
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.contents.login.service.LoginService#login(org.seasar.tugboat.gtd.contents.login.dto.LoginDto)
     */
    public UserDto login(String loginId, String password) {
        User user =this.usersDao_.findUserByLoginIdAndPassword(loginId, password); 
        return userDxo_.convertUserDto(user);
    }
    
    /*
     * (non-Javadoc)
     * @see org.seasar.tugboat.gtd.contents.login.service.LoginService#findByLoginId(java.lang.String)
     */
    public UserDto findByLoginId(String loginId) {
    	User user = this.usersDao_.findByLoginId(loginId);
    	return userDxo_.convertUserDto(user);
    }
}
