--
-- find meeting basic.
--
SELECT
    A.ID
   ,A.ACTIVITY_ID
   ,C.COLOR
   ,V.NAME AS ACTIVITY_NAME
   ,A.STATUS_ID
   ,A.TITLE
   ,B.BODY
   ,A.START_DATE
   ,G1.ACTIVE_AGENDAS
   ,G2.DONE_AGENDAS
   ,A.POSTED_USER_ID
   ,U.FIRST_NAME
   ,U.LAST_NAME
   ,A.DEL_FLAG
   ,A.REGISTERED
   ,A.MODIFIED
FROM
   meeting_basics A 
   INNER JOIN meeting_basic_bodies B ON A.ID = B.BASIC_ID
   LEFT JOIN (
       SELECT
           COUNT(*) AS ACTIVE_AGENDAS
          ,M.BASIC_ID
       FROM
           meeting_relations M
           INNER JOIN meeting_agendas G ON M.AGENDA_ID = G.ID
       WHERE
           M.BASIC_ID = /*basicId*/1
       AND G.STATUS <> '3'
       AND G.DEL_FLAG = '0'
       GROUP BY
           M.BASIC_ID
   ) G1 ON A.ID = G1.BASIC_ID
   LEFT JOIN (
       SELECT
           COUNT(*) AS DONE_AGENDAS
          ,M.BASIC_ID
       FROM
           meeting_relations M
           INNER JOIN meeting_agendas G ON M.AGENDA_ID = G.ID
       WHERE
           M.BASIC_ID = /*basicId*/1
       AND G.STATUS = '3'
       AND G.DEL_FLAG = '0'
       GROUP BY
           M.BASIC_ID
   ) G2 ON A.ID = G2.BASIC_ID
   INNER JOIN users U                ON A.POSTED_USER_ID = U.ID
   INNER JOIN activity_relations R   ON R.USER_ID        = /*userId*/1 
                                    AND A.ACTIVITY_ID    = R.ACTIVITY_ID
   INNER JOIN activity_colors C      ON R.COLOR_ID       = C.ID
   INNER JOIN activities V           ON A.ACTIVITY_ID    = V.ID
WHERE
   A.ID=/*basicId*/1