--
-- find default meeting count by folder.
--
SELECT
    L.ROWS1 AS LIBRARY_COUNT
   ,A.ROWS2 AS ARCHIVES_COUNT
FROM
    (
    SELECT 
        COUNT(*) AS ROWS1
    FROM (
        SELECT DISTINCT B.ID
        FROM meeting_basics B
        INNER JOIN activity_members M1 ON B.ACTIVITY_ID = M1.ACTIVITY_ID
                                      AND M1.USER_ID=/*condition.userId*/1
        WHERE 
            B.DEL_FLAG = '0'
        AND B.STATUS_ID IN (1,2)
        ) AS B1
    ) L
   ,( 
    SELECT 
        COUNT(*) AS ROWS2
    FROM (
        SELECT DISTINCT 
            B.ID
        FROM meeting_basics B
        INNER JOIN activity_members M2 ON B.ACTIVITY_ID = M2.ACTIVITY_ID
                                      AND M2.USER_ID = /*condition.userId*/1
        WHERE 
            B.DEL_FLAG = '0'
        AND B.STATUS_ID IN (3)
    ) AS B2
  ) A