/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.meeting.dto;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.tugboat.gtd.contents.meeting.entity.MeetingAgendaDiscussion;

/**
 * meeting agenda discussion dto
 * 
 * 
 */
public class MeetingAgendaDiscussionDto extends MeetingAgendaDiscussion implements Serializable {
    private static final long serialVersionUID = -5925198131635450885L;
    
    /* physical id */
    private long pid_;

    public long getPid() {
        return pid_;
    }

    public void setPid(long pid) {
        this.pid_ = pid;
    }

    /* body converted textile */
    private String bodyConvertedTextile_;

    public String getBodyConvertedTextile() {
        return bodyConvertedTextile_;
    }

    public void setBodyConvertedTextile(String bodyConvertedTextile) {
        this.bodyConvertedTextile_ = bodyConvertedTextile;
    }

    /* task description textile */
    private String taskDescriptionTextile_;

    public String getTaskDescriptionTextile() {
        return taskDescriptionTextile_;
    }

    public void setTaskDescriptionTextile(String taskDescriptionTextile) {
        this.taskDescriptionTextile_ = taskDescriptionTextile;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime
                * result
                + ((bodyConvertedTextile_ == null) ? 0 : bodyConvertedTextile_
                        .hashCode());
        result = prime * result + (int) (pid_ ^ (pid_ >>> 32));
        result = prime
                * result
                + ((taskDescriptionTextile_ == null) ? 0
                        : taskDescriptionTextile_.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!super.equals(obj))
            return false;
        if (getClass() != obj.getClass())
            return false;
        final MeetingAgendaDiscussionDto other = (MeetingAgendaDiscussionDto) obj;
        if (bodyConvertedTextile_ == null) {
            if (other.bodyConvertedTextile_ != null)
                return false;
        } else if (!bodyConvertedTextile_.equals(other.bodyConvertedTextile_))
            return false;
        if (pid_ != other.pid_)
            return false;
        if (taskDescriptionTextile_ == null) {
            if (other.taskDescriptionTextile_ != null)
                return false;
        } else if (!taskDescriptionTextile_
                .equals(other.taskDescriptionTextile_))
            return false;
        return true;
    }
    
}
