/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.meeting.dto;

import java.io.Serializable;
import java.util.Arrays;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.tugboat.gtd.contents.meeting.entity.MeetingBasic;

/**
 * meeting basic dto
 * 
 * 
 */
public class MeetingBasicDto extends MeetingBasic implements Serializable {
    private static final long serialVersionUID = -8225809649763164495L;
    
    /* body converted textile */
    private String bodyConvertedTextile_;

    public String getBodyConvertedTextile() {
        return bodyConvertedTextile_;
    }

    public void setBodyConvertedTextile(String bodyConvertedTextile) {
        this.bodyConvertedTextile_ = bodyConvertedTextile;
    }

    /* user id. */
    private long userId_;

    public long getUserId() {
        return userId_;
    }

    public void setUserId(long userId) {
        this.userId_ = userId;
    }

    /* query status ids. */
    private Integer[] queryStatusIds_;

    public Integer[] getQueryStatusIds() {
        return queryStatusIds_;
    }

    public void setQueryStatusIds(Integer[] queryStatusIds) {
        this.queryStatusIds_ = queryStatusIds;
    }

    /* query activity ids. */
    private Long[] queryActivityIds_;

    public Long[] getQueryActivityIds() {
        return queryActivityIds_;
    }

    public void setQueryActivityIds(Long[] queryActivityIds) {
        this.queryActivityIds_ = queryActivityIds;
    }

    /* query register ids. */
    private Integer[] queryRegisterIds_;

    public Integer[] getQueryRegisterIds() {
        return queryRegisterIds_;
    }

    public void setQueryRegisterIds(Integer[] queryRegisterIds) {
        this.queryRegisterIds_ = queryRegisterIds;
    }

    /* meeting links. */
    private MeetingRelatedTaskDto[] meetingLinks_;

    public MeetingRelatedTaskDto[] getMeetingLinks() {
        return meetingLinks_;
    }

    public void setMeetingLinks(MeetingRelatedTaskDto[] meetingLinks) {
        this.meetingLinks_ = meetingLinks;
    }

    /* offset */
    private int offset_;

    public int getOffset() {
        return offset_;
    }

    public void setOffset(int offset) {
        this.offset_ = offset;
    }

    /* limit */
    private int limit_;

    public int getLimit() {
        return limit_;
    }

    public void setLimit(int limit) {
        this.limit_ = limit;
    }

    /* Registered formated */
    private String registeredFormated_;

    public String getRegisteredFormated() {
        return registeredFormated_;
    }

    public void setRegisteredFormated(String registeredFormated) {
        this.registeredFormated_ = registeredFormated;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime
                * result
                + ((bodyConvertedTextile_ == null) ? 0 : bodyConvertedTextile_
                        .hashCode());
        result = prime * result + limit_;
        result = prime * result + Arrays.hashCode(meetingLinks_);
        result = prime * result + offset_;
        result = prime * result + Arrays.hashCode(queryActivityIds_);
        result = prime * result + Arrays.hashCode(queryRegisterIds_);
        result = prime * result + Arrays.hashCode(queryStatusIds_);
        result = prime
                * result
                + ((registeredFormated_ == null) ? 0 : registeredFormated_
                        .hashCode());
        result = prime * result + (int) (userId_ ^ (userId_ >>> 32));
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!super.equals(obj))
            return false;
        if (getClass() != obj.getClass())
            return false;
        final MeetingBasicDto other = (MeetingBasicDto) obj;
        if (bodyConvertedTextile_ == null) {
            if (other.bodyConvertedTextile_ != null)
                return false;
        } else if (!bodyConvertedTextile_.equals(other.bodyConvertedTextile_))
            return false;
        if (limit_ != other.limit_)
            return false;
        if (!Arrays.equals(meetingLinks_, other.meetingLinks_))
            return false;
        if (offset_ != other.offset_)
            return false;
        if (!Arrays.equals(queryActivityIds_, other.queryActivityIds_))
            return false;
        if (!Arrays.equals(queryRegisterIds_, other.queryRegisterIds_))
            return false;
        if (!Arrays.equals(queryStatusIds_, other.queryStatusIds_))
            return false;
        if (registeredFormated_ == null) {
            if (other.registeredFormated_ != null)
                return false;
        } else if (!registeredFormated_.equals(other.registeredFormated_))
            return false;
        if (userId_ != other.userId_)
            return false;
        return true;
    }
    
}
