/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.meeting.dto;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * meeting link dto
 * 
 * 
 */
public class MeetingRelatedTaskDto implements Serializable {
    private static final long serialVersionUID = -6114375444970298489L;
    
    /* id */
    private long id_;

    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* type */
    private int type_;

    public int getType() {
        return type_;
    }

    public void setType(int type) {
        this.type_ = type;
    }

    /* activity id */
    private long activityId_;

    public long getActivityId() {
        return activityId_;
    }

    public void setActivityId(long activityId) {
        this.activityId_ = activityId;
    }

    /* activity name */
    private String activityName_;

    public String getActivityName() {
        return activityName_;
    }

    public void setActivityName(String activityName) {
        this.activityName_ = activityName;
    }

    /* activity color */
    private String activityColor_;

    public String getActivityColor() {
        return activityColor_;
    }

    public void setActivityColor(String activityColor) {
        this.activityColor_ = activityColor;
    }

    /* status id */
    private int statusId_;

    public int getStatusId() {
        return statusId_;
    }

    public void setStatusId(int statusId) {
        this.statusId_ = statusId;
    }

    /* class Id */
    private int classId_;

    public int getClassId() {
        return classId_;
    }

    public void setClassid(int classId) {
        this.classId_ = classId;
    }

    /* title */
    private String title_;

    public String getTitle() {
        return title_;
    }

    public void setTitle(String title) {
        this.title_ = title;
    }

    /* person in charge id */
    private long personId_;

    public long getPersonId() {
        return personId_;
    }

    public void setPersonId(long personId) {
        this.personId_ = personId;
    }

    /* person in charge first name */
    private String personFirstName_;

    public String getPersonFirstName() {
        return personFirstName_;
    }

    public void setPersonFirstName(String personFirstName) {
        this.personFirstName_ = personFirstName;
    }

    /* person in charge last name */
    private String personLastName_;

    public String getPersonLastName() {
        return personLastName_;
    }

    public void setPersonLastName(String personLastName) {
        this.personLastName_ = personLastName;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result
                + ((activityColor_ == null) ? 0 : activityColor_.hashCode());
        result = prime * result + (int) (activityId_ ^ (activityId_ >>> 32));
        result = prime * result
                + ((activityName_ == null) ? 0 : activityName_.hashCode());
        result = prime * result + classId_;
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime
                * result
                + ((personFirstName_ == null) ? 0 : personFirstName_.hashCode());
        result = prime * result + (int) (personId_ ^ (personId_ >>> 32));
        result = prime * result
                + ((personLastName_ == null) ? 0 : personLastName_.hashCode());
        result = prime * result + statusId_;
        result = prime * result + ((title_ == null) ? 0 : title_.hashCode());
        result = prime * result + type_;
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final MeetingRelatedTaskDto other = (MeetingRelatedTaskDto) obj;
        if (activityColor_ == null) {
            if (other.activityColor_ != null)
                return false;
        } else if (!activityColor_.equals(other.activityColor_))
            return false;
        if (activityId_ != other.activityId_)
            return false;
        if (activityName_ == null) {
            if (other.activityName_ != null)
                return false;
        } else if (!activityName_.equals(other.activityName_))
            return false;
        if (classId_ != other.classId_)
            return false;
        if (id_ != other.id_)
            return false;
        if (personFirstName_ == null) {
            if (other.personFirstName_ != null)
                return false;
        } else if (!personFirstName_.equals(other.personFirstName_))
            return false;
        if (personId_ != other.personId_)
            return false;
        if (personLastName_ == null) {
            if (other.personLastName_ != null)
                return false;
        } else if (!personLastName_.equals(other.personLastName_))
            return false;
        if (statusId_ != other.statusId_)
            return false;
        if (title_ == null) {
            if (other.title_ != null)
                return false;
        } else if (!title_.equals(other.title_))
            return false;
        if (type_ != other.type_)
            return false;
        return true;
    }
    
}
