/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.meeting.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * meeting agenda.
 * 
 * @author yousukehara
 * 
 */
@Bean(table = "meeting_agendas")
public class MeetingAgenda implements Serializable {
    private static final long serialVersionUID = -8710731519968739864L;
    
    public static final int STATUS_ACTIVE = 0;
    public static final int STATUS_PENDING = 1;
    public static final int STATUS_FREEZE = 2;
    public static final int STATUS_DONE = 3;
    
    /* meeting basic id */
    private long meetingBasicId_;

    @Column("BASIC_ID")
    public long getMeetingBasicId() {
        return meetingBasicId_;
    }

    public void setMeetingBasicId(long meetingBasicId) {
        this.meetingBasicId_ = meetingBasicId;
    }

    /* meeting agenda id */
    private long id_;

    @Column("ID")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* meeting agenda priority */
    private String priority_;

    @Column("PRIORITY")
    public String getPriority() {
        return priority_;
    }

    public void setPriority(String priority) {
        this.priority_ = priority;
    }
    
    /* meeting agenda status */
    private int status_;
    
    @Column("STATUS")
    public int getStatus() {
        return status_;
    }
    public void setStatus(int status) {
        this.status_ = status;
    }

    /* meeting agenda posted User Id */
    private long postedUserId_;

    @Column("POSTED_USER_ID")
    public long getPostedUserId() {
        return postedUserId_;
    }

    public void setPostedUserId(long postedUserId) {
        this.postedUserId_ = postedUserId;
    }

    /* meeting basic deleteFlag */
    private String deleteFlag_;

    @Column("DEL_FLAG")
    public String getDeleteFlag() {
        return deleteFlag_;
    }

    public void setDeleteFlag(String deleteFlag) {
        this.deleteFlag_ = deleteFlag;
    }

    /* meeting agenda registered */
    private String registered_;

    @Column("REGISTERED")
    public String getRegistered() {
        return registered_;
    }

    public void setRegistered(String registered) {
        this.registered_ = registered;
    }

    /* meeting agenda modified */
    private String modified_;

    @Column("MODIFIED")
    public String getModified() {
        return modified_;
    }

    public void setModified(String modified) {
        this.modified_ = modified;
    }

    /* meeting agenda modified user id */
    private long modifiedUserId_;

    @Column("MODIFIED_USER_ID")
    public long getModifiedUserId() {
        return modifiedUserId_;
    }

    public void setModifiedUserId(long modifiedUserId) {
        this.modifiedUserId_ = modifiedUserId;
    }

    /* meeting agenda bodies body */
    private String body_;

    @Column("BODY")
    public String getBody() {
        return body_;
    }

    public void setBody(String body) {
        this.body_ = body;
    }

    /* meeting agenda discussion id */
    private long discussionId_;

    @Column("AGENDA_DISCUSSION_ID")
    public long getDiscussionId() {
        return discussionId_;
    }

    public void setDiscussionId(long discussionId) {
        this.discussionId_ = discussionId;
    }

    /* meeting agenda discussion type */
    private String type_;

    @Column("TYPE")
    public String getType() {
        return type_;
    }

    public void setType(String type) {
        this.type_ = type;
    }

    /* meeting agenda discussion posted User Id */
    private long discussionPostedUserId_;

    @Column("AGENDA_DISCUSSION_POSTED_USER_ID")
    public long getDiscussionPostedUserId() {
        return discussionPostedUserId_;
    }

    public void setDiscussionPostedUserId(long discussionPostedUserId) {
        this.discussionPostedUserId_ = discussionPostedUserId;
    }

    /* meeting agenda discussion registered */
    private String discussionRegistered_;

    @Column("AGENDA_DISCUSSION_REGISTERED")
    public String getDiscussionRegistered() {
        return discussionRegistered_;
    }

    public void setDiscussionRegistered(String discussionRegistered) {
        this.discussionRegistered_ = discussionRegistered;
    }

    /* meeting agenda discussion modified */
    private String discussionModified_;

    @Column("AGENDA_DISCUSSION_MODIFIED")
    public String getDiscussionModified() {
        return discussionModified_;
    }

    public void setDiscussionModified(String discussionModified) {
        this.discussionModified_ = discussionModified;
    }

    /* meeting agenda discussion modified user id */
    private long discussionModifiedUserId_;

    @Column("AGENDA_DISCUSSION_MODIFIED_USER_ID")
    public long getDiscussionModifiedUserId() {
        return discussionModifiedUserId_;
    }

    public void setDiscussionModifiedUserId(long discussionModifiedUserId) {
        this.discussionModifiedUserId_ = discussionModifiedUserId;
    }

    /* meeting agenda discussion bodies body */
    private String discussionBody_;

    @Column("AGENDA_DISCUSSION_BODY")
    public String getDiscussionBody() {
        return discussionBody_;
    }

    public void setDiscussionBody(String discussionBody) {
        this.discussionBody_ = discussionBody;
    }

    /* meeting agenda discussion first name */
    private String discussionFirstName_;

    @Column("AGENDA_DISCUSSION_FIRST_NAME")
    public String getDiscussionFirstName() {
        return discussionFirstName_;
    }

    public void setDiscussionFirstName(String discussionFirstName) {
        this.discussionFirstName_ = discussionFirstName;
    }

    /* meeting agenda discussion last name */
    private String discussionLastName_;

    @Column("AGENDA_DISCUSSION_LAST_NAME")
    public String getDiscussionLastName() {
        return discussionLastName_;
    }

    public void setDiscussionLastName(String discussionLastName) {
        this.discussionLastName_ = discussionLastName;
    }

    /* user id */
    private String firstName_;

    @Column("FIRST_NAME")
    public String getFirstName() {
        return firstName_;
    }

    public void setFirstName(String firstName) {
        this.firstName_ = firstName;
    }

    /* user last name */
    private String lastName_;

    @Column("LAST_NAME")
    public String getLastName() {
        return lastName_;
    }

    public void setLastName(String lastName) {
        this.lastName_ = lastName;
    }

    /* activity id */
    private long activityId_;

    @Column("ACTIVITY_ID")
    public long getActivityId() {
        return activityId_;
    }

    public void setActivityId(long activityId) {
        this.activityId_ = activityId;
    }

    /* task id */
    private long taskId_;

    @Column("TASK_ID")
    public long getTaskId() {
        return taskId_;
    }

    public void setTaskId(long taskId) {
        this.taskId_ = taskId;
    }

    /* task title */
    private String title_;

    @Column("TASK_TITLE")
    public String getTaskTitle() {
        return title_;
    }

    public void setTaskTitle(String title) {
        this.title_ = title;
    }

    /* color color */
    private String colorValue_;

    @Column("COLOR_VALUE")
    public String getColorValue() {
        return colorValue_;
    }

    public void setColorValue(String colorValue) {
        this.colorValue_ = colorValue;
    }

    /* task start date */
    private String taskDeadLine_;

    @Column("TASK_DEAD_LINE")
    public String getTaskDeadLine() {
        return taskDeadLine_;
    }

    public void setTaskDeadLine(String taskDeadLine) {
        this.taskDeadLine_ = taskDeadLine;
    }

    /* task description */
    private String taskDescription_;

    @Column("TASK_DESCRIPTION")
    public String getTaskDescription() {
        return taskDescription_;
    }

    public void setTaskDescription(String taskDescription) {
        this.taskDescription_ = taskDescription;
    }

    /* task person id */
    private long taskPersonId_;

    @Column("TASK_PERSON_ID")
    public long getTaskPersonId() {
        return taskPersonId_;
    }

    public void setTaskPersonId(long taskPersonId) {
        this.taskPersonId_ = taskPersonId;
    }

    /* task person first name */
    private String taskPersonFirstName_;

    @Column("TASK_PERSON_FIRST_NAME")
    public String getTaskPersonFirstName() {
        return taskPersonFirstName_;
    }

    public void setTaskPersonFirstName(String taskPersonFirstName) {
        this.taskPersonFirstName_ = taskPersonFirstName;
    }

    /* task person last name */
    private String taskPersonLastName_;

    @Column("TASK_PERSON_LAST_NAME")
    public String getTaskPersonLastName() {
        return taskPersonLastName_;
    }

    public void setTaskPersonLastName(String taskPersonLastName) {
        this.taskPersonLastName_ = taskPersonLastName;
    }

    /* task status id */
    private int taskStatusId_;

    @Column("TASK_STATUS_ID")
    public int getTaskStatusId() {
        return taskStatusId_;
    }

    public void setTaskStatusId(int taskStatusId) {
        this.taskStatusId_ = taskStatusId;
    }

    /* task classification id */
    private int taskClassificationId_;

    @Column("TASK_CLASSIFICATION_ID")
    public int getTaskClassificationId() {
        return taskClassificationId_;
    }

    public void setTaskClassificationId(int taskClassificationId) {
        this.taskClassificationId_ = taskClassificationId;
    }

    /* task classification value */
    private String taskClassificationValue_;

    @Column("TASK_CLASSIFICATION_VALUE")
    public String getTaskClassificationValue() {
        return taskClassificationValue_;
    }

    public void setTaskClassificationValue(String taskClassificationValue) {
        this.taskClassificationValue_ = taskClassificationValue;
    }

    /* comment rows */
    private int commentRows_;

    @Column("COOMENT_ROWS")
    public int getCommentRows() {
        return commentRows_;
    }

    public void setCommentRows(int commentRows) {
        this.commentRows_ = commentRows;
    }

    /* task rows */
    private int taskRows_;

    @Column("TASK_ROWS")
    public int getTaskRows() {
        return taskRows_;
    }

    public void setTaskRows(int taskRows) {
        this.taskRows_ = taskRows;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (activityId_ ^ (activityId_ >>> 32));
        result = prime * result + ((body_ == null) ? 0 : body_.hashCode());
        result = prime * result
                + ((colorValue_ == null) ? 0 : colorValue_.hashCode());
        result = prime * result + commentRows_;
        result = prime * result
                + ((deleteFlag_ == null) ? 0 : deleteFlag_.hashCode());
        result = prime * result
                + ((discussionBody_ == null) ? 0 : discussionBody_.hashCode());
        result = prime
                * result
                + ((discussionFirstName_ == null) ? 0 : discussionFirstName_
                        .hashCode());
        result = prime * result
                + (int) (discussionId_ ^ (discussionId_ >>> 32));
        result = prime
                * result
                + ((discussionLastName_ == null) ? 0 : discussionLastName_
                        .hashCode());
        result = prime
                * result
                + (int) (discussionModifiedUserId_ ^ (discussionModifiedUserId_ >>> 32));
        result = prime
                * result
                + ((discussionModified_ == null) ? 0 : discussionModified_
                        .hashCode());
        result = prime
                * result
                + (int) (discussionPostedUserId_ ^ (discussionPostedUserId_ >>> 32));
        result = prime
                * result
                + ((discussionRegistered_ == null) ? 0 : discussionRegistered_
                        .hashCode());
        result = prime * result
                + ((firstName_ == null) ? 0 : firstName_.hashCode());
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result
                + ((lastName_ == null) ? 0 : lastName_.hashCode());
        result = prime * result
                + (int) (meetingBasicId_ ^ (meetingBasicId_ >>> 32));
        result = prime * result
                + (int) (modifiedUserId_ ^ (modifiedUserId_ >>> 32));
        result = prime * result
                + ((modified_ == null) ? 0 : modified_.hashCode());
        result = prime * result
                + (int) (postedUserId_ ^ (postedUserId_ >>> 32));
        result = prime * result
                + ((priority_ == null) ? 0 : priority_.hashCode());
        result = prime * result
                + ((registered_ == null) ? 0 : registered_.hashCode());
        result = prime * result + taskClassificationId_;
        result = prime
                * result
                + ((taskClassificationValue_ == null) ? 0
                        : taskClassificationValue_.hashCode());
        result = prime * result
                + ((taskDeadLine_ == null) ? 0 : taskDeadLine_.hashCode());
        result = prime
                * result
                + ((taskDescription_ == null) ? 0 : taskDescription_.hashCode());
        result = prime * result + (int) (taskId_ ^ (taskId_ >>> 32));
        result = prime
                * result
                + ((taskPersonFirstName_ == null) ? 0 : taskPersonFirstName_
                        .hashCode());
        result = prime * result
                + (int) (taskPersonId_ ^ (taskPersonId_ >>> 32));
        result = prime
                * result
                + ((taskPersonLastName_ == null) ? 0 : taskPersonLastName_
                        .hashCode());
        result = prime * result + taskRows_;
        result = prime * result + taskStatusId_;
        result = prime * result + ((title_ == null) ? 0 : title_.hashCode());
        result = prime * result + ((type_ == null) ? 0 : type_.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final MeetingAgenda other = (MeetingAgenda) obj;
        if (activityId_ != other.activityId_)
            return false;
        if (body_ == null) {
            if (other.body_ != null)
                return false;
        } else if (!body_.equals(other.body_))
            return false;
        if (colorValue_ == null) {
            if (other.colorValue_ != null)
                return false;
        } else if (!colorValue_.equals(other.colorValue_))
            return false;
        if (commentRows_ != other.commentRows_)
            return false;
        if (deleteFlag_ == null) {
            if (other.deleteFlag_ != null)
                return false;
        } else if (!deleteFlag_.equals(other.deleteFlag_))
            return false;
        if (discussionBody_ == null) {
            if (other.discussionBody_ != null)
                return false;
        } else if (!discussionBody_.equals(other.discussionBody_))
            return false;
        if (discussionFirstName_ == null) {
            if (other.discussionFirstName_ != null)
                return false;
        } else if (!discussionFirstName_.equals(other.discussionFirstName_))
            return false;
        if (discussionId_ != other.discussionId_)
            return false;
        if (discussionLastName_ == null) {
            if (other.discussionLastName_ != null)
                return false;
        } else if (!discussionLastName_.equals(other.discussionLastName_))
            return false;
        if (discussionModifiedUserId_ != other.discussionModifiedUserId_)
            return false;
        if (discussionModified_ == null) {
            if (other.discussionModified_ != null)
                return false;
        } else if (!discussionModified_.equals(other.discussionModified_))
            return false;
        if (discussionPostedUserId_ != other.discussionPostedUserId_)
            return false;
        if (discussionRegistered_ == null) {
            if (other.discussionRegistered_ != null)
                return false;
        } else if (!discussionRegistered_.equals(other.discussionRegistered_))
            return false;
        if (firstName_ == null) {
            if (other.firstName_ != null)
                return false;
        } else if (!firstName_.equals(other.firstName_))
            return false;
        if (id_ != other.id_)
            return false;
        if (lastName_ == null) {
            if (other.lastName_ != null)
                return false;
        } else if (!lastName_.equals(other.lastName_))
            return false;
        if (meetingBasicId_ != other.meetingBasicId_)
            return false;
        if (modifiedUserId_ != other.modifiedUserId_)
            return false;
        if (modified_ == null) {
            if (other.modified_ != null)
                return false;
        } else if (!modified_.equals(other.modified_))
            return false;
        if (postedUserId_ != other.postedUserId_)
            return false;
        if (priority_ == null) {
            if (other.priority_ != null)
                return false;
        } else if (!priority_.equals(other.priority_))
            return false;
        if (registered_ == null) {
            if (other.registered_ != null)
                return false;
        } else if (!registered_.equals(other.registered_))
            return false;
        if (taskClassificationId_ != other.taskClassificationId_)
            return false;
        if (taskClassificationValue_ == null) {
            if (other.taskClassificationValue_ != null)
                return false;
        } else if (!taskClassificationValue_
                .equals(other.taskClassificationValue_))
            return false;
        if (taskDeadLine_ == null) {
            if (other.taskDeadLine_ != null)
                return false;
        } else if (!taskDeadLine_.equals(other.taskDeadLine_))
            return false;
        if (taskDescription_ == null) {
            if (other.taskDescription_ != null)
                return false;
        } else if (!taskDescription_.equals(other.taskDescription_))
            return false;
        if (taskId_ != other.taskId_)
            return false;
        if (taskPersonFirstName_ == null) {
            if (other.taskPersonFirstName_ != null)
                return false;
        } else if (!taskPersonFirstName_.equals(other.taskPersonFirstName_))
            return false;
        if (taskPersonId_ != other.taskPersonId_)
            return false;
        if (taskPersonLastName_ == null) {
            if (other.taskPersonLastName_ != null)
                return false;
        } else if (!taskPersonLastName_.equals(other.taskPersonLastName_))
            return false;
        if (taskRows_ != other.taskRows_)
            return false;
        if (taskStatusId_ != other.taskStatusId_)
            return false;
        if (title_ == null) {
            if (other.title_ != null)
                return false;
        } else if (!title_.equals(other.title_))
            return false;
        if (type_ == null) {
            if (other.type_ != null)
                return false;
        } else if (!type_.equals(other.type_))
            return false;
        return true;
    }

}
