/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.meeting.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * meeting agenda discussion body
 * 
 * @author naoya.saito
 * 
 */
@Bean(table = "meeting_agenda_discussion_bodies")
public class MeetingAgendaDiscussionBody implements Serializable {
    private static final long serialVersionUID = 8506837398587904576L;
    
    /* meeting agenda discussion body id */
    private long id_;

    @Column("ID")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* meeting agenda discussion body agenda id */
    private long agendaId_;

    @Column("AGENDA_ID")
    public long getAgendaId() {
        return agendaId_;
    }

    public void setAgendaId(long agendaId) {
        this.agendaId_ = agendaId;
    }

    /* meeting agenda discussion body discussion id */
    private long discussionId_;

    @Column("DISCUSSION_ID")
    public long getDiscussionId() {
        return discussionId_;
    }

    public void setDiscussionId(long discussionId) {
        this.discussionId_ = discussionId;
    }

    /* meeting agenda discussion body rev */
    private int rev_;

    @Column("REV")
    public int getRev() {
        return rev_;
    }

    public void setRev(int rev) {
        this.rev_ = rev;
    }

    /* meeting agenda discussion body body */
    private String body_;

    @Column("BODY")
    public String getBody() {
        return body_;
    }

    public void setBody(String body) {
        this.body_ = body;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (agendaId_ ^ (agendaId_ >>> 32));
        result = prime * result + ((body_ == null) ? 0 : body_.hashCode());
        result = prime * result
                + (int) (discussionId_ ^ (discussionId_ >>> 32));
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result + rev_;
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final MeetingAgendaDiscussionBody other = (MeetingAgendaDiscussionBody) obj;
        if (agendaId_ != other.agendaId_)
            return false;
        if (body_ == null) {
            if (other.body_ != null)
                return false;
        } else if (!body_.equals(other.body_))
            return false;
        if (discussionId_ != other.discussionId_)
            return false;
        if (id_ != other.id_)
            return false;
        if (rev_ != other.rev_)
            return false;
        return true;
    }
    
}
