/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.meeting.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * meeting basic.
 * 
 * @author naoya.saito
 * 
 */
@Bean(table = "meeting_basics")
public class MeetingBasic implements Serializable {
    private static final long serialVersionUID = 1237501309262249718L;

    public static final int STATUS_NEW = 1;

    public static final int STATUS_OPEN = 2;

    public static final int STATIS_CLOSE = 3;

    /* row count */
    private int rowCount_;

    @Column("ROW_COUNT")
    public int getRowCount() {
        return rowCount_;
    }

    public void setRowCount(int rowCount) {
        this.rowCount_ = rowCount;
    }

    /* library count */
    private int libraryCount_;

    @Column("LIBRARY_COUNT")
    public int getLibraryCount() {
        return libraryCount_;
    }

    public void setLibraryCount(int libraryCount) {
        this.libraryCount_ = libraryCount;
    }

    /* archives count */
    private int archivesCount_;

    @Column("ARCHIVES_COUNT")
    public int getArchivesCount() {
        return archivesCount_;
    }

    public void setArchivesCount(int archivesCount) {
        this.archivesCount_ = archivesCount;
    }

    /* meeting basic id */
    private long id_;

    @Column("ID")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* meeting basic activity id */
    private long activityId_;

    @Column("ACTIVITY_ID")
    public long getActivityId() {
        return activityId_;
    }

    public void setActivityId(long activityId) {
        this.activityId_ = activityId;
    }

    /* activity name */
    private String activityName_;

    @Column("ACTIVITY_NAME")
    public String getActivityName() {
        return activityName_;
    }

    public void setActivityName(String activityName) {
        this.activityName_ = activityName;
    }

    /* color color */
    private String color_;

    @Column("COLOR")
    public String getColor() {
        return color_;
    }

    public void setColor(String color) {
        this.color_ = color;
    }

    /* meeting basic status id */
    private int statusId_;

    @Column("STATUS_ID")
    public int getStatusId() {
        return statusId_;
    }

    public void setStatusId(int statusId) {
        this.statusId_ = statusId;
    }

    /* meeting basic title */
    private String title_;

    @Column("TITLE")
    public String getTitle() {
        return title_;
    }

    public void setTitle(String title) {
        this.title_ = title;
    }

    /* meeting basic start Date */
    private String startDate_;

    @Column("START_DATE")
    public String getStartDate() {
        return startDate_;
    }

    public void setStartDate(String startDate) {
        this.startDate_ = startDate;
    }

    /* meeting basic posted User Id */
    private long postedUserId_;

    @Column("POSTED_USER_ID")
    public long getPostedUserId() {
        return postedUserId_;
    }

    public void setPostedUserId(long postedUserId) {
        this.postedUserId_ = postedUserId;
    }

    /* meeting basic bodies body */
    private String body_;

    @Column("BODY")
    public String getBody() {
        return body_;
    }

    public void setBody(String body) {
        this.body_ = body;
    }

    /* user id */
    private String firstName_;

    @Column("FIRST_NAME")
    public String getFirstName() {
        return firstName_;
    }

    public void setFirstName(String firstName) {
        this.firstName_ = firstName;
    }

    /* user last name */
    private String lastName_;

    @Column("LAST_NAME")
    public String getLastName() {
        return lastName_;
    }

    public void setLastName(String lastName) {
        this.lastName_ = lastName;
    }

    /* task id */
    private long taskId_;

    @Column("TASK_ID")
    public long getTaskId() {
        return taskId_;
    }

    public void setTaskId(long taskId) {
        this.taskId_ = taskId;
    }

    /* task title */
    private String taskTitle_;

    @Column("TASK_TITLE")
    public String getTaskTitle() {
        return taskTitle_;
    }

    public void setTaskTitle(String taskTitle) {
        this.taskTitle_ = taskTitle;
    }

    /* task status id */
    private int taskStatusId_;

    @Column("TASK_STATUS_ID")
    public int getTaskStatusId() {
        return taskStatusId_;
    }

    public void setTaskStatusId(int taskStatusId) {
        this.taskStatusId_ = taskStatusId;
    }

    /* task class id */
    private int taskClassId_;

    @Column("TASK_CLASS_ID")
    public int getTaskClassId() {
        return taskClassId_;
    }

    public void setTaskClassId(int taskClassId) {
        this.taskClassId_ = taskClassId;
    }

    /* task person in charge id */
    private long taskPersonId_;

    @Column("TASK_PERSON_ID")
    public long getTaskPersonId() {
        return taskPersonId_;
    }

    public void setTaskPersonId(long taskPersonId) {
        this.taskPersonId_ = taskPersonId;
    }

    /* task person in charge first name */
    private String taskPersonFirstName_;

    @Column("TASK_PERSON_FNAME")
    public String getTaskPersonFirstName() {
        return taskPersonFirstName_;
    }

    public void setTaskPersonFirstName(String taskPersonFirstName) {
        this.taskPersonFirstName_ = taskPersonFirstName;
    }

    /* task person in charge last name */
    private String taskPersonLastName_;

    @Column("TASK_PERSON_LNAME")
    public String getTaskPersonLastName() {
        return taskPersonLastName_;
    }

    public void setTaskPersonLastName(String taskPersonLastName) {
        this.taskPersonLastName_ = taskPersonLastName;
    }

    /* meeting basic deleteFlag */
    private String deleteFlag_;

    @Column("DEL_FLAG")
    public String getDeleteFlag() {
        return deleteFlag_;
    }

    public void setDeleteFlag(String deleteFlag) {
        this.deleteFlag_ = deleteFlag;
    }

    /* meeting basic registered */
    private String registered_;

    @Column("REGISTERED")
    public String getRegistered() {
        return registered_;
    }

    public void setRegistered(String registered) {
        this.registered_ = registered;
    }

    /* meeting basic modified */
    private String modified_;

    @Column("MODIFIED")
    public String getModified() {
        return modified_;
    }

    public void setModified(String modified) {
        this.modified_ = modified;
    }

    /* active agendas */
    private int activeAgendas_;
    
    @Column("ACTIVE_AGENDAS")
    public int getActiveAgendas() {
        return activeAgendas_;
    }
    public void setActiveAgendas(int activeAgendas) {
        this.activeAgendas_ = activeAgendas;
    }
    
    /* done agendas */
    private int doneAgendas_;
    
    @Column("DONE_AGENDAS")
    public int getDoneAgendas() {
        return doneAgendas_;
    }
    public void setDoneAgendas(int doneAgendas) {
        this.doneAgendas_ = doneAgendas;
    }
    
    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + activeAgendas_;
        result = prime * result + (int) (activityId_ ^ (activityId_ >>> 32));
        result = prime * result
                + ((activityName_ == null) ? 0 : activityName_.hashCode());
        result = prime * result + archivesCount_;
        result = prime * result + ((body_ == null) ? 0 : body_.hashCode());
        result = prime * result + ((color_ == null) ? 0 : color_.hashCode());
        result = prime * result
                + ((deleteFlag_ == null) ? 0 : deleteFlag_.hashCode());
        result = prime * result + doneAgendas_;
        result = prime * result
                + ((firstName_ == null) ? 0 : firstName_.hashCode());
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result
                + ((lastName_ == null) ? 0 : lastName_.hashCode());
        result = prime * result + libraryCount_;
        result = prime * result
                + ((modified_ == null) ? 0 : modified_.hashCode());
        result = prime * result
                + (int) (postedUserId_ ^ (postedUserId_ >>> 32));
        result = prime * result
                + ((registered_ == null) ? 0 : registered_.hashCode());
        result = prime * result + rowCount_;
        result = prime * result
                + ((startDate_ == null) ? 0 : startDate_.hashCode());
        result = prime * result + statusId_;
        result = prime * result + taskClassId_;
        result = prime * result + (int) (taskId_ ^ (taskId_ >>> 32));
        result = prime
                * result
                + ((taskPersonFirstName_ == null) ? 0 : taskPersonFirstName_
                        .hashCode());
        result = prime * result
                + (int) (taskPersonId_ ^ (taskPersonId_ >>> 32));
        result = prime
                * result
                + ((taskPersonLastName_ == null) ? 0 : taskPersonLastName_
                        .hashCode());
        result = prime * result + taskStatusId_;
        result = prime * result
                + ((taskTitle_ == null) ? 0 : taskTitle_.hashCode());
        result = prime * result + ((title_ == null) ? 0 : title_.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final MeetingBasic other = (MeetingBasic) obj;
        if (activeAgendas_ != other.activeAgendas_)
            return false;
        if (activityId_ != other.activityId_)
            return false;
        if (activityName_ == null) {
            if (other.activityName_ != null)
                return false;
        } else if (!activityName_.equals(other.activityName_))
            return false;
        if (archivesCount_ != other.archivesCount_)
            return false;
        if (body_ == null) {
            if (other.body_ != null)
                return false;
        } else if (!body_.equals(other.body_))
            return false;
        if (color_ == null) {
            if (other.color_ != null)
                return false;
        } else if (!color_.equals(other.color_))
            return false;
        if (deleteFlag_ == null) {
            if (other.deleteFlag_ != null)
                return false;
        } else if (!deleteFlag_.equals(other.deleteFlag_))
            return false;
        if (doneAgendas_ != other.doneAgendas_)
            return false;
        if (firstName_ == null) {
            if (other.firstName_ != null)
                return false;
        } else if (!firstName_.equals(other.firstName_))
            return false;
        if (id_ != other.id_)
            return false;
        if (lastName_ == null) {
            if (other.lastName_ != null)
                return false;
        } else if (!lastName_.equals(other.lastName_))
            return false;
        if (libraryCount_ != other.libraryCount_)
            return false;
        if (modified_ == null) {
            if (other.modified_ != null)
                return false;
        } else if (!modified_.equals(other.modified_))
            return false;
        if (postedUserId_ != other.postedUserId_)
            return false;
        if (registered_ == null) {
            if (other.registered_ != null)
                return false;
        } else if (!registered_.equals(other.registered_))
            return false;
        if (rowCount_ != other.rowCount_)
            return false;
        if (startDate_ == null) {
            if (other.startDate_ != null)
                return false;
        } else if (!startDate_.equals(other.startDate_))
            return false;
        if (statusId_ != other.statusId_)
            return false;
        if (taskClassId_ != other.taskClassId_)
            return false;
        if (taskId_ != other.taskId_)
            return false;
        if (taskPersonFirstName_ == null) {
            if (other.taskPersonFirstName_ != null)
                return false;
        } else if (!taskPersonFirstName_.equals(other.taskPersonFirstName_))
            return false;
        if (taskPersonId_ != other.taskPersonId_)
            return false;
        if (taskPersonLastName_ == null) {
            if (other.taskPersonLastName_ != null)
                return false;
        } else if (!taskPersonLastName_.equals(other.taskPersonLastName_))
            return false;
        if (taskStatusId_ != other.taskStatusId_)
            return false;
        if (taskTitle_ == null) {
            if (other.taskTitle_ != null)
                return false;
        } else if (!taskTitle_.equals(other.taskTitle_))
            return false;
        if (title_ == null) {
            if (other.title_ != null)
                return false;
        } else if (!title_.equals(other.title_))
            return false;
        return true;
    }
    
}
