/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.meeting.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * meeting basic body
 * 
 * @author naoya.saito
 * 
 */
@Bean(table = "meeting_basic_bodies")
public class MeetingBasicBody implements Serializable {
    private static final long serialVersionUID = -393056132160968578L;
    
    /* meeting basic body id */
    private long id_;

    @Column("ID")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* meeting basic body agenda id */
    private long basicId_;

    @Column("BASIC_ID")
    public long getBasicId() {
        return basicId_;
    }

    public void setBasicId(long basicId) {
        this.basicId_ = basicId;
    }

    /* meeting basic body rev */
    private int rev_;

    @Column("REV")
    public int getRev() {
        return rev_;
    }

    public void setRev(int rev) {
        this.rev_ = rev;
    }

    /* meeting basic body body */
    private String body_;

    @Column("BODY")
    public String getBody() {
        return body_;
    }

    public void setBody(String body) {
        this.body_ = body;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (basicId_ ^ (basicId_ >>> 32));
        result = prime * result + ((body_ == null) ? 0 : body_.hashCode());
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result + rev_;
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final MeetingBasicBody other = (MeetingBasicBody) obj;
        if (basicId_ != other.basicId_)
            return false;
        if (body_ == null) {
            if (other.body_ != null)
                return false;
        } else if (!body_.equals(other.body_))
            return false;
        if (id_ != other.id_)
            return false;
        if (rev_ != other.rev_)
            return false;
        return true;
    }
    
    
}
