/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.meeting.entity;

import java.io.Serializable;
import java.util.Arrays;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.pager.DefaultPagerCondition;

/**
 * meeting browse page condition.
 * 
 */
public class MeetingBrowsePageCondition extends DefaultPagerCondition implements Serializable {
    private static final long serialVersionUID = -4833509173329605252L;
    
    /* user id. */
    private long userId_;

    public long getUserId() {
        return userId_;
    }

    public void setUserId(long userId) {
        this.userId_ = userId;
    }

    /* basic id. */
    private long basicId_;

    public long getBasicId() {
        return basicId_;
    }

    public void setBasicId(long basicId) {
        this.basicId_ = basicId;
    }

    /* keyword. */
    private String keyword_;

    public String getKeyword() {
        return keyword_;
    }

    public void setKeyword(String keyword) {
        this.keyword_ = keyword;
    }

    /* query status ids. */
    private Integer[] queryStatusIds_;

    public Integer[] getQueryStatusIds() {
        return queryStatusIds_;
    }

    public void setQueryStatusIds(Integer[] queryStatusIds) {
        this.queryStatusIds_ = queryStatusIds;
    }

    /* query activity ids. */
    private Long[] queryActivityIds_;

    public Long[] getQueryActivityIds() {
        return queryActivityIds_;
    }

    public void setQueryActivityIdsIds(Long[] queryActivityIds) {
        this.queryActivityIds_ = queryActivityIds;
    }

    /* query registration ids. */
    private Integer[] queryRegistrationIds_;

    public Integer[] getQueryRegistrationIds() {
        return queryRegistrationIds_;
    }

    public void setQueryRegistrationIds(Integer[] queryRegistrationIds) {
        this.queryRegistrationIds_ = queryRegistrationIds;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (basicId_ ^ (basicId_ >>> 32));
        result = prime * result
                + ((keyword_ == null) ? 0 : keyword_.hashCode());
        result = prime * result + Arrays.hashCode(queryActivityIds_);
        result = prime * result + Arrays.hashCode(queryRegistrationIds_);
        result = prime * result + Arrays.hashCode(queryStatusIds_);
        result = prime * result + (int) (userId_ ^ (userId_ >>> 32));
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final MeetingBrowsePageCondition other = (MeetingBrowsePageCondition) obj;
        if (basicId_ != other.basicId_)
            return false;
        if (keyword_ == null) {
            if (other.keyword_ != null)
                return false;
        } else if (!keyword_.equals(other.keyword_))
            return false;
        if (!Arrays.equals(queryActivityIds_, other.queryActivityIds_))
            return false;
        if (!Arrays.equals(queryRegistrationIds_, other.queryRegistrationIds_))
            return false;
        if (!Arrays.equals(queryStatusIds_, other.queryStatusIds_))
            return false;
        if (userId_ != other.userId_)
            return false;
        return true;
    }
    
}
