/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.meeting.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * meeting relations.
 * 
 * @author naoya.saito
 * 
 */
@Bean(table = "meeting_relations")
public class MeetingRelation implements Serializable {
    private static final long serialVersionUID = -3419995982769822342L;
    
    /* meeting relations id */
    private long id_;

    @Column("ID")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* meeting relations basic id */
    private long basicId_;

    @Column("BASIC_ID")
    public long getBasicId() {
        return basicId_;
    }

    public void setBasicId(long basicId) {
        this.basicId_ = basicId;
    }

    /* meeting relations agenda id */
    private long agendaId_;

    @Column("AGENDA_ID")
    public long getAgendaId() {
        return agendaId_;
    }

    public void setAgendaId(long agendaId) {
        this.agendaId_ = agendaId;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (agendaId_ ^ (agendaId_ >>> 32));
        result = prime * result + (int) (basicId_ ^ (basicId_ >>> 32));
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final MeetingRelation other = (MeetingRelation) obj;
        if (agendaId_ != other.agendaId_)
            return false;
        if (basicId_ != other.basicId_)
            return false;
        if (id_ != other.id_)
            return false;
        return true;
    }
    
}
