/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.meeting.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * meeting to task.
 * 
 * @author naoya.saito
 * 
 */
@Bean(table = "meeting_to_tasks")
public class MeetingToTask implements Serializable {
    private static final long serialVersionUID = -6870451388404327683L;
    
    /* row count */
    private int rowCount_;

    @Column("ROW_COUNT")
    public int getRowCount() {
        return rowCount_;
    }

    public void setRowCount(int rowCount) {
        this.rowCount_ = rowCount;
    }

    /* meeting to task id */
    private long id_;

    @Column("ID")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* meeting to task basic id */
    private long basicId_;

    @Column("BASIC_ID")
    public long getBasicId() {
        return basicId_;
    }

    public void setBasicId(long basicId) {
        this.basicId_ = basicId;
    }

    /* meeting basic title */
    private String basicTitle_;

    @Column("BASIC_TITLE")
    public String getMeetingTitle() {
        return basicTitle_;
    }

    public void setMeetingTitle(String basicTitle) {
        this.basicTitle_ = basicTitle;
    }

    /* meeting to task agenda id */
    private long agendaId_;

    @Column("AGENDA_ID")
    public long getAgendaId() {
        return agendaId_;
    }

    public void setAgendaId(long agendaId) {
        this.agendaId_ = agendaId;
    }

    /* meeting to task discussion id */
    private long discussionId_;

    @Column("DISCUSSION_ID")
    public long getDiscussionId() {
        return discussionId_;
    }

    public void setDiscussionId(long discussion) {
        this.discussionId_ = discussion;
    }

    /* meeting to task task id */
    private long taskId_;

    @Column("TASK_ID")
    public long getTaskId() {
        return taskId_;
    }

    public void setTaskId(long taskId) {
        this.taskId_ = taskId;
    }

    /* tasks title */
    private String title_;

    @Column("TITLE")
    public String getTitle() {
        return title_;
    }

    public void setTitle(String title) {
        this.title_ = title;
    }

    /* tasks deadline Date */
    private String deadline_;

    @Column("DEAD_LINE")
    public String getDeadline() {
        return deadline_;
    }

    public void setDeadline(String deadline) {
        this.deadline_ = deadline;
    }

    /* tasks registered */
    private String registered_;

    @Column("REGISTERED")
    public String getRegistered() {
        return registered_;
    }

    public void setRegistered(String registered) {
        this.registered_ = registered;
    }

    /* task relations status Id */
    private int statusId_;

    @Column("STATUS_ID")
    public int getStatusId() {
        return statusId_;
    }

    public void setStatusId(int statusId) {
        this.statusId_ = statusId;
    }

    /* task relations classification id */
    private int classificationId_;

    @Column("CLASSIFICATION_ID")
    public int getClassificationId() {
        return classificationId_;
    }

    public void setClassificationId(int classificationId) {
        this.classificationId_ = classificationId;
    }

    /* task relations person in charge id */
    private long personId_;

    @Column("PERSON_ID")
    public long getPersonId() {
        return personId_;
    }

    public void setPersonId(long personId) {
        this.personId_ = personId;
    }

    /* task relations posted User Id */
    private long postedUserId_;

    @Column("POSTED_USER_ID")
    public long getPostedUserId() {
        return postedUserId_;
    }

    public void setPostedUserId(long postedUserId) {
        this.postedUserId_ = postedUserId;
    }

    /* m_user id */
    private String firstName_;

    @Column("FIRST_NAME")
    public String getFirstName() {
        return firstName_;
    }

    public void setFirstName(String firstName) {
        this.firstName_ = firstName;
    }

    /* m_user last name */
    private String lastName_;

    @Column("LAST_NAME")
    public String getLastName() {
        return lastName_;
    }

    public void setLastName(String lastName) {
        this.lastName_ = lastName;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (agendaId_ ^ (agendaId_ >>> 32));
        result = prime * result + (int) (basicId_ ^ (basicId_ >>> 32));
        result = prime * result
                + ((basicTitle_ == null) ? 0 : basicTitle_.hashCode());
        result = prime * result + classificationId_;
        result = prime * result
                + ((deadline_ == null) ? 0 : deadline_.hashCode());
        result = prime * result
                + (int) (discussionId_ ^ (discussionId_ >>> 32));
        result = prime * result
                + ((firstName_ == null) ? 0 : firstName_.hashCode());
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result
                + ((lastName_ == null) ? 0 : lastName_.hashCode());
        result = prime * result + (int) (personId_ ^ (personId_ >>> 32));
        result = prime * result
                + (int) (postedUserId_ ^ (postedUserId_ >>> 32));
        result = prime * result
                + ((registered_ == null) ? 0 : registered_.hashCode());
        result = prime * result + rowCount_;
        result = prime * result + statusId_;
        result = prime * result + (int) (taskId_ ^ (taskId_ >>> 32));
        result = prime * result + ((title_ == null) ? 0 : title_.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final MeetingToTask other = (MeetingToTask) obj;
        if (agendaId_ != other.agendaId_)
            return false;
        if (basicId_ != other.basicId_)
            return false;
        if (basicTitle_ == null) {
            if (other.basicTitle_ != null)
                return false;
        } else if (!basicTitle_.equals(other.basicTitle_))
            return false;
        if (classificationId_ != other.classificationId_)
            return false;
        if (deadline_ == null) {
            if (other.deadline_ != null)
                return false;
        } else if (!deadline_.equals(other.deadline_))
            return false;
        if (discussionId_ != other.discussionId_)
            return false;
        if (firstName_ == null) {
            if (other.firstName_ != null)
                return false;
        } else if (!firstName_.equals(other.firstName_))
            return false;
        if (id_ != other.id_)
            return false;
        if (lastName_ == null) {
            if (other.lastName_ != null)
                return false;
        } else if (!lastName_.equals(other.lastName_))
            return false;
        if (personId_ != other.personId_)
            return false;
        if (postedUserId_ != other.postedUserId_)
            return false;
        if (registered_ == null) {
            if (other.registered_ != null)
                return false;
        } else if (!registered_.equals(other.registered_))
            return false;
        if (rowCount_ != other.rowCount_)
            return false;
        if (statusId_ != other.statusId_)
            return false;
        if (taskId_ != other.taskId_)
            return false;
        if (title_ == null) {
            if (other.title_ != null)
                return false;
        } else if (!title_.equals(other.title_))
            return false;
        return true;
    }
    
}
