/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.meeting.page.impl;

import org.seasar.tugboat.gtd.commons.util.SessionUtil;
import org.seasar.tugboat.gtd.container.annotation.FormAnnotation;
import org.seasar.tugboat.gtd.contents.meeting.page.MeetingAction;
import org.seasar.tugboat.gtd.contents.user.dto.UserDto;

/**
 * meeting action impl.
 * 
 * @author naoya.saito
 * 
 */
@FormAnnotation(formId = "meetingAction", isAuthorizationCheck = true, isDirectAccessCheck = false, errorPage = "error")
public class MeetingActionImpl implements MeetingAction {

    /* user name */
    private String userName_;

    public String getUserName() {
        return userName_;
    }

    public void setUserName(String userName) {
        this.userName_ = userName;
    }

    /* version */
    private String version_;

    public String getVersion() {
        return version_;
    }

    public void setVersion(String version) {
        this.version_ = version;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.contents.meeting.page.MeetingAction#initialize()
     */
    public String initialize() {
        UserDto sessionLoginUser = SessionUtil.getLoginUser();
        this.userName_ = sessionLoginUser.getLastName() + "," + sessionLoginUser.getFirstName();
        return null;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.contents.meeting.page.MeetingAction#forwardMeetingsView()
     */
    public String forwardMeetingsView() {
        return "gtd_meetings";
    }
}
