/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.dao;

import org.seasar.dao.annotation.tiger.Arguments;
import org.seasar.dao.annotation.tiger.S2Dao;
import org.seasar.tugboat.gtd.contents.task.entity.Tag;

/**
 * tags dao.
 * 
 * @author yosuke
 * 
 */
@S2Dao(bean = Tag.class)
public interface TagsDao {

    /**
     * insert.
     * 
     * @param value
     * @return
     */
    @Arguments("value")
    int insert(String value);

    /**
     * find by keyword.
     * 
     * @param keyword
     * @return
     */
    @Arguments("keyword")
    Tag[] findByKeyword(String keyword);

    /**
     * find by id.
     * 
     * @param id
     * @return
     *
    @Arguments("id")
    Tag findById(long id);
    */

    /**
     * find by value.
     * 
     * @param value
     * @return
     */
    @Arguments("value")
    Tag findByValue(String value);
}
