/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.dao;

import org.seasar.dao.annotation.tiger.Arguments;
import org.seasar.dao.annotation.tiger.S2Dao;
import org.seasar.tugboat.gtd.contents.task.entity.TaskCollectionOfRecord;

/**
 * task collection of record dao.
 * 
 * @author yousuke
 *
 */
@S2Dao(bean = TaskCollectionOfRecord.class)
public interface TaskCollectionOfRecordsDao {

    /**
     * insert for today.
     * 
     * @param entity
     * @return
     */
    @Arguments("entity")
    int insertTodayTodo(TaskCollectionOfRecord entity);
    
    /**
     * insert for review.
     * 
     * @param entity
     * @return
     */
    @Arguments({"entity", "yesterday"})
    int insertDoneTodo(TaskCollectionOfRecord entity, String yesterday);
    
    /**
     * find by full date.
     * 
     * @param fullDate
     * @return
     */
    @Arguments("fullDate")
    TaskCollectionOfRecord[] findByFullDate(String fullDate);
    
    /**
     * delete by term.
     * 
     * @param startDate
     * @param endDate
     * @return
     */
    @Arguments("endDate")
    int deleteByTerm(String endDate);
}
