/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.dao;

import org.seasar.dao.annotation.tiger.Arguments;
import org.seasar.dao.annotation.tiger.S2Dao;
import org.seasar.tugboat.gtd.contents.task.entity.TaskGroup;

/**
 * task group dao.
 * 
 * @author yousuke
 * 
 */
@S2Dao(bean = TaskGroup.class)
public interface TaskGroupsDao {

    /**
     * insert.
     * 
     * @param taskGroup
     * @return
     */
    @Arguments("taskGroup")
    int insert(TaskGroup taskGroup);

    /**
     * update.
     * 
     * @param taskGroup
     * @return
     */
    @Arguments("taskGroup")
    int update(TaskGroup taskGroup);

    /**
     * update delete flag.
     * 
     * @param taskGroup
     * @return
     */
    @Arguments("taskGroup")
    int updateDelFlag(TaskGroup taskGroup);

    /**
     * find by user id.
     * 
     * @param userId
     * @return
     */
    @Arguments("userId")
    TaskGroup[] findByUserId(long userId);

    /**
     * find by id.
     * 
     * @return
     */
    @Arguments("id")
    TaskGroup findById(long id);

    /**
     * get task group id.
     * 
     * @return
     */
    long getId();
}
