/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.dto;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.tugboat.gtd.contents.task.entity.TaskComment;

/**
 * Task comment dto.
 * 
 * @author yousuke.hara
 * 
 */
public class TaskCommentDto extends TaskComment {
    private static final long serialVersionUID = -5353502907474875487L;
    
    /* registered formated string */
    private String registeredFormated_;

    public String getRegisteredFormated() {
        return registeredFormated_;
    }

    public void setRegisteredFormated(String registeredFormated) {
        this.registeredFormated_ = registeredFormated;
    }

    /* my comment */
    private boolean isMyComment_ = false;

    public boolean getIsMyComment() {
        return isMyComment_;
    }

    public void setIsMyComment(boolean isMyComment) {
        this.isMyComment_ = isMyComment;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime * result + (isMyComment_ ? 1231 : 1237);
        result = prime
                * result
                + ((registeredFormated_ == null) ? 0 : registeredFormated_
                        .hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!super.equals(obj))
            return false;
        if (getClass() != obj.getClass())
            return false;
        final TaskCommentDto other = (TaskCommentDto) obj;
        if (isMyComment_ != other.isMyComment_)
            return false;
        if (registeredFormated_ == null) {
            if (other.registeredFormated_ != null)
                return false;
        } else if (!registeredFormated_.equals(other.registeredFormated_))
            return false;
        return true;
    }
    
}
