/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.dto;

import java.io.Serializable;
import java.util.Arrays;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.tugboat.gtd.contents.task.entity.TaskRelation;

/**
 * Task dto.
 * 
 * @author yousuke.hara
 * 
 */
public class TaskRelationDto extends TaskRelation implements Serializable {
    private static final long serialVersionUID = 6810073397589342737L;
    
    /* Start date formated */
    private String startDateFormated_;

    public String getStartDateFormated() {
        return startDateFormated_;
    }

    public void setStartDateFormated(String startDateFormated) {
        this.startDateFormated_ = startDateFormated;
    }

    /* Deadline formated */
    private String deadlinFormated_;

    public String getDeadlineFormated() {
        return deadlinFormated_;
    }

    public void setDeadlineFormated(String deadlineFormated) {
        this.deadlinFormated_ = deadlineFormated;
    }

    /* Registered formated */
    private String registeredFormated_;

    public String getRegisteredFormated() {
        return registeredFormated_;
    }

    public void setRegisteredFormated(String registeredFormated) {
        this.registeredFormated_ = registeredFormated;
    }

    /* query status ids. */
    private String[] queryStatusIds_;

    public String[] getQueryStatusIds() {
        return queryStatusIds_;
    }

    public void setQueryStatusIds(String[] queryStatusIds) {
        this.queryStatusIds_ = queryStatusIds;
    }

    /* query classification ids. */
    private String[] queryClassificationIds_;

    public String[] getQueryClassificationIds() {
        return queryClassificationIds_;
    }

    public void setQueryClassificationIds(String[] queryClassificationIds) {
        this.queryClassificationIds_ = queryClassificationIds;
    }

    /* query calendar ids. */
    private String[] queryActivityIds_;

    public String[] getQueryActivityIds() {
        return queryActivityIds_;
    }

    public void setQueryActivityIds(String[] queryActivityIds) {
        this.queryActivityIds_ = queryActivityIds;
    }

    /* query person ids */
    private String[] queryPersonIds_;

    public String[] getQueryPersonIds() {
        return queryPersonIds_;
    }

    public void setQueryPersonIds(String[] queryPersonIds) {
        this.queryPersonIds_ = queryPersonIds;
    }

    /* query person Is Null */
    private boolean queryPersonIsNull_;

    public boolean getQueryPersonIsNull() {
        return queryPersonIsNull_;
    }

    public void setQueryPersonIsNull(boolean queryPersonIsNull) {
        this.queryPersonIsNull_ = queryPersonIsNull;
    }

    /* offset */
    private int offset_;

    public int getOffset() {
        return offset_;
    }

    public void setOffset(int offset) {
        this.offset_ = offset;
    }

    /* limit */
    private int limit_;

    public int getLimit() {
        return limit_;
    }

    public void setLimit(int limit) {
        this.limit_ = limit;
    }

    /* task tags */
    private TaskTagDto[] taskTagDtos_;

    public TaskTagDto[] getTaskTagDtos() {
        return this.taskTagDtos_;
    }

    public void setTaskTagDtos(TaskTagDto[] taskTagDtos) {
        this.taskTagDtos_ = taskTagDtos;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime
                * result
                + ((deadlinFormated_ == null) ? 0 : deadlinFormated_.hashCode());
        result = prime * result + limit_;
        result = prime * result + offset_;
        result = prime * result + Arrays.hashCode(queryActivityIds_);
        result = prime * result + Arrays.hashCode(queryClassificationIds_);
        result = prime * result + Arrays.hashCode(queryPersonIds_);
        result = prime * result + (queryPersonIsNull_ ? 1231 : 1237);
        result = prime * result + Arrays.hashCode(queryStatusIds_);
        result = prime
                * result
                + ((registeredFormated_ == null) ? 0 : registeredFormated_
                        .hashCode());
        result = prime
                * result
                + ((startDateFormated_ == null) ? 0 : startDateFormated_
                        .hashCode());
        result = prime * result + Arrays.hashCode(taskTagDtos_);
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!super.equals(obj))
            return false;
        if (getClass() != obj.getClass())
            return false;
        final TaskRelationDto other = (TaskRelationDto) obj;
        if (deadlinFormated_ == null) {
            if (other.deadlinFormated_ != null)
                return false;
        } else if (!deadlinFormated_.equals(other.deadlinFormated_))
            return false;
        if (limit_ != other.limit_)
            return false;
        if (offset_ != other.offset_)
            return false;
        if (!Arrays.equals(queryActivityIds_, other.queryActivityIds_))
            return false;
        if (!Arrays.equals(queryClassificationIds_,
                other.queryClassificationIds_))
            return false;
        if (!Arrays.equals(queryPersonIds_, other.queryPersonIds_))
            return false;
        if (queryPersonIsNull_ != other.queryPersonIsNull_)
            return false;
        if (!Arrays.equals(queryStatusIds_, other.queryStatusIds_))
            return false;
        if (registeredFormated_ == null) {
            if (other.registeredFormated_ != null)
                return false;
        } else if (!registeredFormated_.equals(other.registeredFormated_))
            return false;
        if (startDateFormated_ == null) {
            if (other.startDateFormated_ != null)
                return false;
        } else if (!startDateFormated_.equals(other.startDateFormated_))
            return false;
        if (!Arrays.equals(taskTagDtos_, other.taskTagDtos_))
            return false;
        return true;
    }
    
}
