/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.dto;

import java.io.Serializable;
import java.util.Arrays;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * Task relations dto.
 * 
 * @author yousuke.hara
 * 
 */
public class TaskRelationsByActivityDto implements Serializable {
    private static final long serialVersionUID = 5145514844858453970L;
    
    /* calendar(activity) id */
    private long activityId_;

    public long getActivityId() {
        return activityId_;
    }

    public void setActivityId(long activityId) {
        this.activityId_ = activityId;
    }

    /* calendar value */
    private String activityValue_;

    public String getActivityValue() {
        return activityValue_;
    }

    public void setActivityValue(String activityValue) {
        this.activityValue_ = activityValue;
    }

    /* calendar color */
    private String activityColor_;

    public String getActivityColor() {
        return activityColor_;
    }

    public void setActivityColor(String activityColor) {
        this.activityColor_ = activityColor;
    }

    /* task number of count */
    public int getRows() {
        return this.taskRelationsDtos_ == null ? 0 : this.taskRelationsDtos_.length;
    }

    /* tasks */
    private TaskRelationDto[] taskRelationsDtos_;

    public TaskRelationDto[] getTaskRelationsDtos() {
        return taskRelationsDtos_;
    }

    public void setTaskDtos(TaskRelationDto[] taskRelationsDtos) {
        this.taskRelationsDtos_ = taskRelationsDtos;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result
                + ((activityColor_ == null) ? 0 : activityColor_.hashCode());
        result = prime * result + (int) (activityId_ ^ (activityId_ >>> 32));
        result = prime * result
                + ((activityValue_ == null) ? 0 : activityValue_.hashCode());
        result = prime * result + Arrays.hashCode(taskRelationsDtos_);
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final TaskRelationsByActivityDto other = (TaskRelationsByActivityDto) obj;
        if (activityColor_ == null) {
            if (other.activityColor_ != null)
                return false;
        } else if (!activityColor_.equals(other.activityColor_))
            return false;
        if (activityId_ != other.activityId_)
            return false;
        if (activityValue_ == null) {
            if (other.activityValue_ != null)
                return false;
        } else if (!activityValue_.equals(other.activityValue_))
            return false;
        if (!Arrays.equals(taskRelationsDtos_, other.taskRelationsDtos_))
            return false;
        return true;
    }
    
}
