/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.dto;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.tugboat.gtd.contents.task.entity.TaskTag;

/**
 * task tag dto.
 * 
 * @author yosuke
 * 
 */
public class TaskTagDto extends TaskTag implements Serializable {
    private static final long serialVersionUID = -6592284158412091708L;

    public TaskTagDto() {
    }

    public TaskTagDto(int tagId, String tagValue) {
        this.setTagId(tagId);
        this.setTagValue(tagValue);
    }

    /* is selected */
    private boolean isSelected_ = false;

    public boolean getIsSelected() {
        return isSelected_;
    }

    public void setIsSelected(boolean isSelected) {
        this.isSelected_ = isSelected;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime * result + (isSelected_ ? 1231 : 1237);
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!super.equals(obj))
            return false;
        if (getClass() != obj.getClass())
            return false;
        final TaskTagDto other = (TaskTagDto) obj;
        if (isSelected_ != other.isSelected_)
            return false;
        return true;
    }
    
}
