/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.dto;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.tugboat.gtd.contents.task.entity.TaskToTask;

/**
 * task to task dto.
 * 
 * @author yosuke
 * 
 */
public class TaskToTaskDto extends TaskToTask implements Serializable {
    private static final long serialVersionUID = -1531832781689959577L;
    
    /* source posted at formated */
    private String sourcePostedAtFormated_;

    public String getSourcePostedAtFormated() {
        return sourcePostedAtFormated_;
    }

    public void setSourcePostedAtFormated(String sourcePostedAtFormated) {
        this.sourcePostedAtFormated_ = sourcePostedAtFormated;
    }

    /* destination posted at formated */
    private String destinationPostedAtFormated_;

    public String getDestinationPostedAtFormated() {
        return destinationPostedAtFormated_;
    }

    public void setDestinationPostedAtFormated(String destinationPostedAtFormated) {
        this.destinationPostedAtFormated_ = destinationPostedAtFormated;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime
                * result
                + ((destinationPostedAtFormated_ == null) ? 0
                        : destinationPostedAtFormated_.hashCode());
        result = prime
                * result
                + ((sourcePostedAtFormated_ == null) ? 0
                        : sourcePostedAtFormated_.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!super.equals(obj))
            return false;
        if (getClass() != obj.getClass())
            return false;
        final TaskToTaskDto other = (TaskToTaskDto) obj;
        if (destinationPostedAtFormated_ == null) {
            if (other.destinationPostedAtFormated_ != null)
                return false;
        } else if (!destinationPostedAtFormated_
                .equals(other.destinationPostedAtFormated_))
            return false;
        if (sourcePostedAtFormated_ == null) {
            if (other.sourcePostedAtFormated_ != null)
                return false;
        } else if (!sourcePostedAtFormated_
                .equals(other.sourcePostedAtFormated_))
            return false;
        return true;
    }
    
}
