/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * tag.
 * 
 * @author yosuke
 * 
 */
@Bean(table = "tags")
public class Tag implements Serializable {
    private static final long serialVersionUID = 4036588065229955968L;

    public Tag() {
    }

    public Tag(int id, String value) {
        this.id_ = id;
        this.value_ = value;
    }

    public Tag(int id, String value, int numberOfCount) {
        this.id_ = id;
        this.value_ = value;
        this.numberOfCount_ = numberOfCount;
    }

    /* id */
    private long id_;

    @Column("id")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* value */
    private String value_;

    @Column("value")
    public String getValue() {
        return value_;
    }

    public void setValue(String value) {
        this.value_ = value;
    }

    /* number of count */
    private int numberOfCount_;

    public int getNumberOfCount() {
        return numberOfCount_;
    }

    public void setNumberOfCount(int numberOfCount) {
        this.numberOfCount_ = numberOfCount;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result + numberOfCount_;
        result = prime * result + ((value_ == null) ? 0 : value_.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final Tag other = (Tag) obj;
        if (id_ != other.id_)
            return false;
        if (numberOfCount_ != other.numberOfCount_)
            return false;
        if (value_ == null) {
            if (other.value_ != null)
                return false;
        } else if (!value_.equals(other.value_))
            return false;
        return true;
    }
    
}
