/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * Task.
 * 
 * @author yousuke.hara
 * 
 */
@Bean(table = "tasks")
public class Task implements Serializable {
    private static final long serialVersionUID = 7862517512216070767L;

    public static final int STATUS_TODO = 1;

    public static final int STATUS_DOING = 2;

    public static final int STATUS_DONE = 3;

    /* Id */
    private long id_;

    @Column("ID")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* Title */
    private String title_;

    @Column("TITLE")
    public String getTitle() {
        return title_;
    }

    public void setTitle(String title) {
        this.title_ = title;
    }

    /* description */
    private String description_ = "";

    public String getDescription() {
        return description_;
    }

    public void setDescription(String description) {
        this.description_ = description;
    }

    /* description textile */
    private String descriptionTextile_ = "";

    public String getDescriptionTextile() {
        return descriptionTextile_;
    }

    public void setDescriptionTextile(String descriptionTextile) {
        this.descriptionTextile_ = descriptionTextile;
    }

    /* share */
    private int share_;

    @Column("SHARE")
    public int getShare() {
        return share_;
    }

    public void setShare(int share) {
        this.share_ = share;
    }

    /* Start date */
    private String startDate_;

    @Column("START_DATE")
    public String getStartDate() {
        return startDate_;
    }

    public void setStartDate(String startDate) {
        this.startDate_ = startDate;
    }

    /* Start year */
    private int startYear_;

    @Column("START_YEAR")
    public int getStartYear() {
        return startYear_;
    }

    public void setStartYear(int startYear) {
        this.startYear_ = startYear;
    }

    /* Start month */
    private int startMonth_;

    @Column("START_MONTH")
    public int getStartMonth() {
        return startMonth_;
    }

    public void setStartMonth(int startMonth) {
        this.startMonth_ = startMonth;
    }

    /* Start day of month */
    private int startDayOfMonth_;

    @Column("START_DAY_OF_MONTH")
    public int getStartDayOfMonth() {
        return startDayOfMonth_;
    }

    public void setStartDayOfMonth(int startDayOfMonth) {
        this.startDayOfMonth_ = startDayOfMonth;
    }

    /* deadline Date */
    private String deadline_;

    @Column("DEAD_LINE")
    public String getDeadline() {
        return deadline_;
    }

    public void setDeadline(String deadline) {
        this.deadline_ = deadline;
    }

    /* deadline year */
    private int deadlineYear_;

    @Column("DEAD_LINE_YEAR")
    public int getDeadlineYear() {
        return deadlineYear_;
    }

    public void setDeadlineYear(int deadlineYear) {
        this.deadlineYear_ = deadlineYear;
    }

    /* deadline month */
    private int deadlineMonth_;

    @Column("DEAD_LINE_MONTH")
    public int getDeadlineMonth() {
        return deadlineMonth_;
    }

    public void setDeadlineMonth(int deadlineMonth) {
        this.deadlineMonth_ = deadlineMonth;
    }

    /* deadline day of month */
    private int deadlineDayOfMonth_;

    @Column("DEAD_LINE_DAY_OF_MONTH")
    public int getDeadlineDayOfMonth() {
        return deadlineDayOfMonth_;
    }

    public void setDeadlineDayOfMonth(int deadlineDayOfMonth) {
        this.deadlineDayOfMonth_ = deadlineDayOfMonth;
    }

    /* privacy */
    private int privacy_;

    @Column("PRIVACY")
    public int getPrivacy() {
        return privacy_;
    }

    public void setPrivacy(int privacy) {
        this.privacy_ = privacy;
    }

    /* priority order */
    private int priorityOrder_;

    @Column("PRIORITY_ORDER")
    public int getPriorityOrder() {
        return priorityOrder_;
    }

    public void setPriorityOrder(int priorityOrder) {
        this.priorityOrder_ = priorityOrder;
    }

    /* status Id */
    private int statusId_;

    @Column("STATUS_ID")
    public int getStatusId() {
        return statusId_;
    }

    public void setStatusId(int statusId) {
        this.statusId_ = statusId;
    }

    /* status value */
    private String statusValue_;

    @Column("STATUS_VALUE")
    public String getStatusValue() {
        return statusValue_;
    }

    public void setStatusValue(String statusValue) {
        this.statusValue_ = statusValue;
    }

    /* activity id */
    private long activityId_;

    @Column("ACTIVITY_ID")
    public long getActivityId() {
        return activityId_;
    }

    public void setActivityId(long activityId) {
        this.activityId_ = activityId;
    }

    /* activity name */
    private String activityValue_;

    @Column("ACTIVITY_VALUE")
    public String getActivityValue() {
        return activityValue_;
    }

    public void setActivityValue(String activityValue) {
        this.activityValue_ = activityValue;
    }

    /* classification id */
    private int classificationId_;

    @Column("CLASSIFICATION_ID")
    public int getClassificationId() {
        return classificationId_;
    }

    public void setClassificationId(int classificationId) {
        this.classificationId_ = classificationId;
    }

    /* classification value */
    private String classificationValue_;

    @Column("CLASSIFICATION_VALUE")
    public String getClassificationValue() {
        return classificationValue_;
    }

    public void setClassificationValue(String classificationValue) {
        this.classificationValue_ = classificationValue;
    }

    /* user id */
    private long userId_;

    @Column("POSTED_USER_ID")
    public long getUserId() {
        return userId_;
    }

    public void setUserId(long userId) {
        this.userId_ = userId;
    }

    /* user first name */
    private String userFirstName_;

    @Column("FIRST_NAME")
    public String getUserFirstName() {
        return userFirstName_;
    }

    public void setUserFirstName(String userFirstName) {
        this.userFirstName_ = userFirstName;
    }

    /* user last name */
    private String userLastName_;

    @Column("LAST_NAME")
    public String getUserLastName() {
        return userLastName_;
    }

    public void setUserLastName(String userLastName) {
        this.userLastName_ = userLastName;
    }

    /* registered */
    private String registered_;

    @Column("REGISTERED")
    public String getRegistered() {
        return registered_;
    }

    public void setRegistered(String registered) {
        this.registered_ = registered;
    }

    /* delete flag */
    private String deleteFlag_ = "0";

    @Column("DELETE_FLAG")
    public String getDeleteFlag() {
        return deleteFlag_;
    }

    public void setDeleteFlag(String deleteFlag) {
        this.deleteFlag_ = deleteFlag;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (activityId_ ^ (activityId_ >>> 32));
        result = prime * result
                + ((activityValue_ == null) ? 0 : activityValue_.hashCode());
        result = prime * result + classificationId_;
        result = prime
                * result
                + ((classificationValue_ == null) ? 0 : classificationValue_
                        .hashCode());
        result = prime * result + deadlineDayOfMonth_;
        result = prime * result + deadlineMonth_;
        result = prime * result + deadlineYear_;
        result = prime * result
                + ((deadline_ == null) ? 0 : deadline_.hashCode());
        result = prime * result
                + ((deleteFlag_ == null) ? 0 : deleteFlag_.hashCode());
        result = prime
                * result
                + ((descriptionTextile_ == null) ? 0 : descriptionTextile_
                        .hashCode());
        result = prime * result
                + ((description_ == null) ? 0 : description_.hashCode());
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result + priorityOrder_;
        result = prime * result + privacy_;
        result = prime * result
                + ((registered_ == null) ? 0 : registered_.hashCode());
        result = prime * result + share_;
        result = prime * result
                + ((startDate_ == null) ? 0 : startDate_.hashCode());
        result = prime * result + startDayOfMonth_;
        result = prime * result + startMonth_;
        result = prime * result + startYear_;
        result = prime * result + statusId_;
        result = prime * result
                + ((statusValue_ == null) ? 0 : statusValue_.hashCode());
        result = prime * result + ((title_ == null) ? 0 : title_.hashCode());
        result = prime * result
                + ((userFirstName_ == null) ? 0 : userFirstName_.hashCode());
        result = prime * result + (int) (userId_ ^ (userId_ >>> 32));
        result = prime * result
                + ((userLastName_ == null) ? 0 : userLastName_.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final Task other = (Task) obj;
        if (activityId_ != other.activityId_)
            return false;
        if (activityValue_ == null) {
            if (other.activityValue_ != null)
                return false;
        } else if (!activityValue_.equals(other.activityValue_))
            return false;
        if (classificationId_ != other.classificationId_)
            return false;
        if (classificationValue_ == null) {
            if (other.classificationValue_ != null)
                return false;
        } else if (!classificationValue_.equals(other.classificationValue_))
            return false;
        if (deadlineDayOfMonth_ != other.deadlineDayOfMonth_)
            return false;
        if (deadlineMonth_ != other.deadlineMonth_)
            return false;
        if (deadlineYear_ != other.deadlineYear_)
            return false;
        if (deadline_ == null) {
            if (other.deadline_ != null)
                return false;
        } else if (!deadline_.equals(other.deadline_))
            return false;
        if (deleteFlag_ == null) {
            if (other.deleteFlag_ != null)
                return false;
        } else if (!deleteFlag_.equals(other.deleteFlag_))
            return false;
        if (descriptionTextile_ == null) {
            if (other.descriptionTextile_ != null)
                return false;
        } else if (!descriptionTextile_.equals(other.descriptionTextile_))
            return false;
        if (description_ == null) {
            if (other.description_ != null)
                return false;
        } else if (!description_.equals(other.description_))
            return false;
        if (id_ != other.id_)
            return false;
        if (priorityOrder_ != other.priorityOrder_)
            return false;
        if (privacy_ != other.privacy_)
            return false;
        if (registered_ == null) {
            if (other.registered_ != null)
                return false;
        } else if (!registered_.equals(other.registered_))
            return false;
        if (share_ != other.share_)
            return false;
        if (startDate_ == null) {
            if (other.startDate_ != null)
                return false;
        } else if (!startDate_.equals(other.startDate_))
            return false;
        if (startDayOfMonth_ != other.startDayOfMonth_)
            return false;
        if (startMonth_ != other.startMonth_)
            return false;
        if (startYear_ != other.startYear_)
            return false;
        if (statusId_ != other.statusId_)
            return false;
        if (statusValue_ == null) {
            if (other.statusValue_ != null)
                return false;
        } else if (!statusValue_.equals(other.statusValue_))
            return false;
        if (title_ == null) {
            if (other.title_ != null)
                return false;
        } else if (!title_.equals(other.title_))
            return false;
        if (userFirstName_ == null) {
            if (other.userFirstName_ != null)
                return false;
        } else if (!userFirstName_.equals(other.userFirstName_))
            return false;
        if (userId_ != other.userId_)
            return false;
        if (userLastName_ == null) {
            if (other.userLastName_ != null)
                return false;
        } else if (!userLastName_.equals(other.userLastName_))
            return false;
        return true;
    }
    
}
