/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * task browse person.
 * 
 * @author yosuke
 * 
 */
@Bean(table = "task_browser_persons")
public class TaskBrowsePerson implements Serializable {
    private static final long serialVersionUID = 7628941414466675700L;
    
    /* id */
    private long id_;

    @Column("id")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* person id */
    private int personId_;

    @Column("person_id")
    public int getPersonId() {
        return personId_;
    }

    public void setPersonId(int personId) {
        this.personId_ = personId;
    }

    /* user id */
    private int userId_;

    @Column("user_id")
    public int getUserId() {
        return userId_;
    }

    public void setUserId(int userId) {
        this.userId_ = userId;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result + personId_;
        result = prime * result + userId_;
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final TaskBrowsePerson other = (TaskBrowsePerson) obj;
        if (id_ != other.id_)
            return false;
        if (personId_ != other.personId_)
            return false;
        if (userId_ != other.userId_)
            return false;
        return true;
    }
    
}
