/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;

/**
 * task collection of records.
 * 
 * @author yousuke
 *
 */
@Bean(table = "task_collection_of_records")
public class TaskCollectionOfRecord implements Serializable {
    private static final long serialVersionUID = 4038836225124113339L;
    
    public static String COLLECT_TYPE_TODAY_TODO     = "1";
    public static String COLLECT_TYPE_YESTERDAY_DONE = "2";

    /* id */
    private long id_;
    
    public long getId() {
        return id_;
    }
    public void setId(long id) {
        this.id_ = id;
    }
    
    /* collect type */
    private String collectType_;
    
    public String getCollectType() {
        return collectType_;
    }
    public void setCollectType(String collectType) {
        this.collectType_ = collectType;
    }
    
    /* full date */
    private String fullDate_;
    
    public String getFullDate() {
        return fullDate_;
    }
    public void setFullDate(String fullDate) {
        this.fullDate_ = fullDate;
    }
    
    /* task id */
    private long taskId_;
    
    public long getTaskId() {
        return taskId_;
    }
    public void setTaskId(long taskId) {
        this.taskId_ = taskId;
    }
    
    /* activity id */
    private long activityId_;
    
    public long getActivityId() {
        return activityId_;
    }
    public void setActivityId(long activityId) {
        this.activityId_ = activityId;
    }
    
    /* status id */
    private int statusId_;
    
    public int getStatusId() {
        return statusId_;
    }
    public void setStatusId(int statusId) {
        this.statusId_ = statusId;
    }
    
    /* classification id */
    private int classificationId_;
    
    public int getClassificationId() {
        return classificationId_;
    }
    public void setClassificationId(int classificationId) {
        this.classificationId_ = classificationId;
    }
    
    /* created at */
    private String createdAt_;
    
    public String getCreatedAt() {
        return createdAt_;
    }
    public void setCreatedAt(String createdAt) {
        this.createdAt_ = createdAt;
    }
 
    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (activityId_ ^ (activityId_ >>> 32));
        result = prime * result + classificationId_;
        result = prime * result
                + ((collectType_ == null) ? 0 : collectType_.hashCode());
        result = prime * result
                + ((createdAt_ == null) ? 0 : createdAt_.hashCode());
        result = prime * result
                + ((fullDate_ == null) ? 0 : fullDate_.hashCode());
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result + statusId_;
        result = prime * result + (int) (taskId_ ^ (taskId_ >>> 32));
        return result;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final TaskCollectionOfRecord other = (TaskCollectionOfRecord) obj;
        if (activityId_ != other.activityId_)
            return false;
        if (classificationId_ != other.classificationId_)
            return false;
        if (collectType_ == null) {
            if (other.collectType_ != null)
                return false;
        } else if (!collectType_.equals(other.collectType_))
            return false;
        if (createdAt_ == null) {
            if (other.createdAt_ != null)
                return false;
        } else if (!createdAt_.equals(other.createdAt_))
            return false;
        if (fullDate_ == null) {
            if (other.fullDate_ != null)
                return false;
        } else if (!fullDate_.equals(other.fullDate_))
            return false;
        if (id_ != other.id_)
            return false;
        if (statusId_ != other.statusId_)
            return false;
        if (taskId_ != other.taskId_)
            return false;
        return true;
    }
    
}
