/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * Task comment.
 * 
 * @author yousuke.hara
 * 
 */
@Bean(table = "task_comments")
public class TaskComment implements Serializable {
    private static final long serialVersionUID = -5615822157596801876L;
    
    /* id */
    private long id_;

    @Column("ID")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* task Id */
    private long taskId_;

    @Column("TASK_ID")
    public long getTaskId() {
        return taskId_;
    }

    public void setTaskId(long taskId) {
        this.taskId_ = taskId;
    }

    /* comment */
    private String comment_;

    @Column("BODY")
    public String getComment() {
        return comment_;
    }

    public void setComment(String comment) {
        this.comment_ = comment;
    }

    /* user Id */
    private long userId_;

    @Column("USER_ID")
    public long getUserId() {
        return userId_;
    }

    public void setUserId(long userId) {
        this.userId_ = userId;
    }

    /* user first name */
    private String userFirstName_;

    @Column("FIRST_NAME")
    public String getUserFirstName() {
        return userFirstName_;
    }

    public void setUserFirstName(String userFirstName) {
        this.userFirstName_ = userFirstName;
    }

    /* user last name */
    private String userLastName_;

    @Column("LAST_NAME")
    public String getUserLastName() {
        return userLastName_;
    }

    public void setUserLastName(String userLastName) {
        this.userLastName_ = userLastName;
    }

    /* registered */
    private String registered_;

    @Column("REGISTERED")
    public String getRegistered() {
        return registered_;
    }

    public void setRegistered(String registered) {
        this.registered_ = registered;
    }

    /* photo url */
    private String photoUrl_;

    @Column("PHOTO_IMG_URL")
    public String getPhotoUrl() {
        return photoUrl_;
    }

    public void setPhotoUrl(String photoUrl) {
        this.photoUrl_ = photoUrl;
    }

    /* color id */
    private int colorId_;

    @Column("COLOR_ID")
    public int getColorId() {
        return colorId_;
    }

    public void setColorId(int colorId) {
        this.colorId_ = colorId;
    }

    /* color value */
    private String colorValue_;

    @Column("COLOR_VALUE")
    public String getColorValue() {
        return colorValue_;
    }

    public void setColorValue(String colorValue) {
        this.colorValue_ = colorValue;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + colorId_;
        result = prime * result
                + ((colorValue_ == null) ? 0 : colorValue_.hashCode());
        result = prime * result
                + ((comment_ == null) ? 0 : comment_.hashCode());
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result
                + ((photoUrl_ == null) ? 0 : photoUrl_.hashCode());
        result = prime * result
                + ((registered_ == null) ? 0 : registered_.hashCode());
        result = prime * result + (int) (taskId_ ^ (taskId_ >>> 32));
        result = prime * result
                + ((userFirstName_ == null) ? 0 : userFirstName_.hashCode());
        result = prime * result + (int) (userId_ ^ (userId_ >>> 32));
        result = prime * result
                + ((userLastName_ == null) ? 0 : userLastName_.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final TaskComment other = (TaskComment) obj;
        if (colorId_ != other.colorId_)
            return false;
        if (colorValue_ == null) {
            if (other.colorValue_ != null)
                return false;
        } else if (!colorValue_.equals(other.colorValue_))
            return false;
        if (comment_ == null) {
            if (other.comment_ != null)
                return false;
        } else if (!comment_.equals(other.comment_))
            return false;
        if (id_ != other.id_)
            return false;
        if (photoUrl_ == null) {
            if (other.photoUrl_ != null)
                return false;
        } else if (!photoUrl_.equals(other.photoUrl_))
            return false;
        if (registered_ == null) {
            if (other.registered_ != null)
                return false;
        } else if (!registered_.equals(other.registered_))
            return false;
        if (taskId_ != other.taskId_)
            return false;
        if (userFirstName_ == null) {
            if (other.userFirstName_ != null)
                return false;
        } else if (!userFirstName_.equals(other.userFirstName_))
            return false;
        if (userId_ != other.userId_)
            return false;
        if (userLastName_ == null) {
            if (other.userLastName_ != null)
                return false;
        } else if (!userLastName_.equals(other.userLastName_))
            return false;
        return true;
    }
    
}
