/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * task comment body.
 * 
 * @author yosuke
 * 
 */
@Bean(table = "task_comment_bodies")
public class TaskCommentBody implements Serializable {
    private static final long serialVersionUID = 1739585374845105803L;
    
    /* id */
    private long id_;

    @Column("ID")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* task id */
    private long taskId_;

    @Column("TASK_ID")
    public long getTaskId() {
        return taskId_;
    }

    public void setTaskId(long taskId) {
        this.taskId_ = taskId;
    }

    /* comment id */
    private long commentId_;

    @Column("COMMENT_ID")
    public long getCommentId() {
        return commentId_;
    }

    public void setCommentId(long commentId) {
        this.commentId_ = commentId;
    }

    /* body */
    private String body_;

    @Column("BODY")
    public String getBody() {
        return body_;
    }

    public void setBody(String body) {
        this.body_ = body;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((body_ == null) ? 0 : body_.hashCode());
        result = prime * result + (int) (commentId_ ^ (commentId_ >>> 32));
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result + (int) (taskId_ ^ (taskId_ >>> 32));
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final TaskCommentBody other = (TaskCommentBody) obj;
        if (body_ == null) {
            if (other.body_ != null)
                return false;
        } else if (!body_.equals(other.body_))
            return false;
        if (commentId_ != other.commentId_)
            return false;
        if (id_ != other.id_)
            return false;
        if (taskId_ != other.taskId_)
            return false;
        return true;
    }
    
}
