/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * task group dto.
 * 
 * @author yousuke
 * 
 */
@Bean(table = "task_groups")
public class TaskGroup implements Serializable {
    private static final long serialVersionUID = 6614712734323892921L;
    
    /** id */
    private long id_;

    @Column("id")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /** name */
    private String name_;

    @Column("name")
    public String getName() {
        return name_;
    }

    public void setName(String name) {
        this.name_ = name;
    }

    /** description */
    private String description_;

    @Column("description")
    public String getDescription() {
        return description_;
    }

    public void setDescription(String description) {
        this.description_ = description;
    }

    /** start date */
    private String startDate_;

    @Column("start_date")
    public String getStartDate() {
        return startDate_;
    }

    public void setStartDate(String startDate) {
        this.startDate_ = startDate;
    }

    /** deadline */
    private String deadline_;

    @Column("deadline")
    public String getDeadline() {
        return deadline_;
    }

    public void setDeadline(String deadline) {
        this.deadline_ = deadline;
    }

    /** del flag */
    private int delFlag_;

    @Column("del_flag")
    public int getDelFlag() {
        return delFlag_;
    }

    public void setDelFlag(int delFlag) {
        this.delFlag_ = delFlag;
    }

    /** registered */
    private String registered_;

    @Column("registered")
    public String getRegistered() {
        return registered_;
    }

    public void setRegistered(String registered) {
        this.registered_ = registered;
    }

    /** modified */
    private String modified_;

    @Column("modified")
    public String getModified() {
        return modified_;
    }

    public void setModified(String modified) {
        this.modified_ = modified;
    }
    
    /** user id */
    private long userId_;
    
    @Column("user_id")
    public long getUserId() {
        return userId_;
    }
    public void setUserId(long userId) {
        this.userId_ = userId;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result
                + ((deadline_ == null) ? 0 : deadline_.hashCode());
        result = prime * result + delFlag_;
        result = prime * result
                + ((description_ == null) ? 0 : description_.hashCode());
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result
                + ((modified_ == null) ? 0 : modified_.hashCode());
        result = prime * result + ((name_ == null) ? 0 : name_.hashCode());
        result = prime * result
                + ((registered_ == null) ? 0 : registered_.hashCode());
        result = prime * result
                + ((startDate_ == null) ? 0 : startDate_.hashCode());
        result = prime * result + (int) (userId_ ^ (userId_ >>> 32));
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final TaskGroup other = (TaskGroup) obj;
        if (deadline_ == null) {
            if (other.deadline_ != null)
                return false;
        } else if (!deadline_.equals(other.deadline_))
            return false;
        if (delFlag_ != other.delFlag_)
            return false;
        if (description_ == null) {
            if (other.description_ != null)
                return false;
        } else if (!description_.equals(other.description_))
            return false;
        if (id_ != other.id_)
            return false;
        if (modified_ == null) {
            if (other.modified_ != null)
                return false;
        } else if (!modified_.equals(other.modified_))
            return false;
        if (name_ == null) {
            if (other.name_ != null)
                return false;
        } else if (!name_.equals(other.name_))
            return false;
        if (registered_ == null) {
            if (other.registered_ != null)
                return false;
        } else if (!registered_.equals(other.registered_))
            return false;
        if (startDate_ == null) {
            if (other.startDate_ != null)
                return false;
        } else if (!startDate_.equals(other.startDate_))
            return false;
        if (userId_ != other.userId_)
            return false;
        return true;
    }

}