/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;

/**
 * task group activity.
 * 
 * @author yousuke
 *
 */
@Bean(table = "task_group_activities")
public class TaskGroupActivity implements Serializable {
    private static final long serialVersionUID = -5355879325026603674L;
    
    public TaskGroupActivity(){}
    
    public TaskGroupActivity(long activityId, long taskGroupId) {
        this.activityId_ = activityId;
        this.taskGroupId_ = taskGroupId;
    }
    
    /* id */
    private long id_;
    
    public long getId() {
        return id_;
    }
    
    public void setId(long id) {
        this.id_ = id;
    }
    
    /* task group id */
    private long taskGroupId_;
    
    public long getTaskGroupId() {
        return taskGroupId_;
    }
    
    public void setTaskGroupId(long taskGroupId) {
        this.taskGroupId_ = taskGroupId;
    }
    
    /* activity id */
    private long activityId_;
    
    public long getActivityId() {
        return activityId_;
    }
    
    public void setActivityId(long activityId) {
        this.activityId_ = activityId;
    }
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (activityId_ ^ (activityId_ >>> 32));
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result + (int) (taskGroupId_ ^ (taskGroupId_ >>> 32));
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final TaskGroupActivity other = (TaskGroupActivity) obj;
        if (activityId_ != other.activityId_)
            return false;
        if (id_ != other.id_)
            return false;
        if (taskGroupId_ != other.taskGroupId_)
            return false;
        return true;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }
}
