/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * task group relation.
 * 
 * @author yousuke
 * 
 */
@Bean(table = "task_group_relations")
public class TaskGroupRelation implements Serializable {
    private static final long serialVersionUID = -8867332665231969661L;

    public TaskGroupRelation() {}
    
    /**
     * @param taskGroupId
     * @param taskId
     */
    public TaskGroupRelation(long taskGroupId, long taskId) {
        this.taskGroupId_ = taskGroupId;
        this.taskId_ = taskId;
    }
    
    /** id */
    private long id_;

    @Column("id")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /** task group id */
    private long taskGroupId_;

    @Column("task_group_id")
    public long getTaskGroupId() {
        return taskGroupId_;
    }

    public void setTaskGroupId(long taskGroupId) {
        this.taskGroupId_ = taskGroupId;
    }

    /** activity id */
    private long activityId_;

    @Column("activity_id")
    public long getActivityId() {
        return activityId_;
    }

    public void setActivityId(long activityId) {
        this.activityId_ = activityId;
    }
    
    /** activity name */
    private String activityName_;
    
    @Column("activity_name")
    public String getActivityName() {
        return activityName_;
    }
    
    public void setActivityName(String activityName) {
        this.activityName_ = activityName;
    }
    
    /** activity color */
    private String activityColor_;
    
    @Column("activity_color")
    public String getActivityColor() {
        return activityColor_;
    }
    
    public void setActivityColor(String activityColor) {
        this.activityColor_ = activityColor;
    }

    /** task group name */
    private String name_;

    @Column("name")
    public String getName() {
        return name_;
    }

    public void setName(String name) {
        this.name_ = name;
    }
    
    /** description */
    private String description_;
    
    @Column("description")
    public String getDescription() {
        return description_;
    }
    
    public void setDescription(String description) {
        this.description_ = description;
    }

    /** task group start date */
    private String startDate_;

    @Column("start_date")
    public String getStartDate() {
        return startDate_;
    }

    public void setStartDate(String startDate) {
        this.startDate_ = startDate;
    }

    /** task group deadline */
    private String deadline_;

    @Column("deadline")
    public String getDeadline() {
        return deadline_;
    }

    public void setDeadline(String deadline) {
        this.deadline_ = deadline;
    }

    /** task id */
    private long taskId_;

    @Column("task_id")
    public long getTaskId() {
        return taskId_;
    }

    public void setTaskId(long taskId) {
        this.taskId_ = taskId;
    }

    /** all tasks */
    private int allTasks_;

    @Column("all_tasks")
    public int getAllTasks() {
        return allTasks_;
    }

    public void setAllTasks(int allTasks) {
        this.allTasks_ = allTasks;
    }

    /** done tasks */
    private int doneTasks_;

    @Column("done_tasks")
    public int getDoneTasks() {
        return this.doneTasks_;
    }

    public void setDoneTasks(int doneTasks) {
        this.doneTasks_ = doneTasks;
    }

    /** task status id */
    private int taskStatusId_;

    @Column("status_id")
    public int getTaskStatusId() {
        return taskStatusId_;
    }

    public void setTaskStatusId(int taskStatusId) {
        this.taskStatusId_ = taskStatusId;
    }

    /** task classification id */
    private int taskClassificationId_;

    @Column("classification_id")
    public int getTaskClassificationId() {
        return taskClassificationId_;
    }

    public void setTaskClassificationId(int taskClassificationId) {
        this.taskClassificationId_ = taskClassificationId;
    }

    /** task title */
    private String taskTitle_;

    @Column("title")
    public String getTaskTitle() {
        return taskTitle_;
    }

    public void setTaskTitle(String taskTitle) {
        this.taskTitle_ = taskTitle;
    }

    /** task group deadline */
    private String taskDeadline_;

    @Column("task_deadline")
    public String getTaskDeadline() {
        return taskDeadline_;
    }

    public void setTaskDeadline(String taskDeadline) {
        this.taskDeadline_ = taskDeadline;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result
                + ((activityColor_ == null) ? 0 : activityColor_.hashCode());
        result = prime * result + (int) (activityId_ ^ (activityId_ >>> 32));
        result = prime * result
                + ((activityName_ == null) ? 0 : activityName_.hashCode());
        result = prime * result + allTasks_;
        result = prime * result
                + ((deadline_ == null) ? 0 : deadline_.hashCode());
        result = prime * result + doneTasks_;
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result + ((name_ == null) ? 0 : name_.hashCode());
        result = prime * result
                + ((startDate_ == null) ? 0 : startDate_.hashCode());
        result = prime * result + taskClassificationId_;
        result = prime * result
                + ((taskDeadline_ == null) ? 0 : taskDeadline_.hashCode());
        result = prime * result + (int) (taskGroupId_ ^ (taskGroupId_ >>> 32));
        result = prime * result + (int) (taskId_ ^ (taskId_ >>> 32));
        result = prime * result + taskStatusId_;
        result = prime * result
                + ((taskTitle_ == null) ? 0 : taskTitle_.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final TaskGroupRelation other = (TaskGroupRelation) obj;
        if (activityColor_ == null) {
            if (other.activityColor_ != null)
                return false;
        } else if (!activityColor_.equals(other.activityColor_))
            return false;
        if (activityId_ != other.activityId_)
            return false;
        if (activityName_ == null) {
            if (other.activityName_ != null)
                return false;
        } else if (!activityName_.equals(other.activityName_))
            return false;
        if (allTasks_ != other.allTasks_)
            return false;
        if (deadline_ == null) {
            if (other.deadline_ != null)
                return false;
        } else if (!deadline_.equals(other.deadline_))
            return false;
        if (doneTasks_ != other.doneTasks_)
            return false;
        if (id_ != other.id_)
            return false;
        if (name_ == null) {
            if (other.name_ != null)
                return false;
        } else if (!name_.equals(other.name_))
            return false;
        if (startDate_ == null) {
            if (other.startDate_ != null)
                return false;
        } else if (!startDate_.equals(other.startDate_))
            return false;
        if (taskClassificationId_ != other.taskClassificationId_)
            return false;
        if (taskDeadline_ == null) {
            if (other.taskDeadline_ != null)
                return false;
        } else if (!taskDeadline_.equals(other.taskDeadline_))
            return false;
        if (taskGroupId_ != other.taskGroupId_)
            return false;
        if (taskId_ != other.taskId_)
            return false;
        if (taskStatusId_ != other.taskStatusId_)
            return false;
        if (taskTitle_ == null) {
            if (other.taskTitle_ != null)
                return false;
        } else if (!taskTitle_.equals(other.taskTitle_))
            return false;
        return true;
    }

}
