/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * Task history.
 * 
 * @author yousuke.hara
 * 
 */
@Bean(table = "task_histories")
public class TaskHistory implements Serializable {
    private static final long serialVersionUID = -621458500335542958L;
    
    /* id */
    private long id_;

    @Column("ID")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* task Id */
    private long taskId_;

    @Column("TASK_ID")
    public long getTaskId() {
        return taskId_;
    }

    public void setTaskId(long taskId) {
        this.taskId_ = taskId;
    }

    /* user Id */
    private long userId_;

    @Column("USER_ID")
    public long getUserId() {
        return userId_;
    }

    public void setUserId(long userId) {
        this.userId_ = userId;
    }

    /* user first name */
    private String userFirstName_;

    @Column("FIRST_NAME")
    public String getUserFirstName() {
        return userFirstName_;
    }

    public void setUserFirstName(String userFirstName) {
        this.userFirstName_ = userFirstName;
    }

    /* user last name */
    private String userLastName_;

    @Column("LAST_NAME")
    public String getUserLastName() {
        return userLastName_;
    }

    public void setUserLastName(String userLastName) {
        this.userLastName_ = userLastName;
    }

    /* status Id */
    private int statusId_;

    @Column("STATUS_ID")
    public int getStatusId() {
        return statusId_;
    }

    public void setStatusId(int statusId) {
        this.statusId_ = statusId;
    }

    /* status value */
    private String statusValue_;

    @Column("STATUS_VALUE")
    public String getStatusValue() {
        return statusValue_;
    }

    public void setStatusValue(String statusValue) {
        this.statusValue_ = statusValue;
    }

    /* status value i18n */
    private String statusValueI18n_;

    @Column("STATUS_VALUE_I18N")
    public String getStatusValueI18n() {
        return statusValueI18n_;
    }

    public void setStatusValueI18n(String statusValueI18n) {
        this.statusValueI18n_ = statusValueI18n;
    }

    /* registered */
    private String registered_;

    @Column("REGISTERED")
    public String getRegistered() {
        return registered_;
    }

    public void setRegistered(String registered) {
        this.registered_ = registered;
    }

    /* description */
    private String description_;

    @Column("DESCRIPTION")
    public String getDescription() {
        return description_;
    }

    public void setDescription(String description) {
        this.description_ = description;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result
                + ((description_ == null) ? 0 : description_.hashCode());
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result
                + ((registered_ == null) ? 0 : registered_.hashCode());
        result = prime * result + statusId_;
        result = prime
                * result
                + ((statusValueI18n_ == null) ? 0 : statusValueI18n_.hashCode());
        result = prime * result
                + ((statusValue_ == null) ? 0 : statusValue_.hashCode());
        result = prime * result + (int) (taskId_ ^ (taskId_ >>> 32));
        result = prime * result
                + ((userFirstName_ == null) ? 0 : userFirstName_.hashCode());
        result = prime * result + (int) (userId_ ^ (userId_ >>> 32));
        result = prime * result
                + ((userLastName_ == null) ? 0 : userLastName_.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final TaskHistory other = (TaskHistory) obj;
        if (description_ == null) {
            if (other.description_ != null)
                return false;
        } else if (!description_.equals(other.description_))
            return false;
        if (id_ != other.id_)
            return false;
        if (registered_ == null) {
            if (other.registered_ != null)
                return false;
        } else if (!registered_.equals(other.registered_))
            return false;
        if (statusId_ != other.statusId_)
            return false;
        if (statusValueI18n_ == null) {
            if (other.statusValueI18n_ != null)
                return false;
        } else if (!statusValueI18n_.equals(other.statusValueI18n_))
            return false;
        if (statusValue_ == null) {
            if (other.statusValue_ != null)
                return false;
        } else if (!statusValue_.equals(other.statusValue_))
            return false;
        if (taskId_ != other.taskId_)
            return false;
        if (userFirstName_ == null) {
            if (other.userFirstName_ != null)
                return false;
        } else if (!userFirstName_.equals(other.userFirstName_))
            return false;
        if (userId_ != other.userId_)
            return false;
        if (userLastName_ == null) {
            if (other.userLastName_ != null)
                return false;
        } else if (!userLastName_.equals(other.userLastName_))
            return false;
        return true;
    }
    
}
