/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * Task relation.
 * 
 * @author yousuke.hara
 * 
 */
@Bean(table = "task_relations")
public class TaskRelation implements Serializable {
    private static final long serialVersionUID = 8771186634843592710L;

    /** status todo */
    public static final int STATUS_TODO = 1;

    /** status doing */
    public static final int STATUS_DOING = 2;

    /** status done */
    public static final int STATIS_DONE = 3;

    /* Id */
    private long id_;

    @Column("ID")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* task id */
    private long taskId_;

    @Column("TASK_ID")
    public long getTaskId() {
        return taskId_;
    }

    public void setTaskId(long taskId) {
        this.taskId_ = taskId;
    }

    /* Title */
    private String title_;

    @Column("TITLE")
    public String getTitle() {
        return title_;
    }

    public void setTitle(String title) {
        this.title_ = title;
    }

    /* description */
    private String description_ = "";

    @Column("BODY")
    public String getDescription() {
        return description_;
    }

    public void setDescription(String description) {
        this.description_ = description;
    }

    /* description textile */
    private String descriptionTextile_ = "";

    public String getDescriptionTextile() {
        return descriptionTextile_;
    }

    public void setDescriptionTextile(String descriptionTextile) {
        this.descriptionTextile_ = descriptionTextile;
    }

    /* share */
    private int share_;

    @Column("SHARE")
    public int getShare() {
        return share_;
    }

    public void setShare(int share) {
        this.share_ = share;
    }

    /* Start date */
    private String startDate_;

    @Column("START_DATE")
    public String getStartDate() {
        return startDate_;
    }

    public void setStartDate(String startDate) {
        this.startDate_ = startDate;
    }

    /* Start year */
    private int startYear_;

    @Column("START_YEAR")
    public int getStartYear() {
        return startYear_;
    }

    public void setStartYear(int startYear) {
        this.startYear_ = startYear;
    }

    /* Start month */
    private int startMonth_;

    @Column("START_MONTH")
    public int getStartMonth() {
        return startMonth_;
    }

    public void setStartMonth(int startMonth) {
        this.startMonth_ = startMonth;
    }

    /* Start day of month */
    private int startDayOfMonth_;

    @Column("START_DAY_OF_MONTH")
    public int getStartDayOfMonth() {
        return startDayOfMonth_;
    }

    public void setStartDayOfMonth(int startDayOfMonth) {
        this.startDayOfMonth_ = startDayOfMonth;
    }

    /* deadline Date */
    private String deadline_;

    @Column("DEAD_LINE")
    public String getDeadline() {
        return deadline_;
    }

    public void setDeadline(String deadline) {
        this.deadline_ = deadline;
    }

    /* deadline year */
    private int deadlineYear_;

    @Column("DEAD_LINE_YEAR")
    public int getDeadlineYear() {
        return deadlineYear_;
    }

    public void setDeadlineYear(int deadlineYear) {
        this.deadlineYear_ = deadlineYear;
    }

    /* deadline month */
    private int deadlineMonth_;

    @Column("DEAD_LINE_MONTH")
    public int getDeadlineMonth() {
        return deadlineMonth_;
    }

    public void setDeadlineMonth(int deadlineMonth) {
        this.deadlineMonth_ = deadlineMonth;
    }

    /* deadline day of month */
    private int deadlineDayOfMonth_;

    @Column("DEAD_LINE_DAY_OF_MONTH")
    public int getDeadlineDayOfMonth() {
        return deadlineDayOfMonth_;
    }

    public void setDeadlineDayOfMonth(int deadlineDayOfMonth) {
        this.deadlineDayOfMonth_ = deadlineDayOfMonth;
    }

    /* privacy */
    private int privacy_;

    @Column("PRIVACY")
    public int getPrivacy() {
        return privacy_;
    }

    public void setPrivacy(int privacy) {
        this.privacy_ = privacy;
    }

    /* priority order */
    private int priorityOrder_;

    @Column("PRIORITY_ORDER")
    public int getPriorityOrder() {
        return priorityOrder_;
    }

    public void setPriorityOrder(int priorityOrder) {
        this.priorityOrder_ = priorityOrder;
    }

    /* status Id */
    private int statusId_;

    @Column("STATUS_ID")
    public int getStatusId() {
        return statusId_;
    }

    public void setStatusId(int statusId) {
        this.statusId_ = statusId;
    }

    /* status value */
    private String statusValue_;

    @Column("STATUS_VALUE")
    public String getStatusValue() {
        return statusValue_;
    }

    public void setStatusValue(String statusValue) {
        this.statusValue_ = statusValue;
    }

    /* activity id */
    private long activityId_;

    @Column("ACTIVITY_ID")
    public long getActivityId() {
        return activityId_;
    }

    public void setActivityId(long activityId) {
        this.activityId_ = activityId;
    }

    /* activity name */
    private String activityValue_;

    @Column("ACTIVITY_VALUE")
    public String getActivityValue() {
        return activityValue_;
    }

    public void setActivityValue(String activityValue) {
        this.activityValue_ = activityValue;
    }

    /* color id */
    private int colorId_;

    @Column("COLOR_ID")
    public int getColorId() {
        return colorId_;
    }

    public void setColorId(int colorId) {
        this.colorId_ = colorId;
    }

    /* color value */
    private String colorValue_;

    @Column("COLOR_VALUE")
    public String getColorValue() {
        return colorValue_;
    }

    public void setColorValue(String colorValue) {
        this.colorValue_ = colorValue;
    }

    /* classification id */
    private int classificationId_;

    @Column("CLASSIFICATION_ID")
    public int getClassificationId() {
        return classificationId_;
    }

    public void setClassificationId(int classificationId) {
        this.classificationId_ = classificationId;
    }

    /* classification value */
    private String classificationValue_;

    @Column("CLASSIFICATION_VALUE")
    public String getClassificationValue() {
        return classificationValue_;
    }

    public void setClassificationValue(String classificationValue) {
        this.classificationValue_ = classificationValue;
    }

    /* alert id */
    private int alertId_;

    @Column("ALERT_ID")
    public int getAlertId() {
        return alertId_;
    }

    public void setAlertId(int alertId) {
        this.alertId_ = alertId;
    }

    /* alert value */
    private String alertValue_;

    @Column("ALERT_VALUE")
    public String getAlertValue() {
        return alertValue_;
    }

    public void setAlertValue(String alertValue) {
        this.alertValue_ = alertValue;
    }

    /* person in charge id */
    private long personInChargeId_;

    @Column("PERSON_ID")
    public long getPersonInChargeId() {
        return personInChargeId_;
    }

    public void setPersonInChargeId(long personInChargeId) {
        this.personInChargeId_ = personInChargeId;
    }

    /* preson in charge.first name */
    private String personInChargeFirstName_;

    @Column("PERSON_FIRST_NAME")
    public String getPersonInChargeFirstName() {
        return personInChargeFirstName_;
    }

    public void setPersonInChargeFirstName(String personInChargeFirstName) {
        this.personInChargeFirstName_ = personInChargeFirstName;
    }

    /* person in charge last name */
    private String personInChargeLastName_;

    @Column("PERSON_LAST_NAME")
    public String getPersonInChargeLastName() {
        return personInChargeLastName_;
    }

    public void setPersonInChargeLastName(String personInChargeLastName) {
        this.personInChargeLastName_ = personInChargeLastName;
    }

    /* user id */
    private long userId_;

    @Column("POSTED_USER_ID")
    public long getUserId() {
        return userId_;
    }

    public void setUserId(long userId) {
        this.userId_ = userId;
    }

    /* user first name */
    private String userFirstName_;

    @Column("FIRST_NAME")
    public String getUserFirstName() {
        return userFirstName_;
    }

    public void setUserFirstName(String userFirstName) {
        this.userFirstName_ = userFirstName;
    }

    /* user last name */
    private String userLastName_;

    @Column("LAST_NAME")
    public String getUserLastName() {
        return userLastName_;
    }

    public void setUserLastName(String userLastName) {
        this.userLastName_ = userLastName;
    }

    /* delete flag */
    private int deleteFlag_;

    @Column("DEL_FLAG")
    public int getDeleteFlag() {
        return deleteFlag_;
    }

    public void setDeleteFlag(int deleteFlag) {
        this.deleteFlag_ = deleteFlag;
    }

    /* posted date time */
    private String postedDateTime_;

    public String getPostedDateTime() {
        return postedDateTime_;
    }

    public void setPostedDateTime(String postedDateTime) {
        this.postedDateTime_ = postedDateTime;
    }

    /* rows */
    private int rows_;

    @Column("RECORDS")
    public int getRows() {
        return rows_;
    }

    public void setRows(int rows) {
        this.rows_ = rows;
    }

    /* total records */
    private int totalRows_;

    @Column("TOTAL_RECORDS")
    public int getTotalRows() {
        return totalRows_;
    }

    public void setTotalRows(int totalRows) {
        this.totalRows_ = totalRows;
    }

    /* done records */
    private int doneRows_;

    @Column("DONE_RECORDS")
    public int getDoneRows() {
        return doneRows_;
    }

    public void setDoneRows(int doneRows) {
        this.doneRows_ = doneRows;
    }

    /* inbox task rows */
    private int inboxTasks_;

    @Column("INBOX_TASKS")
    public int getInboxTasks() {
        return inboxTasks_;
    }

    public void setInboxTasks(int inboxTasks) {
        this.inboxTasks_ = inboxTasks;
    }

    /* today task rows */
    private int todayTasks_;

    @Column("TODAY_TASKS")
    public int getTodayTasks() {
        return todayTasks_;
    }

    public void setTodayTasks(int todayTasks) {
        this.todayTasks_ = todayTasks;
    }

    /* today todo tasks */
    private int todayTodoTasks_;

    @Column("TODAY_TODO_TASKS")
    public int getTodayTodoTasks() {
        return todayTodoTasks_;
    }

    public void setTodayTodoTasks(int todayTodoTasks) {
        this.todayTodoTasks_ = todayTodoTasks;
    }

    /* today doing tasks */
    private int todayDoingTasks_;

    @Column("TODAY_DOING_TASKS")
    public int getTodayDoingTasks() {
        return todayDoingTasks_;
    }

    public void setTodayDoingTasks(int todayDoingTasks) {
        this.todayDoingTasks_ = todayDoingTasks;
    }

    /* today done tasks */
    private int todayDoneTasks_;

    @Column("TODAY_DONE_TASKS")
    public int getTodayDoneTasks() {
        return todayDoneTasks_;
    }

    public void setTodayDoneTasks(int todayDoneTasks) {
        this.todayDoneTasks_ = todayDoneTasks;
    }

    /* week task rows */
    private int weekTasks_;

    @Column("WEEK_TASKS")
    public int getWeekTasks() {
        return weekTasks_;
    }

    public void setWeekTasks(int weekTasks) {
        this.weekTasks_ = weekTasks;
    }

    /* month tasks */
    private int monthTasks_;

    @Column("MONTH_TASKS")
    public int getMonthTasks() {
        return monthTasks_;
    }

    public void setMonthTasks(int monthTasks) {
        this.monthTasks_ = monthTasks;
    }

    /* hold task rows */
    private int holdTasks_;

    @Column("HOLD_TASKS")
    public int getHoldTasks() {
        return holdTasks_;
    }

    public void setHoldTasks(int holdTasks) {
        this.holdTasks_ = holdTasks;
    }

    /* someday task rows */
    private int somedayTasks_;

    @Column("SOMEDAY_TASKS")
    public int getSomedayTasks() {
        return somedayTasks_;
    }

    public void setSomedayTasks(int somedayTasks) {
        this.somedayTasks_ = somedayTasks;
    }

    /* archive task rows */
    private int archiveTasks_;

    @Column("ARCHIVE_TASKS")
    public int getArchiveTasks() {
        return archiveTasks_;
    }

    public void setArchiveTasks(int archiveTasks) {
        this.archiveTasks_ = archiveTasks;
    }

    /* trash bos tasks */
    private int trashBoxTasks_;

    @Column("TRASH_BOX_TASKS")
    public int getTrashBoxTasks() {
        return trashBoxTasks_;
    }

    public void setTrashBoxTasks(int trashBoxTasks) {
        this.trashBoxTasks_ = trashBoxTasks;
    }

    /* registered */
    private String registered_;

    @Column("REGISTERED")
    public String getRegistered() {
        return registered_;
    }

    public void setRegistered(String registered) {
        this.registered_ = registered;
    }

    /* modified */
    private String modified_;

    @Column("MODIFIED")
    public String getModified() {
        return modified_;
    }

    public void setModified(String modified) {
        this.modified_ = modified;
    }

    /* tag id */
    private Integer tagId_;

    @Column("TAG_ID")
    public Integer getTagId() {
        return tagId_;
    }

    public void setTagId(Integer tagId) {
        this.tagId_ = tagId;
    }

    /* tag value */
    private String tagValue_;

    @Column("TAG_VALUE")
    public String getTagValue() {
        return tagValue_;
    }

    public void setTagValue(String tagValue) {
        this.tagValue_ = tagValue;
    }
    
    /* task group id */
    private long taskGroupId_;
    
    @Column("TASK_GROUP_ID")
    public long getTaskGroupId() {
        return taskGroupId_;
    }
    
    public void setTaskGroupId(long taskGroupId) {
        this.taskGroupId_ = taskGroupId;
    }
    
    /* task group name */
    private String taskGroupName_;
    
    @Column("TASK_GROUP_NAME")
    public String getTaskGroupName() {
        return taskGroupName_;
    }
    
    public void setTaskGroupName(String taskGroupName) {
        this.taskGroupName_ = taskGroupName;
    }
    
    /* full date (for task collection of records) */
    private String fullDate_;
    
    @Column("FULL_DATE")
    public String getFullDate() {
        return fullDate_;
    }
    public void setFullDate(String fullDate) {
        this.fullDate_ = fullDate;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (activityId_ ^ (activityId_ >>> 32));
        result = prime * result
                + ((activityValue_ == null) ? 0 : activityValue_.hashCode());
        result = prime * result + alertId_;
        result = prime * result
                + ((alertValue_ == null) ? 0 : alertValue_.hashCode());
        result = prime * result + archiveTasks_;
        result = prime * result + classificationId_;
        result = prime
                * result
                + ((classificationValue_ == null) ? 0 : classificationValue_
                        .hashCode());
        result = prime * result + colorId_;
        result = prime * result
                + ((colorValue_ == null) ? 0 : colorValue_.hashCode());
        result = prime * result + deadlineDayOfMonth_;
        result = prime * result + deadlineMonth_;
        result = prime * result + deadlineYear_;
        result = prime * result
                + ((deadline_ == null) ? 0 : deadline_.hashCode());
        result = prime * result + deleteFlag_;
        result = prime
                * result
                + ((descriptionTextile_ == null) ? 0 : descriptionTextile_
                        .hashCode());
        result = prime * result
                + ((description_ == null) ? 0 : description_.hashCode());
        result = prime * result + doneRows_;
        result = prime * result
                + ((fullDate_ == null) ? 0 : fullDate_.hashCode());
        result = prime * result + holdTasks_;
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result + inboxTasks_;
        result = prime * result
                + ((modified_ == null) ? 0 : modified_.hashCode());
        result = prime * result + monthTasks_;
        result = prime
                * result
                + ((personInChargeFirstName_ == null) ? 0
                        : personInChargeFirstName_.hashCode());
        result = prime * result
                + (int) (personInChargeId_ ^ (personInChargeId_ >>> 32));
        result = prime
                * result
                + ((personInChargeLastName_ == null) ? 0
                        : personInChargeLastName_.hashCode());
        result = prime * result
                + ((postedDateTime_ == null) ? 0 : postedDateTime_.hashCode());
        result = prime * result + priorityOrder_;
        result = prime * result + privacy_;
        result = prime * result
                + ((registered_ == null) ? 0 : registered_.hashCode());
        result = prime * result + rows_;
        result = prime * result + share_;
        result = prime * result + somedayTasks_;
        result = prime * result
                + ((startDate_ == null) ? 0 : startDate_.hashCode());
        result = prime * result + startDayOfMonth_;
        result = prime * result + startMonth_;
        result = prime * result + startYear_;
        result = prime * result + statusId_;
        result = prime * result
                + ((statusValue_ == null) ? 0 : statusValue_.hashCode());
        result = prime * result + ((tagId_ == null) ? 0 : tagId_.hashCode());
        result = prime * result
                + ((tagValue_ == null) ? 0 : tagValue_.hashCode());
        result = prime * result + (int) (taskGroupId_ ^ (taskGroupId_ >>> 32));
        result = prime * result
                + ((taskGroupName_ == null) ? 0 : taskGroupName_.hashCode());
        result = prime * result + (int) (taskId_ ^ (taskId_ >>> 32));
        result = prime * result + ((title_ == null) ? 0 : title_.hashCode());
        result = prime * result + todayDoingTasks_;
        result = prime * result + todayDoneTasks_;
        result = prime * result + todayTasks_;
        result = prime * result + todayTodoTasks_;
        result = prime * result + totalRows_;
        result = prime * result + trashBoxTasks_;
        result = prime * result
                + ((userFirstName_ == null) ? 0 : userFirstName_.hashCode());
        result = prime * result + (int) (userId_ ^ (userId_ >>> 32));
        result = prime * result
                + ((userLastName_ == null) ? 0 : userLastName_.hashCode());
        result = prime * result + weekTasks_;
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final TaskRelation other = (TaskRelation) obj;
        if (activityId_ != other.activityId_)
            return false;
        if (activityValue_ == null) {
            if (other.activityValue_ != null)
                return false;
        } else if (!activityValue_.equals(other.activityValue_))
            return false;
        if (alertId_ != other.alertId_)
            return false;
        if (alertValue_ == null) {
            if (other.alertValue_ != null)
                return false;
        } else if (!alertValue_.equals(other.alertValue_))
            return false;
        if (archiveTasks_ != other.archiveTasks_)
            return false;
        if (classificationId_ != other.classificationId_)
            return false;
        if (classificationValue_ == null) {
            if (other.classificationValue_ != null)
                return false;
        } else if (!classificationValue_.equals(other.classificationValue_))
            return false;
        if (colorId_ != other.colorId_)
            return false;
        if (colorValue_ == null) {
            if (other.colorValue_ != null)
                return false;
        } else if (!colorValue_.equals(other.colorValue_))
            return false;
        if (deadlineDayOfMonth_ != other.deadlineDayOfMonth_)
            return false;
        if (deadlineMonth_ != other.deadlineMonth_)
            return false;
        if (deadlineYear_ != other.deadlineYear_)
            return false;
        if (deadline_ == null) {
            if (other.deadline_ != null)
                return false;
        } else if (!deadline_.equals(other.deadline_))
            return false;
        if (deleteFlag_ != other.deleteFlag_)
            return false;
        if (descriptionTextile_ == null) {
            if (other.descriptionTextile_ != null)
                return false;
        } else if (!descriptionTextile_.equals(other.descriptionTextile_))
            return false;
        if (description_ == null) {
            if (other.description_ != null)
                return false;
        } else if (!description_.equals(other.description_))
            return false;
        if (doneRows_ != other.doneRows_)
            return false;
        if (fullDate_ == null) {
            if (other.fullDate_ != null)
                return false;
        } else if (!fullDate_.equals(other.fullDate_))
            return false;
        if (holdTasks_ != other.holdTasks_)
            return false;
        if (id_ != other.id_)
            return false;
        if (inboxTasks_ != other.inboxTasks_)
            return false;
        if (modified_ == null) {
            if (other.modified_ != null)
                return false;
        } else if (!modified_.equals(other.modified_))
            return false;
        if (monthTasks_ != other.monthTasks_)
            return false;
        if (personInChargeFirstName_ == null) {
            if (other.personInChargeFirstName_ != null)
                return false;
        } else if (!personInChargeFirstName_
                .equals(other.personInChargeFirstName_))
            return false;
        if (personInChargeId_ != other.personInChargeId_)
            return false;
        if (personInChargeLastName_ == null) {
            if (other.personInChargeLastName_ != null)
                return false;
        } else if (!personInChargeLastName_
                .equals(other.personInChargeLastName_))
            return false;
        if (postedDateTime_ == null) {
            if (other.postedDateTime_ != null)
                return false;
        } else if (!postedDateTime_.equals(other.postedDateTime_))
            return false;
        if (priorityOrder_ != other.priorityOrder_)
            return false;
        if (privacy_ != other.privacy_)
            return false;
        if (registered_ == null) {
            if (other.registered_ != null)
                return false;
        } else if (!registered_.equals(other.registered_))
            return false;
        if (rows_ != other.rows_)
            return false;
        if (share_ != other.share_)
            return false;
        if (somedayTasks_ != other.somedayTasks_)
            return false;
        if (startDate_ == null) {
            if (other.startDate_ != null)
                return false;
        } else if (!startDate_.equals(other.startDate_))
            return false;
        if (startDayOfMonth_ != other.startDayOfMonth_)
            return false;
        if (startMonth_ != other.startMonth_)
            return false;
        if (startYear_ != other.startYear_)
            return false;
        if (statusId_ != other.statusId_)
            return false;
        if (statusValue_ == null) {
            if (other.statusValue_ != null)
                return false;
        } else if (!statusValue_.equals(other.statusValue_))
            return false;
        if (tagId_ == null) {
            if (other.tagId_ != null)
                return false;
        } else if (!tagId_.equals(other.tagId_))
            return false;
        if (tagValue_ == null) {
            if (other.tagValue_ != null)
                return false;
        } else if (!tagValue_.equals(other.tagValue_))
            return false;
        if (taskGroupId_ != other.taskGroupId_)
            return false;
        if (taskGroupName_ == null) {
            if (other.taskGroupName_ != null)
                return false;
        } else if (!taskGroupName_.equals(other.taskGroupName_))
            return false;
        if (taskId_ != other.taskId_)
            return false;
        if (title_ == null) {
            if (other.title_ != null)
                return false;
        } else if (!title_.equals(other.title_))
            return false;
        if (todayDoingTasks_ != other.todayDoingTasks_)
            return false;
        if (todayDoneTasks_ != other.todayDoneTasks_)
            return false;
        if (todayTasks_ != other.todayTasks_)
            return false;
        if (todayTodoTasks_ != other.todayTodoTasks_)
            return false;
        if (totalRows_ != other.totalRows_)
            return false;
        if (trashBoxTasks_ != other.trashBoxTasks_)
            return false;
        if (userFirstName_ == null) {
            if (other.userFirstName_ != null)
                return false;
        } else if (!userFirstName_.equals(other.userFirstName_))
            return false;
        if (userId_ != other.userId_)
            return false;
        if (userLastName_ == null) {
            if (other.userLastName_ != null)
                return false;
        } else if (!userLastName_.equals(other.userLastName_))
            return false;
        if (weekTasks_ != other.weekTasks_)
            return false;
        return true;
    }

}
