/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * task select tag.
 * 
 * @author yosuke
 * 
 */
@Bean(table = "task_select_tags")
public class TaskSelectTag implements Serializable {
    private static final long serialVersionUID = 2975855832702542519L;
    
    /* id */
    long id_;

    @Column("ID")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* tag id */
    long tagId_;

    @Column("TAG_ID")
    public long getTagId() {
        return tagId_;
    }

    public void setTagId(long tagId) {
        this.tagId_ = tagId;
    }

    /* user id */
    int userId_;

    @Column("USER_ID")
    public int getUserId() {
        return userId_;
    }

    public void setUserId(int userId) {
        this.userId_ = userId;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result + (int) (tagId_ ^ (tagId_ >>> 32));
        result = prime * result + userId_;
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final TaskSelectTag other = (TaskSelectTag) obj;
        if (id_ != other.id_)
            return false;
        if (tagId_ != other.tagId_)
            return false;
        if (userId_ != other.userId_)
            return false;
        return true;
    }
    
}
