/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;
import org.seasar.tugboat.gtd.contents.common.entity.Classification;

/**
 * task select view.
 * 
 * @author yosuke
 * 
 */
@Bean(table = "task_select_views")
public class TaskSelectView implements Serializable {
    private static final long serialVersionUID = -3561344282321272119L;

    public TaskSelectView() {
    }

    public TaskSelectView(int classId, int userId) {
        this.classId_ = classId;
        this.userId_ = userId;
    }

    /* id */
    private long id_;

    @Column("ID")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* mode id */
    private int modeId_;

    @Column("MODE_ID")
    public int getModeId() {
        return modeId_;
    }

    public void setModeId(int modeId) {
        this.modeId_ = modeId;
    }

    /* class id */
    private int classId_ = Classification.INBOX;

    @Column("CLASS_ID")
    public int getClassId() {
        return classId_;
    }

    public void setClassId(int classId) {
        this.classId_ = classId;
    }

    /* is visible browser */
    private int isVisibleBrowser_;

    @Column("IS_ViSIBLE_BROWSER")
    public int getIsVisibleBrowser() {
        return isVisibleBrowser_;
    }

    public void setIsVisibleBrowser(int isVisibleBrowser) {
        this.isVisibleBrowser_ = isVisibleBrowser;
    }

    /* selected tab id */
    private int selectedTabId_;

    @Column("SELECTED_TAB_ID")
    public int getSelectedTabId() {
        return selectedTabId_;
    }

    public void setSelectedTabId(int selectedTabId) {
        this.selectedTabId_ = selectedTabId;
    }

    /* user id */
    private long userId_;

    @Column("USER_ID")
    public long getUserId() {
        return userId_;
    }

    public void setUserId(long userId) {
        this.userId_ = userId;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + classId_;
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result + isVisibleBrowser_;
        result = prime * result + modeId_;
        result = prime * result + selectedTabId_;
        result = prime * result + (int) (userId_ ^ (userId_ >>> 32));
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final TaskSelectView other = (TaskSelectView) obj;
        if (classId_ != other.classId_)
            return false;
        if (id_ != other.id_)
            return false;
        if (isVisibleBrowser_ != other.isVisibleBrowser_)
            return false;
        if (modeId_ != other.modeId_)
            return false;
        if (selectedTabId_ != other.selectedTabId_)
            return false;
        if (userId_ != other.userId_)
            return false;
        return true;
    }
    
}
