/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * Task tag.
 * 
 * @author yousuke.hara
 * 
 */
@Bean(table = "task_tags")
public class TaskTag implements Serializable {
    private static final long serialVersionUID = 1751754773961565413L;

    public TaskTag() {
    }

    public TaskTag(int id, String tagValue) {
        this.id_ = id;
        this.tagValue_ = tagValue;
    }

    /* Id */
    private long id_;

    @Column("ID")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* activity id */
    private long activityId_;

    @Column("ACTIVITY_ID")
    public long getActivityId() {
        return activityId_;
    }

    public void setActivityId(long activityId) {
        this.activityId_ = activityId;
    }

    /* task id */
    private long taskId_;

    @Column("TASK_ID")
    public long getTaskId() {
        return taskId_;
    }

    public void setTaskId(long taskId) {
        this.taskId_ = taskId;
    }

    /* tag id */
    private long tagId_;

    @Column("TAG_ID")
    public long getTagId() {
        return tagId_;
    }

    public void setTagId(long tagId) {
        this.tagId_ = tagId;
    }

    /* tag value */
    private String tagValue_;

    @Column("TAG_VALUE")
    public String getTagValue() {
        return tagValue_;
    }

    public void setTagValue(String tagValue) {
        this.tagValue_ = tagValue;
    }

    /* user id */
    private long userId_;

    @Column("USER_ID")
    public long getUserId() {
        return userId_;
    }

    public void setUserId(long userId) {
        this.userId_ = userId;
    }

    /* posted at */
    private String postedAt_;

    @Column("POSTED_AT")
    public String getPostedAt() {
        return postedAt_;
    }

    public void setPostedAt(String postedAt) {
        this.postedAt_ = postedAt;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (activityId_ ^ (activityId_ >>> 32));
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result
                + ((postedAt_ == null) ? 0 : postedAt_.hashCode());
        result = prime * result + (int) (tagId_ ^ (tagId_ >>> 32));
        result = prime * result
                + ((tagValue_ == null) ? 0 : tagValue_.hashCode());
        result = prime * result + (int) (taskId_ ^ (taskId_ >>> 32));
        result = prime * result + (int) (userId_ ^ (userId_ >>> 32));
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final TaskTag other = (TaskTag) obj;
        if (activityId_ != other.activityId_)
            return false;
        if (id_ != other.id_)
            return false;
        if (postedAt_ == null) {
            if (other.postedAt_ != null)
                return false;
        } else if (!postedAt_.equals(other.postedAt_))
            return false;
        if (tagId_ != other.tagId_)
            return false;
        if (tagValue_ == null) {
            if (other.tagValue_ != null)
                return false;
        } else if (!tagValue_.equals(other.tagValue_))
            return false;
        if (taskId_ != other.taskId_)
            return false;
        if (userId_ != other.userId_)
            return false;
        return true;
    }
    
}
