/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;
import java.util.Arrays;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * task 2 task.
 * 
 * @author yosuke
 * 
 */
@Bean(table = "task_to_tasks")
public class TaskToTask implements Serializable {
    private static final long serialVersionUID = -987622525952987769L;
    
    /* id */
    private long id_;

    @Column("ID")
    public long getId() {
        return id_;
    }

    public void setId(long id) {
        this.id_ = id;
    }

    /* source task id */
    private long sourceTaskId_;

    @Column("SRC_TASK_ID")
    public long getSourceTaskId() {
        return sourceTaskId_;
    }

    public void setSourceTaskId(long sourceTaskId) {
        this.sourceTaskId_ = sourceTaskId;
    }

    /* source activity id */
    private int sourceActivityId_;

    @Column("SRC_ACTIVITY_ID")
    public int getSourceActivityId() {
        return sourceActivityId_;
    }

    public void setSourceActivityId(int sourceActivityId) {
        this.sourceActivityId_ = sourceActivityId;
    }

    /* source status id */
    private int sourceStatusId_;

    @Column("SRC_STATUS_ID")
    public int getSourceStatusId() {
        return sourceStatusId_;
    }

    public void setSourceStatusId(int sourceStatusId) {
        this.sourceStatusId_ = sourceStatusId;
    }

    /* source classification id */
    private int sourceClassificationId_;

    @Column("SRC_CLASS_ID")
    public int getSourceClassificationId() {
        return sourceClassificationId_;
    }

    public void setSourceClassificationId(int sourceClassificationId) {
        this.sourceClassificationId_ = sourceClassificationId;
    }

    /* source title */
    private String sourceTitle_;

    @Column("SRC_TITLE")
    public String getSourceTitle() {
        return sourceTitle_;
    }

    public void setSourceTitle(String sourceTitle) {
        this.sourceTitle_ = sourceTitle;
    }

    /* source description */
    private String sourceDescription_;

    @Column("SRC_DESCRIPTION")
    public String getSourceDescription() {
        return sourceDescription_;
    }

    public void setSourceDescription(String sourceDescription) {
        this.sourceDescription_ = sourceDescription;
    }

    /* source due */
    private String sourceDue_;

    @Column("SRC_DUE")
    public String getSourceDue() {
        return sourceDue_;
    }

    public void setSourceDue(String sourceDue) {
        this.sourceDue_ = sourceDue;
    }

    /* source posted at */
    private String sourcePostedAt_;

    @Column("SRC_POSTED_AT")
    public String getSourcePostedAt() {
        return sourcePostedAt_;
    }

    public void setSourcePostedAt(String sourcePostedAt) {
        this.sourcePostedAt_ = sourcePostedAt;
    }

    /* source posted by */
    private String sourcePostedBy_;

    @Column("SRC_POSTED_BY")
    public String getSourcePostedBy() {
        return sourcePostedBy_;
    }

    public void setSourcePostedBy(String sourcePostedBy) {
        this.sourcePostedBy_ = sourcePostedBy;
    }

    /* source posted user id */
    private int sourcePostedUserId_;

    @Column("SRC_POSTED_USER_ID")
    public int getSourcePostedUserId() {
        return sourcePostedUserId_;
    }

    public void setSourcePostedUserId(int sourcePostedUserId) {
        this.sourcePostedUserId_ = sourcePostedUserId;
    }

    /* destination task id */
    private long destinationTaskId_;

    @Column("DEST_TASK_ID")
    public long getDestinationTaskId() {
        return destinationTaskId_;
    }

    public void setDestinationTaskId(long destinationTaskId) {
        this.destinationTaskId_ = destinationTaskId;
    }

    /* destination activity id */
    private long destinationActivityId_;

    @Column("DEST_ACTIVITY_ID")
    public long getDestinationActivityId() {
        return destinationActivityId_;
    }

    public void setDestinationActivityId(long destinationActivityId) {
        this.destinationActivityId_ = destinationActivityId;
    }

    /* destination status id */
    private int destinationStatusId_;

    @Column("DEST_STATUS_ID")
    public int getDestinationStatusId() {
        return destinationStatusId_;
    }

    public void setDestinationStatusId(int destinationStatusId) {
        this.destinationStatusId_ = destinationStatusId;
    }

    /* destination classification id */
    private int destinationClassificationId_;

    @Column("DEST_CLASS_ID")
    public int getDestinationClassificationId() {
        return destinationClassificationId_;
    }

    public void setDestinationClassificationId(int destinationClassificationId) {
        this.destinationClassificationId_ = destinationClassificationId;
    }

    /* destination title */
    private String destinationTitle_;

    @Column("DEST_TITLE")
    public String getDestinationTitle() {
        return destinationTitle_;
    }

    public void setDestinationTitle(String destinationTitle) {
        this.destinationTitle_ = destinationTitle;
    }

    /* destination description */
    private String destinationDescription_;

    @Column("DEST_DESCRIPTION")
    public String getDestinationDescription() {
        return destinationDescription_;
    }

    public void setDestinationDescription(String destinationDescription) {
        this.destinationDescription_ = destinationDescription;
    }

    /* destination posted at */
    private String destinationPostedAt_;

    @Column("DEST_POSTED_AT")
    public String getDestinationPostedAt() {
        return destinationPostedAt_;
    }

    public void setDestinationPostedAt(String destinationPostedAt) {
        this.destinationPostedAt_ = destinationPostedAt;
    }

    /* destination posted by */
    private String destinationPostedBy_;

    @Column("DEST_POSTED_BY")
    public String getDestinationPostedBy() {
        return destinationPostedBy_;
    }

    public void setDestinationPostedBy(String destinationPostedBy) {
        this.destinationPostedBy_ = destinationPostedBy;
    }

    /* destination posted user id */
    private long destinationPostedUserId_;

    @Column("DEST_POSTED_USER_ID")
    public long getDestinationPostedUserId() {
        return destinationPostedUserId_;
    }

    public void setDestinationPostedUserId(long destinationPostedUserId) {
        this.destinationPostedUserId_ = destinationPostedUserId;
    }

    /* destination person in charge id */
    private int destinationPersonInChargeId_;

    @Column("DEST_PERSON_ID")
    public int getDestinationPersonInChargeId() {
        return destinationPersonInChargeId_;
    }

    public void setDestinationPersonInChargeId(int destinationPersonInChargeId) {
        this.destinationPersonInChargeId_ = destinationPersonInChargeId;
    }

    /* destination person in charge name */
    private String destinationPersonInChargeName_;

    @Column("DEST_PERSON_NAME")
    public String getDestinationPersonInChargeName() {
        return destinationPersonInChargeName_;
    }

    public void setDestinationPersonInChargeName(String destinationPersonInChargeName) {
        this.destinationPersonInChargeName_ = destinationPersonInChargeName;
    }

    /* destination due */
    private String destinationDue_;

    @Column("DEST_DUE")
    public String getDestinationDue() {
        return destinationDue_;
    }

    public void setDestinationDue(String destinationDue) {
        this.destinationDue_ = destinationDue;
    }

    /* destination tags */
    private String[] destinationTags_;

    public String[] getDestinationTags() {
        return destinationTags_;
    }

    public void setDestinationTags(String[] destinationTags) {
        this.destinationTags_ = destinationTags;
    }
    
    /* destination task group id */
    private long destinationTaskGroupId_;
    
    public long getDestinationTaskGroupId() {
        return destinationTaskGroupId_;
    }
    public void setDestinationTaskGroupId(long destinationTaskGroupId) {
        this.destinationTaskGroupId_ = destinationTaskGroupId;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime
                * result
                + (int) (destinationActivityId_ ^ (destinationActivityId_ >>> 32));
        result = prime * result + destinationClassificationId_;
        result = prime
                * result
                + ((destinationDescription_ == null) ? 0
                        : destinationDescription_.hashCode());
        result = prime * result
                + ((destinationDue_ == null) ? 0 : destinationDue_.hashCode());
        result = prime * result + destinationPersonInChargeId_;
        result = prime
                * result
                + ((destinationPersonInChargeName_ == null) ? 0
                        : destinationPersonInChargeName_.hashCode());
        result = prime
                * result
                + ((destinationPostedAt_ == null) ? 0 : destinationPostedAt_
                        .hashCode());
        result = prime
                * result
                + ((destinationPostedBy_ == null) ? 0 : destinationPostedBy_
                        .hashCode());
        result = prime
                * result
                + (int) (destinationPostedUserId_ ^ (destinationPostedUserId_ >>> 32));
        result = prime * result + destinationStatusId_;
        result = prime * result + Arrays.hashCode(destinationTags_);
        result = prime * result
                + (int) (destinationTaskId_ ^ (destinationTaskId_ >>> 32));
        result = prime
                * result
                + ((destinationTitle_ == null) ? 0 : destinationTitle_
                        .hashCode());
        result = prime * result + (int) (id_ ^ (id_ >>> 32));
        result = prime * result + sourceActivityId_;
        result = prime * result + sourceClassificationId_;
        result = prime
                * result
                + ((sourceDescription_ == null) ? 0 : sourceDescription_
                        .hashCode());
        result = prime * result
                + ((sourceDue_ == null) ? 0 : sourceDue_.hashCode());
        result = prime * result
                + ((sourcePostedAt_ == null) ? 0 : sourcePostedAt_.hashCode());
        result = prime * result
                + ((sourcePostedBy_ == null) ? 0 : sourcePostedBy_.hashCode());
        result = prime * result + sourcePostedUserId_;
        result = prime * result + sourceStatusId_;
        result = prime * result
                + (int) (sourceTaskId_ ^ (sourceTaskId_ >>> 32));
        result = prime * result
                + ((sourceTitle_ == null) ? 0 : sourceTitle_.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final TaskToTask other = (TaskToTask) obj;
        if (destinationActivityId_ != other.destinationActivityId_)
            return false;
        if (destinationClassificationId_ != other.destinationClassificationId_)
            return false;
        if (destinationDescription_ == null) {
            if (other.destinationDescription_ != null)
                return false;
        } else if (!destinationDescription_
                .equals(other.destinationDescription_))
            return false;
        if (destinationDue_ == null) {
            if (other.destinationDue_ != null)
                return false;
        } else if (!destinationDue_.equals(other.destinationDue_))
            return false;
        if (destinationPersonInChargeId_ != other.destinationPersonInChargeId_)
            return false;
        if (destinationPersonInChargeName_ == null) {
            if (other.destinationPersonInChargeName_ != null)
                return false;
        } else if (!destinationPersonInChargeName_
                .equals(other.destinationPersonInChargeName_))
            return false;
        if (destinationPostedAt_ == null) {
            if (other.destinationPostedAt_ != null)
                return false;
        } else if (!destinationPostedAt_.equals(other.destinationPostedAt_))
            return false;
        if (destinationPostedBy_ == null) {
            if (other.destinationPostedBy_ != null)
                return false;
        } else if (!destinationPostedBy_.equals(other.destinationPostedBy_))
            return false;
        if (destinationPostedUserId_ != other.destinationPostedUserId_)
            return false;
        if (destinationStatusId_ != other.destinationStatusId_)
            return false;
        if (!Arrays.equals(destinationTags_, other.destinationTags_))
            return false;
        if (destinationTaskId_ != other.destinationTaskId_)
            return false;
        if (destinationTitle_ == null) {
            if (other.destinationTitle_ != null)
                return false;
        } else if (!destinationTitle_.equals(other.destinationTitle_))
            return false;
        if (id_ != other.id_)
            return false;
        if (sourceActivityId_ != other.sourceActivityId_)
            return false;
        if (sourceClassificationId_ != other.sourceClassificationId_)
            return false;
        if (sourceDescription_ == null) {
            if (other.sourceDescription_ != null)
                return false;
        } else if (!sourceDescription_.equals(other.sourceDescription_))
            return false;
        if (sourceDue_ == null) {
            if (other.sourceDue_ != null)
                return false;
        } else if (!sourceDue_.equals(other.sourceDue_))
            return false;
        if (sourcePostedAt_ == null) {
            if (other.sourcePostedAt_ != null)
                return false;
        } else if (!sourcePostedAt_.equals(other.sourcePostedAt_))
            return false;
        if (sourcePostedBy_ == null) {
            if (other.sourcePostedBy_ != null)
                return false;
        } else if (!sourcePostedBy_.equals(other.sourcePostedBy_))
            return false;
        if (sourcePostedUserId_ != other.sourcePostedUserId_)
            return false;
        if (sourceStatusId_ != other.sourceStatusId_)
            return false;
        if (sourceTaskId_ != other.sourceTaskId_)
            return false;
        if (sourceTitle_ == null) {
            if (other.sourceTitle_ != null)
                return false;
        } else if (!sourceTitle_.equals(other.sourceTitle_))
            return false;
        return true;
    }
    
}
