/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.page;

/**
 * task detail ajax.
 * 
 * @author yosuke
 * 
 */
public interface TaskDetailAjax {

    /**
     * update task.
     * 
     */
    String update();

    /**
     * get task detail json.
     * 
     * @return
     */
    String getTaskDetailJSON();

    /**
     * add comment.
     * 
     * @return
     */
    String addComment();

    /**
     * get all comments by task id.
     * 
     * @return
     */
    String getAllCommentsByTaskId();

    /**
     * get comment by comment id.
     * 
     * @return
     */
    String getCommentByCommentId();

    /**
     * update comment.
     * 
     * @return
     */
    String updateComment();

    /**
     * delete comment.
     * 
     * @return
     */
    String deleteComment();

    /**
     * add task to tasks.
     * 
     * @return
     */ 
     String addTaskToTasks();
     

    /**
     * get task to tasks and trackbacks json.
     * 
     * @return
     */ 
     String getTaskToTasksAndTrackbacksJSON();
     
     /**
      * remove child task.
      * 
      * @return
      */
     String removeChildTask();
}
