/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.page;

/**
 * task tag ajax.
 * 
 * @author yosuke
 * 
 */
public interface TaskTagAjax {

    /**
     * update tag.
     * 
     * @return
     */
    String update();

    /**
     * find by own tags.
     * 
     * @return
     */
    String findByOwnTags();

    /**
     * find by task id.
     * 
     * @return
     */
    String findByTaskId();

    /**
     * find tags.
     * 
     * @return
     */
    String findTags();

    /**
     * find tags by keyword.
     * 
     * @return
     */
    String findTagsByKeyword();

    /**
     * update by drag and drop.
     * 
     * @return
     */
    String updateByDragnDrop();

}
