/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.timeline.dxo;

import org.seasar.tugboat.gtd.contents.meeting.entity.MeetingAgenda;
import org.seasar.tugboat.gtd.contents.meeting.entity.MeetingAgendaDiscussion;
import org.seasar.tugboat.gtd.contents.meeting.entity.MeetingBasic;
import org.seasar.tugboat.gtd.contents.task.entity.TaskComment;
import org.seasar.tugboat.gtd.contents.task.entity.TaskRelation;
import org.seasar.tugboat.gtd.contents.timeline.entity.xml.Data;

/**
 * calednar dxo.
 * 
 * @author yousuke.hara
 * 
 */
public interface TimelineDxo {

    /**
     * covert timeline datas.
     * 
     * @param tasks
     * @param taskComments
     * @param meetingBasics
     * @param agendas
     * @param discussions
     * @return
     */
    Data convertTimelineDatas(TaskRelation[] tasks, TaskComment[] taskComments,
            MeetingBasic[] meetingBasics, MeetingAgenda[] agendas,
            MeetingAgendaDiscussion[] discussions);
}
