/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.timeline.service;

import org.seasar.tugboat.gtd.contents.timeline.entity.xml.Data;

/**
 * timeline service
 * 
 * @author yousuke.hara
 * 
 */
public interface TimelineService {
    static final int FUNC_TASK = 1;

    static final int FUNC_TASK_COMMENT = 2;

    static final int FUNC_MEETING = 11;

    static final int FUNC_MEETING_AGENDA = 12;

    static final int FUNC_MEETING_COMMENT = 13;

    /**
     * get timeline data by user id.
     * 
     * @param userId
     * @return
     */
    Data getTimelineDataByUserId(long userId);

    /**
     * get timeline data by user id and select functions.
     * 
     * @param userId
     * @param selectFunctions
     * @return
     */
    Data getTimelineDataByUserId(long userId, Integer[] selectFunctions);
}
