/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.user.dto;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.tugboat.gtd.contents.user.entity.User;

/**
 * user dto.
 * 
 * @author yosuke
 * 
 */
public class UserDto extends User implements Serializable {
    private static final long serialVersionUID = 1877019650879340084L;

    public static final String LOGIN_USER_SESSION_ATTRIBUTE_NAME = "loginUser";

    public static final String LOGIN_ADMIN_USER_SESSION_ATTRIBUTE_NAME = "loginAdminUser";

    /* password digest */
    private String passwordDigest_;

    public String getPasswordDigest() {
        return passwordDigest_;
    }

    public void setPasswordDigest(String passwordDigest) {
        this.passwordDigest_ = passwordDigest;
    }

    /* role id */
    private int roleId_;

    public int getRoleId() {
        return roleId_;
    }

    public void setRoleId(int roleId) {
        this.roleId_ = roleId;
    }

    /* role name */
    private String roleName_;

    public String getRoleName() {
        return roleName_;
    }

    public void setRoleName(String roleName) {
        this.roleName_ = roleName;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime * result
                + ((passwordDigest_ == null) ? 0 : passwordDigest_.hashCode());
        result = prime * result + roleId_;
        result = prime * result
                + ((roleName_ == null) ? 0 : roleName_.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!super.equals(obj))
            return false;
        if (getClass() != obj.getClass())
            return false;
        final UserDto other = (UserDto) obj;
        if (passwordDigest_ == null) {
            if (other.passwordDigest_ != null)
                return false;
        } else if (!passwordDigest_.equals(other.passwordDigest_))
            return false;
        if (roleId_ != other.roleId_)
            return false;
        if (roleName_ == null) {
            if (other.roleName_ != null)
                return false;
        } else if (!roleName_.equals(other.roleName_))
            return false;
        return true;
    }
    
}
