/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.user.dto;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.apache.myfaces.custom.fileupload.UploadedFile;
import org.seasar.framework.container.annotation.tiger.Binding;
import org.seasar.framework.container.annotation.tiger.BindingType;

/**
 * user xls dto.
 * 
 * @author yosuke
 * 
 */
public class UserXlsDto implements Serializable {
    private static final long serialVersionUID = -3202357040902196922L;
    
    /* upload file */
    private UploadedFile userXlsFile_;

    public UploadedFile getUserXlsFile() {
        return userXlsFile_;
    }

    /**
     * set user xls file.
     * 
     * @param userXlsFile
     */
    @Binding(bindingType = BindingType.NONE)
    public void setUserXlsFile(UploadedFile userXlsFile) {
        this.userXlsFile_ = userXlsFile;
    }
    
    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result
                + ((userXlsFile_ == null) ? 0 : userXlsFile_.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final UserXlsDto other = (UserXlsDto) obj;
        if (userXlsFile_ == null) {
            if (other.userXlsFile_ != null)
                return false;
        } else if (!userXlsFile_.equals(other.userXlsFile_))
            return false;
        return true;
    }
    
}
