/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.user.dxo;

import org.seasar.tugboat.gtd.contents.user.dto.UserDto;
import org.seasar.tugboat.gtd.contents.user.entity.User;
import org.seasar.tugboat.gtd.contents.user.entity.UserRole;

/**
 * user dxo.
 * 
 * @author yosuke
 * 
 */
public interface UserDxo {
    /**
     * convert user to user dto.
     * 
     * @param user
     * @return user dto
     */
    UserDto convertUserDto(User user);

    /**
     * convert users to user dtos.
     * 
     * @param users
     * @return user dtos
     */
    UserDto[] convertUserDtos(User[] users);

    /**
     * convert user dto to user.
     * 
     * @param userDto
     * @return user
     */
    User convertUser(UserDto userDto);

    /**
     * convert user dtos to users.
     * 
     * @param userDtos
     * @return users
     */
    User[] convertUsers(UserDto[] userDtos);

    /**
     * convert 'user dto' to 'user role'.
     * 
     * @param userDto
     * @return user role
     */
    UserRole convertUserRole(UserDto userDto);
}
