/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.user.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * user role.
 * 
 * @author yosuke
 * 
 */
public class UserRole implements Serializable {
    private static final long serialVersionUID = 3093530390420297975L;
    
    /* id */
    private int id_;

    public int getId() {
        return id_;
    }

    public void setId(int id) {
        this.id_ = id;
    }

    /* role id */
    private int roleId_;

    public int getRoleId() {
        return roleId_;
    }

    public void setRoleId(int roleId) {
        this.roleId_ = roleId;
    }

    /* user id */
    private long userId_;

    public long getUserId() {
        return userId_;
    }

    public void setUserId(long userId) {
        this.userId_ = userId;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + id_;
        result = prime * result + roleId_;
        result = prime * result + (int) (userId_ ^ (userId_ >>> 32));
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final UserRole other = (UserRole) obj;
        if (id_ != other.id_)
            return false;
        if (roleId_ != other.roleId_)
            return false;
        if (userId_ != other.userId_)
            return false;
        return true;
    }
    
}
