/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.mailservices.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * meeting mail.
 * 
 * @author kacchi
 * 
 */
@Bean(table = "meeting_mails")
public class MeetingMail implements Serializable {
    private static final long serialVersionUID = -4796211807669359174L;
    
    /* id */
    private int id;

    @Column("ID")
    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    /* message id */
    private String messageId;

    @Column("message_id")
    public String getMessageId() {
        return messageId;
    }

    public void setMessageId(String messageId) {
        this.messageId = messageId;
    }

    /* sent at */
    private String sentAt;

    @Column("sent_at")
    public String getSentAt() {
        return sentAt;
    }

    public void setSentAt(String sentAt) {
        this.sentAt = sentAt;
    }

    /* sent by */
    private long sentBy;

    @Column("sent_by")
    public long getSentBy() {
        return sentBy;
    }

    public void setSentBy(long sentBy) {
        this.sentBy = sentBy;
    }

    /* meeting basic id */
    private long basicId;

    @Column("basic_id")
    public long getBasicId() {
        return basicId;
    }

    public void setBasicId(long basicId) {
        this.basicId = basicId;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (basicId ^ (basicId >>> 32));
        result = prime * result + id;
        result = prime * result
                + ((messageId == null) ? 0 : messageId.hashCode());
        result = prime * result + ((sentAt == null) ? 0 : sentAt.hashCode());
        result = prime * result + (int) (sentBy ^ (sentBy >>> 32));
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final MeetingMail other = (MeetingMail) obj;
        if (basicId != other.basicId)
            return false;
        if (id != other.id)
            return false;
        if (messageId == null) {
            if (other.messageId != null)
                return false;
        } else if (!messageId.equals(other.messageId))
            return false;
        if (sentAt == null) {
            if (other.sentAt != null)
                return false;
        } else if (!sentAt.equals(other.sentAt))
            return false;
        if (sentBy != other.sentBy)
            return false;
        return true;
    }
    
}
