/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.mailservices.service;

import org.seasar.tugboat.gtd.contents.activity.dto.ActivityDto;
import org.seasar.tugboat.gtd.contents.meeting.dto.MeetingAgendaDto;
import org.seasar.tugboat.gtd.contents.meeting.dto.MeetingBasicDto;
import org.seasar.tugboat.gtd.contents.meeting.dto.MeetingToTaskDto;
import org.seasar.tugboat.gtd.contents.task.dto.TaskCommentDto;
import org.seasar.tugboat.gtd.contents.task.dto.TaskRelationDto;

/**
 * mail service
 * 
 * @author kacchi
 * 
 */
public interface MailService {

    /**
     * send mail(task)
     * 
     * @param taskRelationDto
     * @param taskCommentDtos
     */
    void sendMail(TaskRelationDto taskRelationDto, TaskCommentDto[] taskCommentDtos,
            ActivityDto activityDto, long userId);

    /**
     * send mail(meeting)
     * 
     * @param basicDto
     * @param agendaDtos
     * @param activityDto
     * @param meetingToTaskDto
     * @param userId
     */
    void send(MeetingBasicDto basicDto, MeetingAgendaDto[] agendaDtos, ActivityDto activityDto,
            MeetingToTaskDto[] meetingToTaskDtos, long userId);

}
