/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.webservices.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * feed token.
 * 
 * @author yosuke
 * 
 */
@Bean(table = "feed_tokens")
public class FeedToken implements Serializable {
    private static final long serialVersionUID = 2729251942799855444L;
    
    /* id */
    private int id_;

    @Column("ID")
    public int getId() {
        return id_;
    }

    public void setId(int id) {
        this.id_ = id;
    }

    /* token */
    private String token_;

    @Column("TOKEN")
    public String getToken() {
        return token_;
    }

    public void setToken(String token) {
        this.token_ = token;
    }

    /* user id */
    private long userId_;

    @Column("USER_ID")
    public long getUserId() {
        return userId_;
    }

    public void setUserId(long userId) {
        this.userId_ = userId;
    }

    /* activity id */
    private long activityId_;

    @Column("ACTIVITY_ID")
    public long getActivityId() {
        return activityId_;
    }

    public void setActivityId(long activityId) {
        this.activityId_ = activityId;
    }

    /* created at */
    private String createdAt_;

    @Column("CREATED_AT")
    public String getCreatedAt() {
        return createdAt_;
    }

    public void setCreatedAt(String createdAt) {
        this.createdAt_ = createdAt;
    }

    /* delete flag */
    private String deleteFlag_;

    @Column("DEL_FLAG")
    public String getDeleteFlag() {
        return deleteFlag_;
    }

    public void setDeleteFlag(String deleteFlag) {
        this.deleteFlag_ = deleteFlag;
    }

    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (activityId_ ^ (activityId_ >>> 32));
        result = prime * result
                + ((createdAt_ == null) ? 0 : createdAt_.hashCode());
        result = prime * result
                + ((deleteFlag_ == null) ? 0 : deleteFlag_.hashCode());
        result = prime * result + id_;
        result = prime * result + ((token_ == null) ? 0 : token_.hashCode());
        result = prime * result + (int) (userId_ ^ (userId_ >>> 32));
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final FeedToken other = (FeedToken) obj;
        if (activityId_ != other.activityId_)
            return false;
        if (createdAt_ == null) {
            if (other.createdAt_ != null)
                return false;
        } else if (!createdAt_.equals(other.createdAt_))
            return false;
        if (deleteFlag_ == null) {
            if (other.deleteFlag_ != null)
                return false;
        } else if (!deleteFlag_.equals(other.deleteFlag_))
            return false;
        if (id_ != other.id_)
            return false;
        if (token_ == null) {
            if (other.token_ != null)
                return false;
        } else if (!token_.equals(other.token_))
            return false;
        if (userId_ != other.userId_)
            return false;
        return true;
    }
    
}
