/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.webservices.feeds.atom;

import org.seasar.tugboat.gtd.contents.task.dto.TaskTagDto;

import com.sun.syndication.feed.module.ModuleImpl;

/**
 * task detail item module implements.
 * 
 * @author yosuke
 * 
 */
public class TaskDetailItemModuleImpl extends ModuleImpl implements TaskDetailItemModule {
    private static final long serialVersionUID = -3528284206928525377L;

    public TaskDetailItemModuleImpl() {
        super(TaskDetailItemModule.class, TaskDetailItemModule.URI);
    }

    /* activity color */
    String activityColor_;

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskItemModule#getActivityColor()
     */
    public String getActivityColor() {
        return activityColor_;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskItemModule#setActivityColor(java.lang.String)
     */
    public void setActivityColor(String activityColor) {
        this.activityColor_ = activityColor;
    }

    /* activity id */
    long activityId_;

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskItemModule#getActivityId()
     */
    public long getActivityId() {
        return activityId_;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskItemModule#setActivityId(int)
     */
    public void setActivityId(long activityId) {
        this.activityId_ = activityId;
    }

    /* activity name */
    String activityName_;

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskItemModule#getActivityName()
     */
    public String getActivityName() {
        return activityName_;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskItemModule#setActivityName(java.lang.String)
     */
    public void setActivityName(String activityName) {
        this.activityName_ = activityName;
    }

    /* classification */
    int classificationId_;

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskItemModule#getClassificationId()
     */
    public int getClassificationId() {
        return classificationId_;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskItemModule#setClassificationId(int)
     */
    public void setClassificationId(int classificationId) {
        this.classificationId_ = classificationId;
    }

    /* person in charge first name */
    String personInChargeFirstName_;

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskItemModule#getPersonInChargeFirstName()
     */
    public String getPersonInChargeFirstName() {
        return personInChargeFirstName_;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskItemModule#setPersonInChargeFirstName(java.lang.String)
     */
    public void setPersonInChargeFirstName(String personInChargeFirstName) {
        this.personInChargeFirstName_ = personInChargeFirstName;
    }

    /* person in charge id */
    long personInChargeId_;

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskItemModule#getPersonInChargeId()
     */
    public long getPersonInChargeId() {
        return personInChargeId_;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskItemModule#setPersonInChargeId(int)
     */
    public void setPersonInChargeId(long personInChargeId) {
        this.personInChargeId_ = personInChargeId;
    }

    /* person in charge last name */
    String personInChargeLastName_;

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskItemModule#getPersonInChargeLastName()
     */
    public String getPersonInChargeLastName() {
        return personInChargeLastName_;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskItemModule#setPersonInChargeLastName(java.lang.String)
     */
    public void setPersonInChargeLastName(String personInChargeLastName) {
        this.personInChargeLastName_ = personInChargeLastName;
    }

    /* status id */
    int statusId_;

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskItemModule#getStatusId()
     */
    public int getStatusId() {
        return statusId_;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskItemModule#setStatusId(int)
     */
    public void setStatusId(int statusId) {
        this.statusId_ = statusId;
    }

    /* tags */
    TaskTagDto[] tags_;

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskDetailItemModule#getTags()
     */
    public TaskTagDto[] getTags() {
        return tags_;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskDetailItemModule#setTags(org.seasar.tugboat.gtd.contents.task.entity.Tag[])
     */
    public void setTags(TaskTagDto[] tag) {
        this.tags_ = tag;
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.sun.syndication.feed.CopyFrom#copyFrom(java.lang.Object)
     */
    public void copyFrom(Object arg0) {
        TaskDetailItemModule module = (TaskDetailItemModule) arg0;
        this.setStatusId(module.getStatusId());

        this.setActivityId(module.getActivityId());
        this.setActivityName(module.getActivityName());
        this.setActivityColor(module.getActivityColor());

        this.setClassificationId(module.getClassificationId());

        this.setPersonInChargeId(module.getPersonInChargeId());
        this.setPersonInChargeFirstName(module.getPersonInChargeFirstName());
        this.setPersonInChargeLastName(module.getPersonInChargeLastName());

        this.setTags(module.getTags());
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.sun.syndication.feed.CopyFrom#getInterface()
     */
    public Class<TaskDetailItemModule> getInterface() {
        return TaskDetailItemModule.class;
    }

}
