/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.webservices.feeds.atom;

import org.seasar.tugboat.gtd.contents.common.entity.Classification;
import org.seasar.tugboat.gtd.contents.task.entity.Tag;

import com.sun.syndication.feed.module.Module;

/**
 * task feed plugin module.
 * 
 * @author yosuke
 * 
 */
public interface TaskHeaderFeedModule extends Module {
    public static final String URI = "http://tugboat-gtd.seasar.org/module";

    public static final String NS_TUGBOAT = "tgb";

    public static final String ELEMENT_USER = "user";

    public static final String ELEMENT_CREATED = "created";

    public static final String ELEMENT_NOUNCE = "nonce";

    public static final String ELEMENT_HEADER = "header";

    public static final String ELEMENT_FOLDER = "folder";

    public static final String ELEMENT_TAG = "tag";

    public static final String ATRB_ID = "id";

    public static final String ATRB_NAME = "name";

    public static final String ATRB_NUMBER_OF_COUNT = "number_of_count";

    /**
     * get nounce.
     * 
     * @return
     */
    public String getNonce();

    /**
     * set nounce.
     * 
     * @param nounce
     */
    public void setNonce(String nounce);

    /**
     * get created at.
     * 
     * @return
     */
    public String getCreated();

    /**
     * set created at.
     * 
     * @param created
     */
    public void setCreated(String created);

    /**
     * get classifications.
     * 
     * @return
     */
    public Classification[] getClassifications();

    /**
     * set classifications.
     * 
     * @param classifications
     */
    public void setClassifications(Classification[] classifications);

    /**
     * get tags.
     * 
     * @return
     */
    public Tag[] getTags();

    /**
     * set tags.
     * 
     * @param tags
     */
    public void setTags(Tag[] tags);
}
