/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.webservices.feeds.atom;

import org.seasar.tugboat.gtd.contents.common.entity.Classification;
import org.seasar.tugboat.gtd.contents.task.entity.Tag;

import com.sun.syndication.feed.module.ModuleImpl;

/**
 * task feed module implements.
 * 
 * @author yosuke
 * 
 */
public class TaskHeaderFeedModuleImpl extends ModuleImpl implements TaskHeaderFeedModule {
    private static final long serialVersionUID = 4273344927842365525L;

    public TaskHeaderFeedModuleImpl() {
        super(TaskHeaderFeedModule.class, TaskHeaderFeedModule.URI);
    }

    /* nounce */
    String nonce_;

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.webservices.feeds.atom.TaskHeaderFeedModule#getNonce()
     */
    public String getNonce() {
        return nonce_;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.webservices.feeds.atom.TaskHeaderFeedModule#setNonce(java.lang.String)
     */
    public void setNonce(String nounce) {
        this.nonce_ = nounce;
    }

    /* created at */
    String created_;

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskFeedModule#getCreated()
     */
    public String getCreated() {
        return created_;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskFeedModule#setCreated(java.lang.String)
     */
    public void setCreated(String created) {
        this.created_ = created;
    }

    /* classifications */
    Classification[] classifications_;

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskHeaderFeedModule#getClassifications()
     */
    public Classification[] getClassifications() {
        return classifications_;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskHeaderFeedModule#setClassifications(org.seasar.tugboat.gtd.contents.common.entity.Classification[])
     */
    public void setClassifications(Classification[] classifications) {
        this.classifications_ = classifications;
    }

    /* tags */
    Tag[] tags_;

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskHeaderFeedModule#getTags()
     */
    public Tag[] getTags() {
        return tags_;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.syndication.feed.module.task.TaskHeaderFeedModule#setTags(org.seasar.tugboat.gtd.contents.task.entity.Tag[])
     */
    public void setTags(Tag[] tags) {
        this.tags_ = tags;
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.sun.syndication.feed.CopyFrom#copyFrom(java.lang.Object)
     */
    public void copyFrom(Object arg0) {
        TaskHeaderFeedModule module = (TaskHeaderFeedModule) arg0;
        this.setNonce(module.getNonce());
        this.setCreated(module.getCreated());
        this.setClassifications(module.getClassifications());
        this.setTags(module.getTags());
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.sun.syndication.feed.CopyFrom#getInterface()
     */
    public Class<TaskHeaderFeedModule> getInterface() {
        return TaskHeaderFeedModule.class;
    }

}
