package org.seasar.tugboat.gtd.webservices.helper;

import org.seasar.tugboat.gtd.contents.activity.dto.ActivityDto;
import org.seasar.tugboat.gtd.contents.activity.dto.ActivityMemberDto;
import org.seasar.tugboat.gtd.contents.task.dto.TaskRelationDto;
import org.seasar.tugboat.gtd.contents.user.dto.UserDto;

/**
 * task web service helper.
 * 
 * @author yosuke
 * 
 */
public interface WebServiceHelper {

    /**
     * created secure info.
     * 
     * @param acceptType
     * @param nonce
     * @param createdAt
     * @return
     */
    String createSecureInfo(String acceptType, String nonce, String createdAt);

    /**
     * create content.
     * 
     * @param acceptType
     * @param taskRelaiton
     * @return
     */
    String createContentForTask(String acceptType, TaskRelationDto taskRelaiton);

    /**
     * create content.
     * 
     * @param acceptType
     * @param taskRelaitons
     * @return
     */
    String createContentForTask(String acceptType, TaskRelationDto[] taskRelaitons);

    /**
     * create folder records.
     * 
     * @param acceptType
     * @param taskRelation
     * @return
     */
    String createFolderRecords(String acceptType, TaskRelationDto taskRelation);

    /**
     * create activities.
     * 
     * @param activities
     * @return
     */
    String createActities(String acceptType, ActivityDto[] activities);

    /**
     * create activity members.
     * 
     * @param acceptType
     * @param members
     * @return
     */
    String createActivityMembers(String acceptType, ActivityMemberDto[] members);

    /**
     * create acitivity member.
     * 
     * @param acceptType
     * @param member
     * @return
     */
    String createActivityMember(String acceptType, ActivityMemberDto member);

    /**
     * create suggested list.
     * 
     * @param acceptType
     * @param members
     * @return
     */
    String createSuggestedList(String acceptType, UserDto[] members);
}