/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.webservices.service;

/**
 * activity member webservice.
 * 
 * @author yosuke
 * 
 */
public interface ActivityMemberWebService {

    /**
     * find by id.
     * 
     * @return
     */
    String findByActivityAndUser();

    /**
     * find by activity.
     * 
     * @return
     */
    String findByActivity();

    /**
     * find by activities.
     * 
     * @return
     */
    String findByActivities();

    /**
     * find by belong activities.
     * 
     * @return
     */
    String findByBelongActivities();

    /**
     * find all members.
     * 
     * @return
     */
    String findAllMembers();

    /**
     * suggest members.
     * 
     * @return
     */
    String suggest();

    /**
     * create.
     * 
     * @return
     */
    String create();

    /**
     * update.
     * 
     * @return
     */
    String update();

    /**
     * delete.
     * 
     * @return
     */
    String delete();
}
