/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.webservices.service;

import org.seasar.tugboat.gtd.webservices.entity.FeedToken;

/**
 * feed token service.
 * 
 * @author yosuke
 * 
 */
public interface FeedTokenService {

    /**
     * create.
     * 
     * @param activityId
     * @param userId
     * @return - feed token.
     */
    String create(long activityId, long userId);
    
    /**
     * create.
     * 
     * @param userId
     * @return
     */
    String create(long userId);

    /**
     * reset.
     * 
     * @param activity
     * @param userId
     * @return - feed token.
     */
    String reset(long activityId, long userId);

    /**
     * delete activity id and user id.
     * 
     * @param activityId
     * @param userId
     * @return
     */
    void deleteByActivityIdAndUserId(long activityId, long userId);

    /**
     * delete by activity id.
     * 
     * @param activityId
     */
    void deleteByActivityId(long activityId);

    /**
     * find by activity id and token (for rss servlet).
     * 
     * @param activityId
     * @param token
     * @return
     */
    FeedToken findByActivityIdAndToken(long activityId, String token);
    
    /**
     * find by token (for rss servlet).
     * 
     * @param token
     * @return
     */
    FeedToken findByToken(String token);
}
