/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.webservices.service;

/**
 * task web service.
 * 
 * @author yosuke
 * 
 */
public interface TaskWebService {

    /**
     * find by id.
     * 
     * @return
     */
    String find();

    /**
     * find all.
     * 
     * @return
     */
    String findAll();

    /**
     * find by query params.
     * 
     * @return
     */
    String findByQueryParams();

    /**
     * find by tags.
     * 
     * @return
     */
    String findByTags();

    /**
     * create task.
     * 
     * @return
     */
    String create();

    /**
     * get folder records.
     * 
     * @return
     */
    String getFolderRecords();

    /**
     * update task.
     * 
     * @return
     */
    String update();

    /**
     * update classification id.
     * 
     * 
     * @return
     */
    String updateClassificationId();

    /**
     * delete task.
     * 
     * @return
     */
    String delete();

    /**
     * empty trash.
     * 
     * @return
     */
    String emptyTrash();

}
