/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
Tugboat.gtd_common = {
  FUNC_TYPE_TASK     : 'T',
  FUNC_TYPE_MEETING  : 'L',
  FUNC_TYPE_ACTIVITY : 'A',
  BROWSER_HEIGHT : 122,
  
  _is_ie6 : false,
  _is_initialized : false,
  _before_selected_list_id : null,
  

  /**
   * toggle browser area. #show/#hide
   */
  toggle_browser_area : function() {
    var display = $('browser_pane').style.display;
    Tugboat.gtd_common.resize_list_area(
      display == Tugboat.constant.STYLE_DISPLAY_NONE, true);
    Element.toggle('browser_pane');
  },

  /**
   * block select
   * @param {Object} object
   */
  block_select : function(object) {
    object.blur();
    if (object.className == 'layout_blocks_icon') {
      //expand list -> collapse list.
      var args = $$('div.detailContainer');
      args.each(
        function(a) {
          a.style.display = 'none';
          
          var id = a.id.substring('list_detail_container-'.length);
          $('gtd_list_'+id).className = 'default';
        }
      );
      // mode change
      $('layout_block').className = 'layout_blocks_icon_inactive';
      $('layout_list').className   = 'layout_list_icon';
      
      $('list_pane').removeClassName('gtdList');
      $('list_pane').toggleClassName('block_mode');

      if ($('list_top'))    $('list_top').className     = 'gtdBox clearfix';
      if ($('list_middle')) $('list_middle').className  = 'gtdBox clearfix';
      if ($('list_bottom')) $('list_bottom').className  = 'gtdBox clearfix';

      $('list_column_header').style.display = Tugboat.constant.STYLE_DISPLAY_NONE;
      $('list_pane').style.height = 
        Number($('list_pane').style.height.replace('px','')) + 21 + 'px';
        
      Tugboat.gtd_common._before_selected_list_id = null;
    }
  },
  
  /**
   * list select
   * @param {Object} object
   */
  list_select : function(object) {
    object.blur();
    if (object.className == 'layout_list_icon') {
      $('layout_block').className = 'layout_blocks_icon';
      $('layout_list').className   = 'layout_list_icon_inactive';
      $('list_pane').className = 'gtdList';

      if ($('list_top'))    $('list_top').className     = 'gtdList clearfix';
      if ($('list_middle')) $('list_middle').className  = 'gtdList clearfix';
      if ($('list_bottom')) $('list_bottom').className  = 'gtdList clearfix';

      $('list_column_header').style.display = Tugboat.constant.STYLE_DISPLAY_BLOCK;
    }
  },
  
  /**
   * show folder's area.
   */
  _show : function() {
    $('folders_pane').style.display = Tugboat.constant.STYLE_DISPLAY_BLOCK;
    $('folders_pane').style.width = '130px';
    $('main_pane').style.width    = '790px';
  },
    
  /**
   * hide folder's area.
   */
  _hide : function() {
    $('folders_pane').style.display = Tugboat.constant.STYLE_DISPLAY_NONE;
    $('folders_pane').style.width = '0px';
    $('main_pane').style.width    = '920px';
  },
  
  /**
   * create list dom.
   * @param {Object} transport
   * @param {Object} functionType
   * @param {Object} is_selected_archives
   */
  create_list_dom : function(transport, functionType, is_selected_archives) {
    var self = Tugboat.gtd_common;
    self._is_ie6 = navigator.userAgent.indexOf('MSIE 6.0') > -1;
    
    $('res_number').innerHTML = '0 results';
    $('res_page').innerHTML   = '1/1 page';
    $('page_prev').className  = 'page_prev_off';
    $('page_next').className  = 'page_next_off';
    
    //
    //-- TASK
    //
    if (functionType == self.FUNC_TYPE_TASK) {
      $('list_top').innerHTML = '';
      $('list_middle').innerHTML = '';
      $('list_bottom').innerHTML = '';
      
      if (Tugboat.gtd_task._current_mode == Tugboat.constant.task.SEL_MODE_GTD.id) {
        Tugboat.gtd_common.task._setup_task_default_folder();
      }
      
      $('list_top_container').style.display =
        is_selected_archives
        ? 'none'
        : Tugboat.constant.task.list_style(
            TugboatUI.DragBox.selected_folder_id, Tugboat.constant.task.STYLE_LIST_TOP);

      $('list_top_caption').style.display = 
        is_selected_archives
        ? 'none'
        : Tugboat.constant.task.get_list_caption_display(
            TugboatUI.DragBox.selected_folder_id, Tugboat.constant.task.STYLE_LIST_TOP);

      $('list_middle_container').style.display =
        is_selected_archives
        ? 'none'
        : Tugboat.constant.task.list_style(
            TugboatUI.DragBox.selected_folder_id, Tugboat.constant.task.STYLE_LIST_MIDDLE);    

      $('list_middle_caption').style.display =
        is_selected_archives
        ? 'none'
        : Tugboat.constant.task.get_list_caption_display(
            TugboatUI.DragBox.selected_folder_id, Tugboat.constant.task.STYLE_LIST_MIDDLE);

      $('list_bottom_container').style.display =
        Tugboat.constant.task.list_style(
          TugboatUI.DragBox.selected_folder_id, Tugboat.constant.task.STYLE_LIST_BOTTOM);

      $('list_bottom_caption').style.display = 
        Tugboat.constant.task.get_list_caption_display(
          TugboatUI.DragBox.selected_folder_id, Tugboat.constant.task.STYLE_LIST_BOTTOM
        );
    }
    //
    //-- MEETING
    //
    else if(functionType == self.FUNC_TYPE_MEETING){
      $('list_top').innerHTML = '';
      $('list_middle').innerHTML = '';
      $('list_bottom').innerHTML = '';
      
      Tugboat.gtd_common.meeting._setup_meeting_default_folder();
      $('list_top').style.display = 'block';
      $('list_middle').style.display = 'block';
      $('list_bottom').style.display = 'block';      
    }
    //
    //-- ACTIVITY
    //
    else if (functionType == self.FUNC_TYPE_ACTIVITY) {
    }
    
    if (Tugboat.isEmpty(transport.responseText)) {
      Tugboat.gtd_common.resize_list_area(false, false);
      if (functionType == self.FUNC_TYPE_TASK) {
        Tugboat.gtd_common.task.resize_option_folder_area();
      }
      return false;   
    }
    json = eval(transport.responseText);
    if (!self._is_ie6) {
      Tugboat.gtd_common.resize_list_area(false, false);
    }
    return (functionType == self.FUNC_TYPE_TASK    ? self.task._create_list_dom(json)    :
            functionType == self.FUNC_TYPE_MEETING ? self.meeting._create_list_dom(json) :
                                                     self.activity._create_list_dom(json));
  },
  
  /**
   * setup page info.
   * 
   * @param {Object} page_info
   */
  _setup_page_info : function(page_info) {
    $('res_number').innerHTML = page_info.results + ' results';
    $('res_page').innerHTML   = 
      (page_info.currentPageNumber <= 0 
        ? '1' : page_info.currentPageNumber) + '/' + page_info.totalPages + ' page';
    
    $('page_prev').className =
      page_info.totalPages        == 1 
   || page_info.currentPageNumber == 1 
      ? 'page_prev_off' : 'page_prev';
      
    $('page_next').className = 
      page_info.totalPages        == 1 
   || page_info.currentPageNumber == page_info.totalPages 
      ? 'page_next_off' : 'page_next';
  },

  /*
   * Task.
   * 
   * 
   */
  task : {
    page_info     : null,
    _title_cells  : [],
    _context_menu : null,

    /**
     * create task list dom.
     * 
     * @param {Object} json
     */
    _create_list_dom : function (json) {
      $('dummy_drop_box').innerHTML = '';

      var ID_PREFIX = 'gtd_list_';
      var is_exists_rules = false;
      TugboatUI.DragBox.folder_rules.each(
        function(rule) {
          if (TugboatUI.DragBox.selected_folder_id == rule.selected_folder_id 
            && rule.draggable_allow_folders.length > 0) {
            is_exists_rules = true;
          }
        }
      );
      var self = Tugboat.gtd_common.task;
      self.page_info = json.page;
      
      Tugboat.gtd_common._setup_page_info(json.page);

      var is_selected_tags = 
        TugboatUI.DragBox.selected_folder_id == Tugboat.constant.task.SEL_MODE_TAG.label;

      var el_main_pane = YAHOO.util.Dom.getRegion('main_pane');
      var title_column_header_width = (el_main_pane.right - el_main_pane.left) - 335;
      if (title_column_header_width < 430) title_column_header_width = 430;
      $('list_column_header_title').style.width = title_column_header_width + 'px';

      self._title_cells = [];
      self._setup_context_menu();

      var ul = null;
      var tasks = json.tasks;
      tasks.each(
        function(t) {
          ul = t.statusId == Tugboat.constant.task.STATUS_TODO.id  ? $('list_top')    :
               t.statusId == Tugboat.constant.task.STATUS_DOING.id ? $('list_middle') : 
                                                                     $('list_bottom');
                                                                  
          var is_folder_all =TugboatUI.DragBox.selected_folder_id == 'folder_all' || is_selected_tags;
          var block_style  = Tugboat.constant.task.block_style(t.statusId, t.classId, t.isMe, is_folder_all);
          var title_cell = null;

          var list =
          LI({'id':ID_PREFIX + t.id, 'class':'default'},
            [
              DIV({'class':block_style.class_name},
                [
                  DIV({'class': Tugboat.constant.task.findFolderByValue(t.classId).icon}),
                  DIV({'id':'task_list_activity-' + t.id,
                       'class':'activity_icon a_' + t.activityColor,
                       'title':'Activity: [' + t.activityName + ']'}),
                  
                  // for block-mode.
                  P({'class':'title'},
                    [
                      A({'id':'task_list_block_title-' + t.id,
                         'class':'block',
                         'onclick': function(){
                            Tugboat.gtd_common._show_block_balloon(
                              null, t.id,  Tugboat.gtd_common.FUNC_TYPE_TASK);
                            this.blur();
                          }
                        }, t.title
                      ),
                      A({
                        'id':'task_list_title-' + t.id, 
                        'class':'list',
                        'href':'javascript:void(0);',
                        'onclick':function(){
                            if ($('list_pane').className.indexOf('block_mode') > -1 ) {
                              return false;
                            } else {
                              self._list_title_onclick(t.id);
                              this.blur();
                            }
                          }
                        }, t.title
                      ) 
                    ]
                  ),
                  
                  // for list-mode.
                  title_cell = P({
                    'id'   :'title_for_list-' + t.id,
                    'class':'title_for_list',
                    'style':'width:' + (title_column_header_width + 10) + 'px'
                    },
                    [
                      function() {
                        return self._create_tag_list_dom(t, 'list');
                      },
                      A({
                        'id'   : 'task_list_title-' + t.id,
                        'class': 'list',
                        'href' : 'javascript:void(0);',
                        'onclick':function(){
                            if ($('list_pane').className.indexOf('block_mode') > -1 ) {
                              return false;
                            } else {
                              self._list_title_onclick(t.id);
                              this.blur();
                            }
                          }
                        }, t.title
                      ) 
                    ]
                  ),
                  P({'id':'task_list_due-' + t.id, 'class':'due'}, (t.due == '' ? 'N/A' : t.due)),
                  P({'class':'personInCharge'}, t.isMe ? '[Me]' : (t.personInChargeLastName + ',' + t.personInChargeFirstName) ),
                  DIV({'id':'pull_down_menu_container-' + t.id,'class':'pull_down_menu'},
                    A({
                      'id':'pull_down_menu_link-' + t.id, 
                      'onclick':function(){
                          self._show_context_menu(
                            t.id, 'pull_down_menu_link-' + t.id, 'gtd_list_' + t.id, t.activityId, t.title);
                        }
                      }
                    )
                  )
                ]
              ),
              DIV({'id':'list_detail_container-' + t.id , 'class':'detailContainer', 'style':'display:none'}),
              DIV({'class':'block_option_info'}, function(){return self._create_tag_list_dom(t, 'block');})
            ]
          );

          list.ondblclick = function() {
            Tugboat.gtd_task.edit_task(t.id);
          };
          ul.appendChild(list);
          
          // setup drag and drop.
          if (! Tugboat.gtd_common._is_ie6 && t.isMe && t.classId != Tugboat.constant.task.CLASS_ARCHIVES) {
            new TugboatUI.DragBox(
              list.id, ID_PREFIX, 'block', t.statusId, t.classId, {'id':t.activityId,'color':t.activityColor});
          }
          self._title_cells.push(title_cell);
        }
      );
      // after process#1.
      if (! Tugboat.gtd_common._is_initialized) {
        Tugboat.gtd_common.task.resize_option_folder_area();
      }
      // after process#2.
      var _new_task_ids = Tugboat.gtd_task.task_group._js_obj_task_ids;
      if (_new_task_ids && _new_task_ids.task_ids) {
        for (var i = 0; i < _new_task_ids.task_ids.length; i++) {
          new Effect.Highlight('gtd_list_' + _new_task_ids.task_ids[i], {duration:2.5});
        }
        Tugboat.gtd_task.task_group._js_obj_task_ids = null;
      }
      
      Tugboat.gtd_common._is_initialized = true;
      Tugboat.gtd_common.resize_list_area(false, false);
      return tasks;
    },
    
    /**
     * setup context menu.
     * 
     */
    _setup_context_menu : function() {
      var self = Tugboat.gtd_common.task;
      if (self._context_menu) return false;
      
      self._context_menu = new TugboatUI.ActionSelector({
        uid : Tugboat.constant.task.UID_TASK_CONTEXT_MENU,
        root_element         : 'list_pane',
        link_element_on_img  : 'images/default/icon/link_arrow_down_active.gif',
        link_element_off_img : 'images/default/icon/link_arrow_down_inactive.gif',
        options:{
          row_default_class_name  : 'default',
          row_selected_class_name : 'default selected'
        },
        on_selected : function(task_id, action_id, options) {
          switch (action_id) {
            case Tugboat.constant.task.MENU_ID_DIVIDE:
              Tugboat.gtd_task.task_group._show_divide_sub_window(
                task_id, options.activity_id, options.task_title);
              break;
            case Tugboat.constant.task.MENU_ID_EDIT:
              Tugboat.gtd_task.edit_task(task_id);
              break;
            case Tugboat.constant.task.MENU_ID_DETAIL: break;
            case Tugboat.constant.task.MENU_ID_TODO:
            case Tugboat.constant.task.MENU_ID_DOING:
            case Tugboat.constant.task.MENU_ID_DONE:
            case Tugboat.constant.task.MENU_ID_WEEK:
            case Tugboat.constant.task.MENU_ID_MONTH:
            case Tugboat.constant.task.MENU_ID_HOLD:
            case Tugboat.constant.task.MENU_ID_HOLD_DONE:
            case Tugboat.constant.task.MENU_ID_SOMEDAY:
            case Tugboat.constant.task.MENU_ID_TRASH:
              var status_id =
                action_id == 11                    ? 1 :
                action_id == 12                    ? 2 :
                action_id == 13 || action_id == 43 ? 3 :
                                                     1;
              var class_id =
                action_id == 11  ? 1 :
                action_id == 12  ? 1 :
                action_id == 13  ? 1 :
                action_id == 2   ? 2 :
                action_id == 3   ? 3 :
                action_id == 4   ? 4 :
                action_id == 43  ? 4 :
                action_id == 5   ? 5 :
                action_id == 99  ? 99 
                                 : 0;
              Tugboat.gtd_task.browser.update_classification(task_id, status_id, class_id);
              break;
          }
        }
      });
      self._context_menu.items = Tugboat.constant.task.TASK_CONTEXT_MENU_ITEMS;
    },
    
    /**
     * show context menu.
     * 
     * @param {Object} task_id
     * @param {Object} link_element
     * @param {Object} row_element
     * @param {Number} activity_id
     * @param {String} task_title
     */
    _show_context_menu : function(task_id, link_element, row_element, activity_id, task_title) {
      var self = Tugboat.gtd_common.task;
      self._context_menu.show(
        task_id, link_element, row_element, null, null, {'activity_id':activity_id, 'task_title':task_title});
    },
    
    /**
     * create tag list dom.
     * 
     * @param {Object} t
     * @param {String} mode - [block/list]
     */
    _create_tag_list_dom : function(t, mode) {
      if (!t.tags && t.taskGroupId == 0) {
        return (P({'id': 'gtd_tags_' + mode + '-' + t.id, 'class': 'tag'}, ''));
      }
      
      var options = [];
      if (t.taskGroupId > 0) {
        options.push(
          A({
            'id'     : 'gtd_tags_link_group_' + mode + '_' + t.id + '-' +  t.taskGroupId,
            'class'  : 'group',
            'href'   : 'javascript:void(0);',
            'onclick':function(){
                var group = Tugboat.gtd_task.task_group;
                group.task_group_tab_onclick();
                group._select_todo_by_group_id(t.taskGroupId, t.taskGroupName);
                this.blur();
              }
            },t.taskGroupName
          )
        );
      }
      if (t.tags) {
        t.tags.each(function(tag){
          var tag_id = tag.tagId;
          options.push(
            A({
              'id'      : 'gtd_tags_link_tag_' + mode + '_' + t.id + '-' + tag.tagId,
              'href'    : 'javascript:void(0);',
              'class'   : 'tag',
              'onclick' : function(){
                  var tag = Tugboat.gtd_task.tag; 
                  tag.tag_tab_onclick();
                  tag.tag_onclick(tag_id);
                  this.blur();
                }
              },tag.tagValue
            )
          );
        });
      }
      return options;
    },
    
    /**
     * list title onclick.
     * 
     * @param {Number} id
     */
    _list_title_onclick : function(id) {
      var element = $('list_detail_container-' + id);
      element.innerHTML = '';
      
      var display = element.style.display;
      element.style.display = (display=='none' ? 'block' : 'none');
      $('gtd_list_'+id).className = (display=='none' ? 'default expanded' : 'default');

      if (display == 'block') {
        if (Tugboat.gtd_common._before_selected_list_id
         && id == Tugboat.gtd_common._before_selected_list_id.id) {
          
          Tugboat.gtd_common._before_selected_list_id = null;
        }
        return false;
      }

      // get data. same create balloon.
      Tugboat.gtd_task.progress.open();
      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        {   
          method: Tugboat.constant.REQUEST_GET,
          parameters: 
          {
            component: 'taskAjax',
            action   : 'getTaskForBalloonJSON',
            id       : id
          },
          onComplete: function(transport){
            if (Tugboat.isEmpty(transport.responseText)) return false;

            var self = Tugboat.gtd_common.task;
            
            if (Tugboat.gtd_common._before_selected_list_id
             && $(Tugboat.gtd_common._before_selected_list_id.title_id)) {

              $(Tugboat.gtd_common._before_selected_list_id.title_id).className = 'default';
              $(Tugboat.gtd_common._before_selected_list_id.detail_id).style.display = 'none'; 
            }
            var json = eval('(' + transport.responseText + ')');
                        
            self._list_title_create_dom(json);
            self._get_task_to_tasks_json(id, $('list_detail_link-' + id));
            
            Tugboat.gtd_common._before_selected_list_id = 
              {id:id, title_id:'gtd_list_' + id, detail_id:'list_detail_container-' + id};
              
            Tugboat.gtd_task.progress.close();
          }
        }
      );
    },
    
    /**
     * create list title's dom.
     * 
     * @param {Object} json
     */
    _list_title_create_dom : function(json) {
      var self = Tugboat.gtd_common.task;
      var table = 
      FORM(null,
        TABLE({'class':'tableStyleB'},
          TBODY(null,
          [
            TR(null,
              [
                TH(null,'Title:'),
                TD(null,
                  [
                  A({'id'  :'task_summary_title-'    + json.task.id,
                     'href':'gtdTaskDetail.html?id=' + json.task.id},
                    [
                      json.task.title,
                      IMG({'src':'images/default/icon/lastpost.gif', 'class':'left_and_right_5px_margin'})   
                    ]
                   )
                  ]
                )
              ]
            ),
            TR(null,
              [
                TH(null,'Discription:'),
                  TD(null,
                  function() { 
                    var p = P({'id':'task_summary_description-' + json.task.id, 'class':'description'});
                    p.innerHTML = json.task.description.replace(/\x0D\x0A|\x0D|\x0A/g,'<br/>');
                    return p;
                  }
                )
              ]
            ),

            TR(null,
              [
                TH(null,'Folder:'),
                TD(null,
                  [
                    IMG({'class':'left_and_right_3px_margin',
                         'src'  :'images/default/folder/gif/' + Tugboat.constant.task.class_value_by_class_and_status(
                                                                  json.task.classId, json.task.statusId).icon
                      }
                    ),
                    SPAN(null,Tugboat.constant.task.class_value_by_class_and_status(json.task.classId, json.task.statusId).label)
                  ]
                )
                 
              ]
            ),
            
            TR(null,
              [
                TH(null,'Acitivity:'),
                TD(null,
                  [
                    IMG({'class':'left_and_right_3px_margin', src:'images/default/palette/sphere/pl_' + json.task.activityColor + '_12x12.png'}),
                    SPAN(null,json.task.activityName)
                  ]
                )
              ]
            ),
            
            TR(null,
              [
                TH(null,'Person in charge:'),
                TD(null, json.task.personName )
              ]
            ),
            
            TR(null,
              [
                TH(null,'Due:'),
                TD({'id':'task_summary_due-' + json.task.id}, Tugboat.isEmpty(json.task.dueFormated) ? 'N/A' : json.task.dueFormated )
              ]
            ),
            
            TR(null,
              [
                TH(null,'Link:'),
                TD(null,
                  UL({'id':'list_detail_link-'+json.task.id})
                )
              ]
            ),
            TR(null,
              [
                TH(null,'Group/Tags:'),
                TD(null,
                  [
                    DIV({'id':'list_detail_tags-'+json.task.id},
                      [
                        function() {
                          if (!json.tags && json.task.taskGroupId == 0) return null;
                          
                          var tags = [];
                          if (json.task.taskGroupId > 0) {
                            tags.push(SPAN({'class':'group_text'},json.task.taskGroupName))
                          }
                          if (json.tags) {
                            for (i = 0; i < json.tags.length; i++) {
                              tags.push(SPAN({
                                'class': 'tag_text'
                              }, json.tags[i].tagValue))
                            }
                          }
                          return tags;
                        }
                      ]
                    )
                  ]
                )
              ]
            ),
            TR(null,
              [
                TH(null),
                TD(null,
                  [
                    P({'style':'line-height:1.5; text-align:left; color:#666;'},
                      'Permalink: ' + document.URL.replace(/view\/.*/,'browse/tasks/' + json.task.id)
                    ),
                    A({'href':'javascript:void(0);', 
                       'onclick':function(){Tugboat.gtd_task.edit_task(json.task.id);}}, 'quick edit'),
                    SPAN({'style':'padding-left:15px;'},'Created by ' + json.task.postedBy + ' at ' + json.task.postedAt),
                    P({'style':'line-height:1.5; text-align:right;'},
                      A({'href':'javascript:void(0);', 
                         'style':'padding-right:5px;',
                         'onclick':function(){
                           $('list_detail_container-' + json.task.id).style.display = 'none';
                           $('gtd_list_' + json.task.id).className = 'default';
                          }
                        }, '[x] close'
                      )
                    )
                  ]
                )
              ]
            )
          ]
          )
        )
      );
      $('list_detail_container-' + json.task.id).appendChild(table);
      $('task_summary_title-' + json.task.id).focus();
    },

    /**
     * setup task default folder.
     */
    _setup_task_default_folder : function() {
      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        {
          method: Tugboat.constant.REQUEST_GET,
          parameters:
          {
            component:'taskAjax',
            action   :'getDefaultFolderTasks'
          },
          onComplete: function(transport){
            var json = eval('(' + transport.responseText + ')');
            if (! json) return;

            $('task_folder_all').innerHTML     = json.allTasks;
            $('task_folder_inbox').innerHTML   = json.inboxTasks;
            $('task_folder_today').innerHTML   = json.todayTasks;
            $('task_folder_week').innerHTML    = json.weekTasks;
            $('task_folder_month').innerHTML   = json.monthTasks;
            $('task_folder_hold').innerHTML    = json.holdTasks;
            $('task_folder_someday').innerHTML = json.somedayTasks;

            $('task_today_todo').innerHTML     = json.todayToDoTasks;
            $('task_today_doing').innerHTML    = json.todayDoingTasks;
            $('task_today_done').innerHTML     = json.todayDoneTasks;

            $('task_folder_archives').innerHTML= json.archiveTasks;
            $('task_folder_trash').innerHTML   = json.trashBoxTasks;
          }
        }
      );
    },
  
    /**
     * setup task droppables.
     */
    _setup_task_droppables : function() {
      if (Tugboat.gtd_common._is_ie6 || TugboatUI.DragBox.drop_target_styles.length > 0) return false;

      new YAHOO.util.DDTarget(Tugboat.constant.task.FOLDER_INBOX.id,      'block');
      new YAHOO.util.DDTarget(Tugboat.constant.task.FOLDER_TODAY.id,      'block');
      new YAHOO.util.DDTarget(Tugboat.constant.task.FOLDER_WEEK.id,       'block');
      new YAHOO.util.DDTarget(Tugboat.constant.task.FOLDER_MONTH.id,      'block');
      new YAHOO.util.DDTarget(Tugboat.constant.task.FOLDER_HOLD.id,       'block');
      new YAHOO.util.DDTarget(Tugboat.constant.task.FOLDER_SOMEDAY.id,    'block');
      new YAHOO.util.DDTarget(Tugboat.constant.task.FOLDER_TODAY_TODO.id, 'block');
      new YAHOO.util.DDTarget(Tugboat.constant.task.FOLDER_TODAY_DOING.id,'block');
      new YAHOO.util.DDTarget(Tugboat.constant.task.FOLDER_TODAY_DONE.id, 'block');
      new YAHOO.util.DDTarget(Tugboat.constant.task.FOLDER_TRASH_BOX.id,  'block');
      
      new YAHOO.util.DDTarget('list_top',   'block');
      new YAHOO.util.DDTarget('list_middle','block');
      new YAHOO.util.DDTarget('list_bottom','block');
      
      TugboatUI.DragBox.drop_target_styles = Tugboat.constant.task.droppable_target_style();
      TugboatUI.DragBox.folder_rules = Tugboat.constant.task.droppable_folder_rules();
    },

    /**
     * create task balloon.
     * @param {Object} transport
     */
    _create_balloon : function(transport) {
      var json = eval('(' + transport.responseText + ')');
      
      //-- title.
      var titleAreaHtml = '';
      titleAreaHtml += '<a id="block_balloon_item_' + json.task.id
                     + '" href="gtdTaskDetail.html?id='+ json.task.id + '">'
                     + json.task.title 
                     + '</a>';
      $('block_balloon_item_title').innerHTML = titleAreaHtml;
     
      //-- icons.
      var self = Tugboat.gtd_common.task;
     
      var folder_info =
        Tugboat.constant.task.class_value_by_class_and_status(json.task.classId, json.task.statusId);
    
      var iconsAreaHtml = '';
      iconsAreaHtml += '&nbsp;<img src="images/default/folder/gif/' + folder_info.icon + '" class="left_and_right_3px_margin" />';
      iconsAreaHtml += folder_info.label;

      iconsAreaHtml += '&nbsp;<img class="left_and_right_3px_margin" ';
      iconsAreaHtml += 'src="images/default/palette/sphere/pl_' + json.task.activityColor + '_12x12.png" />';
      iconsAreaHtml += json.task.activityName;
     
      $('block_balloon_item_icons').innerHTML = iconsAreaHtml;
     
      var personInCharge = 'Person In Charge: ' + json.task.personName;
      $('detail_balloon_option_1').innerHTML = personInCharge;
      
      var due = 'Due: ' 
	    + (Tugboat.isEmpty(json.task.dueFormated) ? 'N/A' : json.task.dueFormated);
      $('detail_balloon_option_2').innerHTML = due;
      
      // setup tags.
      var balloon_item_tags = $('block_balloon_item_tags');
      balloon_item_tags.innerHTML = '';
      
      var tagsText = '';
      var tag_span_elements = [];
      
      if (json.task.taskGroupId > 0) {
        tag_span_elements.push(SPAN({'class':'group_text'}, json.task.taskGroupName));
      }
      if (json.tags) {
        for (i=0; i<json.tags.length; i++) {
          var tag = json.tags[i].tagValue;
          tag_span_elements.push(SPAN({'class':'tag_text'}, tag));
        }
      }
      var tag_values_container = 
        DIV({'id':'tag_values_container_' + json.task.id, 'style':'float:left'});

      if (tag_span_elements) {
        tag_span_elements.each(
          function(e) {
            tag_values_container.appendChild(e);
          }
        );
      }
      balloon_item_tags.appendChild(tag_values_container);
      
      // setup posted at.
      $('block_balloon_edit_link').onclick = function() {
        Tugboat.gtd_task.edit_task(json.task.id);
      }
      
      $('block_balloon_item_posted').innerHTML = 
        'Created by ' + json.task.postedBy + ' at ' + json.task.postedAt;
      
      var self = Tugboat.gtd_common.task;
      self._get_task_to_tasks_json(
        json.task.id, $('block_balloon_item_links_list'));

      $('block_balloon_item_' + json.task.id).focus();
    },
    
    /**
     * get task to tasks and trackbacks.
     * 
     * @param {Number} taskId
     * @param {Object} ulElement
     */
    _get_task_to_tasks_json : function(taskId, ulElement) {
      var self = Tugboat.gtd_common.task;
      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        { 
          method: Tugboat.constant.REQUEST_POST,
          parameters:
          {
            component :'taskDetailAjax',
            action    :'getTaskToTasksAndTrackbacksJSON',
            id        :taskId
          },
          onComplete: function(transport){
            ulElement.innerHTML = '';
            
            if (!transport.responseText || transport.responseText == 'null') {
              return false;
            }
            var json = eval(transport.responseText);
            
            //-- related tasks.
            if (json.taskToTasks) {
              json.taskToTasks.each(
                function (t) {
                  if (taskId == t.destinationTaskId) {
                    var li =
                    LI({'class':'oneliner'},
                      [
                      IMG({'src':'images/default/icon/chart_organisation_parent.gif','class':'left_and_right_3px_margin'}),
                      A(
                        { 'href':'gtdTaskDetail.html?id=' + t.sourceTaskId + '&sid=' + Tugboat.dateSerialize(new Date())
                        },t.sourceTitle
                      )
                      ]
                    );
                    ulElement.appendChild(li);
                  }
                }
              );
            
              //-- task to tasks.
              json.taskToTasks.each(
                function (t) {
                  if (taskId == t.sourceTaskId) {
                    var li =
                    LI({'class':'oneliner'},
                      [
                      IMG({'src':'images/default/icon/chart_organisation_child.gif','class':'left_and_right_3px_margin'}),
                      A(
                        { 'href':'gtdTaskDetail.html?id=' + t.destinationTaskId + '&sid=' + Tugboat.dateSerialize(new Date())
                        },t.destinationTitle
                      )
                      ]
                    );
                    ulElement.appendChild(li);
                  }
                }
              );
            }
            
            //-- meeting to tasks.
            if (json.meetingToTasks) {
              json.meetingToTasks.each(
                function(t) {
                  var li =
                  LI({'class':'oneliner'},
                    [
                    IMG({'src':'images/default/icon/contact_group.gif','class':'left_and_right_3px_margin'}),
                    A(
                      { 'href':'gtdMeetingDetail.html?id=' + t.basicId + '&sid=' + Tugboat.dateSerialize(new Date())
                      },t.meetingTitle
                    )
                    ]
                  );
                  ulElement.appendChild(li);
                }
              );
            }            
          }
        }
      );
    },
    
    /**
     * resize option foloder area.
     * 
     */
    resize_option_folder_area : function() {
      var folder_pane    = YAHOO.util.Dom.getRegion('folders_pane');
      var option_container = YAHOO.util.Dom.getRegion('option_container');
      
      $('option_container').style.height =
        (folder_pane.bottom - option_container.top - 22) + 'px';
        
      $('task_group_list').style.height =
        (folder_pane.bottom - option_container.top - 22 - 40) + 'px';
        
      $('task_group_archive_pane').style.height =
        (folder_pane.bottom - option_container.top - 22 - 20) + 'px';
    }
  },
  
  /*
   * Meeting.
   * 
   * 
   */
  meeting : {
    LM_STATUS_NEW  : 1,
    LM_STATUS_OPEN : 2,
    LM_STATUS_DONE : 3,
    _lm_status : [
      {id:1, value:'New',   icon:'images/default/folder/gif/status_todo.gif'},
      {id:2, value:'Open',  icon:'images/default/folder/gif/marker.gif'},
      {id:3, value:'Close', icon:'images/default/folder/gif/status_done.gif'}
    ],
    _find_lm_status : function(id) {
      var status = Tugboat.gtd_common.meeting._lm_status.find( function(s){
        return (id == s.id);
      });
      return status;
    },
    
    /**
     * setup meeting default folder.
     */
    _setup_meeting_default_folder : function() {
      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        { 
          method: Tugboat.constant.REQUEST_POST,
          parameters:
          {
            component:'meetingAjax',
            action   :'getFolderMeetingCountJson'
          },
          onComplete: function(transport){
            var json = eval('(' + transport.responseText + ')');
            if (! json) return;
          
            $('folder_all_count').innerHTML      = json.libraryCount;          
            $('folder_archives_count').innerHTML = json.archivesCount;
          }
        }
      );
    },

    /**
     * create meeting list dom.
     * @param {Object} json
     */
    _create_list_dom : function(json) {
      Tugboat.gtd_common._setup_page_info(json.page);      

      $('dummy_drop_box').innerHTML = '';
      var ID_PREFIX = 'gtd_list_';
      var isThreeSection = true;
      if ($('folder_all').className.indexOf('selected') > -1) {
        Element.show('list_top_container');
        Element.show('list_middle_container');
        Element.hide('list_bottom_container');
      } else {
        Element.hide('list_top_container');
        Element.hide('list_middle_container');
        Element.show('list_bottom_container');
      }
   
      if (! json.meetings) {
        Tugboat.gtd_common.resize_list_area(false, false);
        return false;
      }
   
      var self = Tugboat.gtd_common.meeting;
      var ul = null;
      var meetings = json.meetings;
      meetings.each(
        function(m) {
          if (isThreeSection) {
            ul = m.statusId == self.LM_STATUS_NEW
               ? $('list_top')
               : m.statusId == self.LM_STATUS_OPEN
                 ? $('list_middle')
                 : $('list_bottom');
          }
          appendChildNodes(ul,
            function(){
              var liMeeting = 
              LI({'class':'default', 'id':'gtd_list_' + m.id},
                [
                  DIV(
                    {'class': m.statusId=='1' ? 'meeting meeting_new'  : 
                              m.statusId=='2' ? 'meeting meeting_open' 
                                              : 'meeting meeting_close'
                    },
                    [
                      DIV({'class':'pushpin'}),
                      DIV({'class':m.statusId=='1' ? 'status' :
                                   m.statusId=='2' ? 'status' 
                                                   : 'status done'
                           }),
                      DIV({'class':'activity_icon a_' + m.activityColor, 'title':'Activity: [' + m.activityName + ']'}),
                      P({'class':'title'}, 
                        [
                          A({'class':'block',
                             'href':'javascript:void(0);',
                             'onclick':function(){
                              Tugboat.gtd_common._show_block_balloon(
                                null, m.id,  Tugboat.gtd_common.FUNC_TYPE_MEETING);
                              this.blur();
                            }
                          },m.title),
                          A({'class':'list',
                             'href':'javascript:void(0);',
                             'onclick':function(){
                               self._list_title_onclick(m.id);
                               this.blur();}
                             }, m.title)
                        ]
                      ),
                      P({'class':'posted'}, (m.postedAt + ' / ' +  m.postedByLastName + ',' + m.postedByFirstName))
                    ]
                  ),
                  DIV({'id':'list_detail_container-' + m.id ,
                       'class':'detailContainer',
                       'style':'display:none'})
                ]
              );
              liMeeting.ondblclick = function() {
                if ($('list_pane').className == 'gtdList') return false;
                
                Tugboat.gtd_common._show_block_balloon(
                  null, m.id,  Tugboat.gtd_common.FUNC_TYPE_MEETING);
              };
              return liMeeting;              
            }           
          );
        }
      );
      if (! Tugboat.gtd_common._is_ie6) {
        Tugboat.gtd_common.resize_list_area(false, false);
      }
      return meetings;
    },
    
    /**
     * list title onclick.
     * 
     * @param {Number} id
     */
    _list_title_onclick : function(id) {
      var element = $('list_detail_container-' + id);
      element.innerHTML = '';
      
      var display = element.style.display;
      element.style.display = (display=='none' ? 'block' : 'none');
      $('gtd_list_'+id).className = (display=='none' ? 'default expanded' : 'default');

      if (display == 'block') {
        if (Tugboat.gtd_common._before_selected_list_id
         && id == Tugboat.gtd_common._before_selected_list_id.id) {
          
          Tugboat.gtd_common._before_selected_list_id = null;
        }
        return false;
      }

      new Ajax.Request(
        Tugboat.AJAX_SERVLET_NAME,
        {   
          method: Tugboat.constant.REQUEST_GET,
          parameters: 
          {
            component : 'meetingAjax',
            action    : 'getMeetingBalloonJson',
            id        : id
          },
          onComplete: function(transport){
            if (Tugboat.isEmpty(transport.responseText)) return false;
            
            if (Tugboat.gtd_common._before_selected_list_id) {
              $(Tugboat.gtd_common._before_selected_list_id.title_id).className = 'default';
              $(Tugboat.gtd_common._before_selected_list_id.detail_id).style.display = 'none'; 
            }
            
            var self = Tugboat.gtd_common.meeting;
            var json = eval('(' + transport.responseText + ')');

            Tugboat.gtd_common._before_selected_list_id = 
              {id:id, title_id:'gtd_list_' + id, detail_id:'list_detail_container-' + id};

            self._list_title_create_dom(json);
          }
        }
      );
    },
    
    /**
     * list title create dom.
     * 
     * @param {Object} json
     */
    _list_title_create_dom : function(json) {
      var self = Tugboat.gtd_common.meeting;
      var table = 
			FORM(null,
        TABLE({'class':'tableStyleB'},
          [
          TBODY(null,
            [
              TR(null,
                [
                  TH(null,'Title:'),
                  TD(null,
                    [
                      A({'id':'meeting_summary_title-' + json.id,
                         'href':'gtdMeetingDetail.html?id=' + json.id},
                         [
                           json.title,
                           IMG({'src':'images/default/icon/lastpost.gif', 'class':'left_and_right_5px_margin'})   
                         ]
                      )
                    ]
                  )
                ]
              ),
              TR(null,
                [
                  TH(null,'Activity:'),
                  TD(null,
                    [
                      IMG({'src':'images/default/palette/sphere/pl_' + json.activityColor + '_12x12.png' , 'class':'left_and_right_5px_margin'}),
                      SPAN(null, json.activityName)
                    ]
                  )
                ]
              ),
              TR(null,
                [
                  TH(null,'Discription:'),
                  function() { 
                    var td = TD({'style':'padding-bottom:3px;'});
                    td.innerHTML = json.description.replace(/\x0D\x0A|\x0D|\x0A/g,'<br/>');
                    return td;
                  }
                ]
              ),
              TR(null,
                [
                  TH(null,'Task(s):'),
                  TD({'id':'list_detail_link-' + json.id},

                    UL(null,
                      function() {
                        var link_elements = [];
                        json.links.each(
                          function(j) {
                            var list = LI({'class':'oneliner'});
                            var folder_image = 
                              Tugboat.constant.task.class_value_by_class_and_status(j.taskClassId, j.taskStatusId).icon;

                            list.appendChild(
                              IMG({'class':'left_and_right_3px_margin','border':'0',
                                   'src':'images/default/folder/gif/' + folder_image})
                            );
                            list.appendChild(
                              A({'href':'gtdTaskDetail.html?id=' + j.id}, j.title)
                            );
                            link_elements.push(list);
                          }
                        );
                        return link_elements;
                      }
                    )
                  )
                ]
              ),
              TR(null,
                [
                  TH(null),
                  TD(null,
                    [
                      P({'style':'line-height:1.5; text-align:left; color:#666;'},
                        'Permalink: ' + document.URL.replace(/view\/.*/,'browse/meetings/' + json.id)
                      ),
                      'Created by ' + json.postedBy + ' at ' + json.postedAt,
                      P({'style':'line-height:1.5; text-align:right;'},
                        A({'href':'javascript:void(0);', 
                           'style':'padding-right:5px;',
                           'onclick':function(){
                             $('list_detail_container-' + json.id).style.display = 'none';
                             $('gtd_list_' + json.id).className = 'default';
                            }
                          }, '[x] close'
                        )
                      )
                    ]
                  )
                ]
              )
            ]
            )
          ]
        )
      );
      $('list_detail_container-' + json.id).appendChild(table);
			$('meeting_summary_title-' + json.id).focus();
    },
  
    /**
     * create meeting balloon.
     * @param {Object} transport
     */
    _create_balloon : function(transport) {
      var self = Tugboat.gtd_common.meeting;
      var json = eval('(' + transport.responseText + ')');
      
      //-- title.
      var titleUrl="gtdMeetingDetail.html?id="+json.id;
      var titleAreaHtml = '';
      titleAreaHtml += '<a id="block_balloon_item_' + json.id + '" href="'+titleUrl+'">' + json.title + '</a>';
      $('block_balloon_item_title').innerHTML = titleAreaHtml;

      //-- icons.
      var status = self._find_lm_status(json.statusId);
      var statusIcon = status.icon;
      var statusValue = status.value;
      var iconsAreaHtml = '';
      iconsAreaHtml += '<img src="' + statusIcon + '" class="left_and_right_3px_margin"/>';
      iconsAreaHtml += statusValue;

      iconsAreaHtml += '&nbsp;<img class="left_and_right_3px_margin" ';
      iconsAreaHtml += 'src="images/default/palette/sphere/pl_' + json.activityColor + '_12x12.png" />';
      iconsAreaHtml += json.activityName;      
      $('block_balloon_item_icons').innerHTML = iconsAreaHtml;

      var createdAtHtml = '';
      createdAtHtml = '<p class="left_and_right_3px_margin">Created by ' + json.postedBy + ' at ' + json.postedAt + '</p>';
      $('detail_balloon_option_1').innerHTML = createdAtHtml;    
      $('detail_balloon_option_2').innerHTML = ""; 

      var linksAreaHtml = '<ul>';
      var linkUrl='';
      for(var i = 0; i < json.links.length; i++){
        linkUrl="gtdTaskDetail.html?id=" + json.links[i].id;
        
        var folder_image = 
          Tugboat.constant.task.class_value_by_class_and_status(
            json.links[i].taskClassId, json.links[i].taskStatusId).icon;
        
        linksAreaHtml += '<img src="images/default/folder/gif/' 
                       + folder_image  + '" border="0" class="left_and_right_3px_margin" />';
        
        linksAreaHtml += '<a href="'+linkUrl+'">' + json.links[i].title + '</a><br/>';
      }
      linksAreaHtml += '</ul>';
      $('block_balloon_item_links').innerHTML = linksAreaHtml;      
    
      //-- posted by ... at ...
      $('block_balloon_item_posted').innerHTML = 
        'Posted by ' + json.postedBy + ' at ' + json.postedAt;
				
      $('block_balloon_item_' + json.id).focus();
    }
  },

  activity : {
    page_info : null,
    
    /**
     * create activity list dom.
     * @param {Object} json
     */
    _create_list_dom : function(json) {
      var ul = $('list_top');
      ul.innerHTML = '';
      
      var self = Tugboat.gtd_common.activity;
      self.page_info = json.page;
      Tugboat.gtd_common._setup_page_info(json.page);
     
      var ID_PREFIX = 'gtd_list_';
      var members = json.members;
      members.each(
        function(member) {
          var list = 
            LI({'class':'default', 'id':'gtd_list_'+member.id},
              DIV(
                {'class':'activity'},
                [
                  DIV({'class':'pushpin'}),
                  DIV({'class':'photo'},
                    IMG({'src':'images/default/contacts/contanct.jpg','height':'60','width':'60'})  
                  ),
                  P({'class':'memberLastName'},
                    A({'onclick': function(){
                          Tugboat.gtd_activity.sub_window.editMember_onclick(member);
                        }
                      }, member.lastName
                    )
                  ),
                  P({'class':'memberFirstName'},
                    A({'onclick':function(){
                          Tugboat.gtd_activity.sub_window.editMember_onclick(member);
                        }
                      },member.firstName
                    )
                  ),
                  P({'class':(member.roleId == '1' ? 'memberRole owner' : member.roleId == '2' ? 'memberRole user' : 'memberRole guest')},
                             (member.roleId == '1' ? 'Owner'            : member.roleId == '2' ? 'User'            : 'Guest')),
                  P({'class':'memberFullName'},
                    A({'onclick':function(){
                          Tugboat.gtd_activity.sub_window.editMember_onclick(member);                    
                        }
                      },(member.lastName + ', ' + member.firstName)
                    )
                  ),
                  P({'class':'memberJoined'},member.registeredFormated)
                ]
              )
            );
          list.ondblclick = function() {
            Tugboat.gtd_activity.sub_window.editMember_onclick(member);
          };
          ul.appendChild(list);
        }
      );
    }
  },

  /**
   * resize list area.
   * 
   * @param isVisibleBrowser
   * @param isCallToggleBrowser
   */
  resize_list_area : function(isVisibleBrowser, isCallToggleBrowser) {
    if ($('list_top'))    $('list_top').style.height    = 'auto';
    if ($('list_middle')) $('list_middle').style.height = 'auto';
    if ($('list_bottom')) $('list_bottom').style.height = 'auto';
    
    Element.show('folders_pane');
    Element.show('list_pane');
    Element.show('main_pane');

    var window_size = Tugboat.getPageSize();
    var is_ie6 = Tugboat.gtd_common._is_ie6;
    var is_ie7 = navigator.userAgent.indexOf('MSIE 7.0') > -1;
    //
    // folder area.
    //
    var folder_pane = $('folders_pane');
    var el_menubar_pane = YAHOO.util.Dom.getRegion('menuBar_ul');
    
    folder_pane.style.height =
      (window_size.windowHeight - el_menubar_pane.bottom + (is_ie6 || is_ie7 ? 4 : 0)) + 'px';

    //
    // contents area.
    //
    var main_pnae = $('main_pane');
    var el_folder_pane = YAHOO.util.Dom.getRegion('folders_pane');
    var el_main_pane_width = window_size.windowWidth - (el_folder_pane.left + el_folder_pane.right);
    
    main_pnae.style.width =
      (window_size.windowWidth < 960 ? 770 : (el_main_pane_width + (is_ie6 || is_ie7 ? 4 : 0))) + 'px';
    
    // list/block pane.
    var BROWSER_HEIGHT = Tugboat.gtd_common.BROWSER_HEIGHT;
    var el_gtd_list_pane = YAHOO.util.Dom.getRegion('list_pane');
    var pane_height = 0;
    if (isCallToggleBrowser) {
      pane_height = 
        window_size.windowHeight 
        - el_gtd_list_pane.top + (!isVisibleBrowser && isCallToggleBrowser ? BROWSER_HEIGHT : 0)
        - (isVisibleBrowser ? BROWSER_HEIGHT : 0);
    }
    else {
      var isShownBrowserPane = Element.visible('browser_pane')
      pane_height = window_size.windowHeight - el_gtd_list_pane.top;
    }
  
    if (pane_height < 0) {
      pane_height = 1000;
    }
    $('list_pane').style.height = pane_height + 'px';
    
    // balloon.
    var displayBalloon = $('block_balloon').style.display;
    if (displayBalloon == Tugboat.constant.STYLE_DISPLAY_BLOCK) {
      $('block_balloon').style.display = Tugboat.constant.STYLE_DISPLAY_NONE;
    }
    
    // list bottom resize.
    var display_class_name = $('list_pane').className;
    if (display_class_name == 'block_mode') {
      
      var view_name = $('container').className;
      var elListTopPane    = YAHOO.util.Dom.getRegion('list_top');
      var elListMidPane    = YAHOO.util.Dom.getRegion('list_middle');
      var elListBottomPane = YAHOO.util.Dom.getRegion('list_bottom');
      var elListPaneHeight = YAHOO.util.Dom.getRegion('list_pane');
      
      var is_list_top_container    = Element.visible('list_top_container');
      var is_list_middle_container = Element.visible('list_middle_container');
      var is_list_bottom_container = Element.visible('list_bottom_container');
      
      var top_pane_height    = is_list_top_container    ? elListTopPane.bottom    - elListTopPane.top    : 0;
      var mid_pane_heigth    = is_list_middle_container ? elListMidPane.bottom    - elListMidPane.top    : 0;
      var bottom_pane_height = is_list_bottom_container ? elListBottomPane.bottom - elListBottomPane.top : 0;
      var list_pane_height   = elListPaneHeight.bottom - elListPaneHeight.top;
      $('list_top_container').className = 
        is_list_top_container && !mid_pane_heigth && !is_list_bottom_container
        ? 'list_top_container_single_pane'
        : 'list_top_container_multi_panes';
      
      pane_width = elListPaneHeight.right - elListPaneHeight.left - 20;
      
      if (view_name == 'task') {
        pane_width = 
          is_list_top_container &&  is_list_middle_container &&  is_list_bottom_container ? (pane_width - 200 - 200) :
          is_list_top_container && !is_list_middle_container &&  is_list_bottom_container ? (pane_width - 200 -   0) :
          is_list_top_container && !is_list_middle_container && !is_list_bottom_container ? (pane_width -   0 -   0) :
         !is_list_top_container && !is_list_middle_container &&  is_list_bottom_container ? (pane_width)
                                                                                          : 200;

        if (is_list_top_container)    $('list_top_container').style.width    = pane_width + 'px';
        if (is_list_middle_container) $('list_middle_container').style.width = '200px';
        if (is_list_bottom_container)
          $('list_bottom_container').style.width =
            !is_list_top_container && !is_list_middle_container && is_list_bottom_container
            ? pane_width + 'px'
            : '200px';

      } else if (view_name == 'meeting') {
        if (is_list_top_container && is_list_middle_container) {
          $('list_top_container').style.width    = '200px';
          $('list_middle_container').style.width = (pane_width) - 200 + 'px';

        } else if (is_list_bottom_container) {
          $('list_bottom_container').style.width = pane_width + 'px';
        }
      }

      pane_height =
        top_pane_height    >= mid_pane_heigth && top_pane_height    >= bottom_pane_height && top_pane_height    >= list_pane_height   ? top_pane_height    :
        mid_pane_heigth    >= top_pane_height && mid_pane_heigth    >= bottom_pane_height && mid_pane_heigth    >= list_pane_height   ? mid_pane_heigth    :
        bottom_pane_height >= top_pane_height && bottom_pane_height >= mid_pane_heigth    && bottom_pane_height >= list_pane_height   ? bottom_pane_height :
        list_pane_height   >= top_pane_height && list_pane_height   >= mid_pane_heigth    && list_pane_height   >= bottom_pane_height ? list_pane_height   :
                                                                                                                                        top_pane_height;
      if (is_ie7) pane_height += 20;
      $('list_top').style.height    = (pane_height + 80) + 'px';
      $('list_middle').style.height = (pane_height + 80) + 'px';
      $('list_bottom').style.height = (pane_height + 80) + 'px';

    } else {
      if ($('list_top')) $('list_top').style.height = 'auto';
      if ($('list_middle')) $('list_middle').style.height = 'auto';
      if ($('list_bottom')) $('list_bottom').style.height = 'auto';
      if ($('list_top_container')) $('list_top_container').style.width  = '';
      if ($('list_middle_container')) $('list_middle_container').style.width  = '';
      if ($('list_bottom_container')) $('list_bottom_container').style.width  = '';
      
      // task list title column resize.
      if (Tugboat.gtd_common.task._title_cells && $('list_column_header_title')) {
        var el_main_pane = YAHOO.util.Dom.getRegion('main_pane');
        var title_column_header_width = (el_main_pane.right - el_main_pane.left) - 335;
        if (title_column_header_width < 430) title_column_header_width = 430;
        $('list_column_header_title').style.width = title_column_header_width + 'px';
      
        Tugboat.gtd_common.task._title_cells.each(
          function(p) {
            p.style.width = (title_column_header_width + 10) + 'px';
          }
        );
      }
    }
  },
  
  /**
   * set application window size.
   * 
   */
  set_application_window_size : function() {
    var window_size = Tugboat.getPageSize();
    var window_width  = window_size.windowWidth;
    var isOverflow = window_width < 960;
    $('container').style.width    = isOverflow ? '960px' : '100%';
    $('content_body').style.width = isOverflow ? '960px' : '100%';
    $('html').className           = isOverflow ? 'overflow_auto' : 'one_column';
  },

  BOX_WIDTH : 148,
  BOX_HEIGHT: 130,
  BALLOON_MODE_TOP_LEFT     : 1,
  BALLOON_MODE_TOP_RIGHT    : 2,
  BALLOON_MODE_RIGHT_TOP    : 3,
  BALLOON_MODE_RIGHT_BOTTOM : 4,
  BALLOON_MODE_BOTTOM_RIGHT : 5,
  BALLOON_MODE_BOTTOM_LEFT  : 6,
  BALLOON_MODE_LEFT_BOTTOM  : 7,
  BALLOON_MODE_LEFT_TOP     : 8,
  BALLOON_ATTRIBUTE : 
  [
    {top:20,   left:-50,  class_name:'block_balloonTopLeft'},
    {top:20,   left:-50,  class_name:'block_balloonTopLeft'},
    {top:20,   left:-360, class_name:'block_balloonTopRight'},
    {top:-50,  left:-445, class_name:'block_balloonRightTop'},
    {top:-230, left:-445, class_name:'block_balloonRightBottom'},
    {top:-305, left:-360, class_name:'block_balloonBottomRight'},
    {top:-305, left:-50,  class_name:'block_balloonBottomLeft'},
    {top:-230, left:120,  class_name:'block_balloonLeftBottom'},
    {top:-50,  left:120,  class_name:'block_balloonLeftTop'}
  ],

  /**
   * show block balloon.
   * 
   * @param {Object} anchorObject
   * @param {Object} id
   * @param {Object} functionType
   */
  _show_block_balloon : function(anchorObject, id, functionType) {
    if (TugboatUI.DragBox.already_drag_started) return false;
    
    
    
    var self = Tugboat.gtd_common;
    var el_gtd_list_pane = YAHOO.util.Dom.getRegion('list_pane');
    var elBlock       = YAHOO.util.Dom.getRegion('gtd_list_' + id);
    
    var elGridListPaneHeight = el_gtd_list_pane.bottom - el_gtd_list_pane.top;
    var elGridListPaneWidth  = el_gtd_list_pane.right  - el_gtd_list_pane.left;
    var amountOfCol = Math.floor(elGridListPaneWidth  / self.BOX_WIDTH);
    var amountOfRow = Math.round(elGridListPaneHeight / self.BOX_HEIGHT);
    var boxPosX = Math.floor((elBlock.left - el_gtd_list_pane.left)/self.BOX_WIDTH ) + 1;
    var boxPosY = Math.round((elBlock.top  - el_gtd_list_pane.top )/self.BOX_HEIGHT) + 1;
    
    var showMode = 0;
    if      (boxPosX == 1                         && boxPosY <= Math.round(amountOfRow/2)) showMode = self.BALLOON_MODE_LEFT_TOP;
    else if (boxPosX == amountOfCol               && boxPosY <= Math.round(amountOfRow/2)) showMode = self.BALLOON_MODE_RIGHT_TOP;
    else if (boxPosX == 1                         && boxPosY >  Math.round(amountOfRow/2)) showMode = self.BALLOON_MODE_LEFT_BOTTOM;
    else if (boxPosX == amountOfCol               && boxPosY >  Math.round(amountOfRow/2)) showMode = self.BALLOON_MODE_RIGHT_BOTTOM;
    else if (boxPosX <= Math.round(amountOfCol/2) && boxPosY <= Math.round(amountOfRow/2)) showMode = self.BALLOON_MODE_TOP_LEFT;
    else if (boxPosX >  Math.round(amountOfCol/2) && boxPosY <= Math.round(amountOfRow/2)) showMode = self.BALLOON_MODE_TOP_RIGHT;
    else if (boxPosX <= Math.round(amountOfCol/2) && boxPosY >  Math.round(amountOfRow/2)) showMode = self.BALLOON_MODE_BOTTOM_LEFT;
    else if (boxPosX >  Math.round(amountOfCol/2) && boxPosY >  Math.round(amountOfRow/2)) showMode = self.BALLOON_MODE_BOTTOM_RIGHT;
    
    $('block_balloon').className     = self.BALLOON_ATTRIBUTE[showMode].class_name;
    $('block_balloon').style.top     = (elBlock.top  + self.BALLOON_ATTRIBUTE[showMode].top ) + 'px';
    $('block_balloon').style.left    = (elBlock.left + self.BALLOON_ATTRIBUTE[showMode].left) + 'px';
    $('block_balloon').style.display = Tugboat.constant.STYLE_DISPLAY_BLOCK;
    
    // processing....
    $('block_balloon_item_icons').innerHTML = '';
    $('detail_balloon_option_1').innerHTML = '';
    $('detail_balloon_option_2').innerHTML = '';
    
    if ($('block_balloon_item_links_list')) $('block_balloon_item_links_list').innerHTML = '';
    if ($('block_balloon_item_tags')) $('block_balloon_item_tags').innerHTML = '';
    
    var component = '';
    var action = '';
    if (functionType == Tugboat.gtd_common.FUNC_TYPE_TASK) {
      component = 'taskAjax';
      action = 'getTaskForBalloonJSON';
    }
    else if (functionType == Tugboat.gtd_common.FUNC_TYPE_MEETING) {
      component = 'meetingAjax';
      action = 'getMeetingBalloonJson';
    }
    
    Tugboat.gtd_common.progress.open();
    new Ajax.Request(
      Tugboat.AJAX_SERVLET_NAME,
      { 
        method: Tugboat.constant.REQUEST_GET,
        parameters: 
        {
          component: component,
          action   : action,
          id       : id
        },
        onComplete: function(transport){
          if (functionType == Tugboat.gtd_common.FUNC_TYPE_TASK) {
            self.task._create_balloon(transport);
          }
          else if (functionType == Tugboat.gtd_common.FUNC_TYPE_MEETING) {
            self.meeting._create_balloon(transport);
          }
          Tugboat.gtd_common.progress.close();
        }
      }
    );
  },

  progress : {
    _is_processing : false,
    
    open : function () {
      var self = Tugboat.gtd_common.progress;
      if (self._is_processing) return false;
      self._is_processing = true;
      
      var page = Tugboat.getPageSize(); 
      Element.setHeight('progress_window', page.pageHeight);
      $('progress_window').style.display = Tugboat.constant.STYLE_DISPLAY_BLOCK;
    },
    close : function() {
      Tugboat.gtd_common.progress._is_processing = false;
      Element.hide('progress_window');
    }
  }
};
YAHOO.util.Event.addListener(
  document, "keydown",
  function(key){
    if (key.keyCode == Event.KEY_ESC) {
      var elmBlockBalloon = $('block_balloon');
      if(elmBlockBalloon) {
        $('block_balloon').style.display=Tugboat.constant.STYLE_DISPLAY_NONE;
      }
    }
  }
);
