/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.dao;

import org.seasar.dao.unit.S2DaoTestCase;
import org.seasar.tugboat.gtd.contents.task.entity.TaskBody;

/**
 * test TaskBodiesDao.
 * 
 * @author yosuke
 * 
 */
public class TestTaskBodiesDao extends S2DaoTestCase {
    TaskBodiesDao taskBodiesDao_;

    @Override
    public void setUp() {
        this.include("dicon/contents/task/taskDao.dicon");
    }

    /**
     * test #insert.
     * 
     */
    public void testInsertTx() {
        super.readXlsWriteDb("tasks.xls");

        TaskBody taskBody = new TaskBody();
        taskBody.setTaskId(9990);
        taskBody.setBody("nitidezza di scrittura.");

        this.taskBodiesDao_.delete(taskBody);
        this.taskBodiesDao_.insert(taskBody);

        TaskBody entity = this.taskBodiesDao_.findByTaskId(9990);
        System.out.println(entity);

        super.assertNotNull(entity);
        super.assertEquals(9990, entity.getTaskId());
        super.assertEquals("nitidezza di scrittura.", entity.getBody());
    }

    /**
     * test #update.
     * 
     */
    public void testUpdateTx() {
        super.readXlsWriteDb("tasks.xls");

        TaskBody taskBody = new TaskBody();
        taskBody.setTaskId(9990);
        taskBody.setBody("nitidezza di scrittura.");

        this.taskBodiesDao_.delete(taskBody);
        this.taskBodiesDao_.insert(taskBody);

        taskBody.setBody("Lexikon");
        this.taskBodiesDao_.update(taskBody);

        TaskBody entity = this.taskBodiesDao_.findByTaskId(9990);
        System.out.println(entity);

        super.assertNotNull(entity);
        super.assertEquals(9990, entity.getTaskId());
        super.assertEquals("Lexikon", entity.getBody());
    }

    /**
     * test #delete.
     * 
     */
    public void testDeleteTx() {
        super.readXlsWriteDb("tasks.xls");

        TaskBody taskBody = new TaskBody();
        taskBody.setTaskId(9990);
        taskBody.setBody("nitidezza di scrittura.");
        this.taskBodiesDao_.insert(taskBody);

        this.taskBodiesDao_.delete(taskBody);

        TaskBody entity = this.taskBodiesDao_.findByTaskId(9990);
        System.out.println(entity);

        super.assertNull(entity);
    }
}
