/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.dao;

import org.seasar.dao.unit.S2DaoTestCase;
import org.seasar.tugboat.gtd.contents.task.entity.TaskBrowsePerson;

/**
 * test TaskBrowsePersonsDao.
 * 
 * @author yosuke
 * 
 */
public class TestTaskBrowserPersonsDao extends S2DaoTestCase {
    TaskBrowserPersonsDao taskBrowsePersonsDao_;

    @Override
    public void setUp() {
        this.include("dicon/contents/task/taskDao.dicon");
    }

    /**
     * test #insert.
     * 
     */
    public void testInsertTx() {
        super.readXlsWriteDb("taskBrowseRelated.xls");

        int result = this.taskBrowsePersonsDao_.insert(9990, 9990);
        super.assertEquals("[OK]", 1, result);
    }

    /**
     * test #delete.
     * 
     */
    public void testDeleteTx() {
        super.readXlsWriteDb("taskBrowseRelated.xls");

        this.taskBrowsePersonsDao_.insert(9990, 9990);

        int result = this.taskBrowsePersonsDao_.delete(9990);
        super.assertEquals("[OK]", 1, result);
    }

    /**
     * test #findByUserId.
     * 
     */
    public void testFindByUserIdTx() {
        super.readXlsWriteDb("taskBrowseRelated.xls");

        this.taskBrowsePersonsDao_.insert(9990, 9990);
        this.taskBrowsePersonsDao_.insert(9991, 9990);
        this.taskBrowsePersonsDao_.insert(9992, 9990);

        TaskBrowsePerson[] result = this.taskBrowsePersonsDao_
                .findByUserId(9990);

        super.assertEquals("[OK]", 3, result.length);
    }
}
