/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.dao;

import org.seasar.dao.unit.S2DaoTestCase;
import org.seasar.tugboat.gtd.contents.task.entity.TaskCommentRelation;

/**
 * test TaskCommentRelatiosDao.
 * 
 * @author yosuke
 * 
 */
public class TestTaskCommentRelatiosDao extends S2DaoTestCase {
    TaskCommentRelatiosDao taskCommentRelatiosDao_;

    @Override
    public void setUp() {
        this.include("dicon/contents/task/taskDao.dicon");
    }

    /**
     * test TaskCommentRelatiosDao#findByCommentId.
     * 
     */
    public void testFindByCommentIdTx() {
        super.readXlsWriteDb("task_comment_bodies.xls");

        TaskCommentRelation relation = this.taskCommentRelatiosDao_
                .findByCommentId(9990);

        super.assertNotNull(relation);
        super.assertEquals("", 9990, relation.getActivityId());
        super.assertEquals("", 9990, relation.getTaskId());
        super.assertEquals("", 9990, relation.getUserId());
        super.assertEquals("", true, "Comment Body -1".equals(relation
                .getComment()));
    }
}
