/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.dao;

import org.seasar.dao.unit.S2DaoTestCase;
import org.seasar.tugboat.gtd.commons.util.CalendarUtil;
import org.seasar.tugboat.gtd.contents.task.entity.TaskHistory;

/**
 * test TaskHistoriesDao.
 * 
 * @author yosuke
 * 
 */
public class TestTaskHistoriesDao extends S2DaoTestCase {
    TaskHistoriesDao taskHistoriesDao_;

    @Override
    public void setUp() {
        this.include("dicon/contents/task/taskDao.dicon");
    }

    /**
     * test TaskHistoriesDao#insert.
     * 
     */
    public void testInsertTx() {
        super.readXlsWriteDb("tasks.xls");

        TaskHistory history = new TaskHistory();
        history.setTaskId(9990);
        history.setStatusId(2);
        history.setUserId(9990);
        history.setRegistered(CalendarUtil.now(CalendarUtil.DATE_LONG_FORMAT_FOR_RDB));
        this.taskHistoriesDao_.insert(history);

        TaskHistory[] histories = this.taskHistoriesDao_.findByTaskId(9990);
        super.assertNotNull(histories);
        super.assertEquals("[OK]", 2, histories.length);
    }

    /**
     * test TaskHistoriesDao#findByTaskId.
     * 
     */
    public void testFindByTaskIdTx() {
        super.readXlsWriteDb("tasks.xls");

        TaskHistory[] histories = this.taskHistoriesDao_.findByTaskId(9990);
        super.assertNotNull(histories);
        super.assertEquals("[OK]", 1, histories.length);
    }
}
