/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.dao;

import org.seasar.dao.unit.S2DaoTestCase;
import org.seasar.tugboat.gtd.commons.util.CalendarUtil;
import org.seasar.tugboat.gtd.contents.task.entity.TaskTag;

/**
 * test TaskTagsDao.
 * 
 * @author yosuke
 * 
 */
public class TestTaskTagsDao extends S2DaoTestCase {
    TaskTagsDao taskTagsDao_;

    @Override
    public void setUp() {
        this.include("dicon/contents/task/taskDao.dicon");
    }

    /**
     * test #insert.
     * 
     */
    public void testInsertTx() {
        super.readXlsWriteDb("taskBrowseRelated.xls");

        TaskTag entity = new TaskTag();
        entity.setTaskId(9990);
        entity.setTagId(9990);
        entity.setUserId(9990);
        entity.setPostedAt(CalendarUtil.now(CalendarUtil.DATE_LONG_FORMAT_FOR_RDB));
        int result = this.taskTagsDao_.insert(entity);
        super.assertEquals("[OK]", 1, result);
    }

    /**
     * test #delete
     * 
     */
    public void testDeleteTx() {
        super.readXlsWriteDb("taskBrowseRelated.xls");

        TaskTag entity = new TaskTag();
        entity.setTaskId(9990);
        entity.setTagId(9990);
        entity.setUserId(9990);
        entity.setPostedAt(CalendarUtil.now(CalendarUtil.DATE_LONG_FORMAT_FOR_RDB));
        this.taskTagsDao_.insert(entity);

        int result = this.taskTagsDao_.delete(entity.getTaskId());
        super.assertEquals("[OK]", 4, result);
    }

    /**
     * test #findByUserId.
     * 
     */
    public void testFindByUserIdTx() {
        super.readXlsWriteDb("taskBrowseRelated.xls");

        TaskTag[] result = this.taskTagsDao_.findByUserId(9990);
        super.assertEquals("[OK]", 10, result.length);
    }

    /**
     * test #findByTaskIdAndUserId.
     * 
     */
    public void testFindByTaskIdAndUserIdTx() {
        super.readXlsWriteDb("taskBrowseRelated.xls");

        TaskTag[] result = this.taskTagsDao_.findByTaskIdAndUserId(9990, 9990);
        super.assertEquals("[OK]", 3, result.length);
    }
}
