/*
 * Copyright 2004-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.dao;

import org.seasar.dao.unit.S2DaoTestCase;
import org.seasar.tugboat.gtd.contents.task.entity.TaskToTask;

/**
 * test TaskToTasksDao.
 * 
 * @author yosuke
 * 
 */
public class TestTaskToTasksDao extends S2DaoTestCase {
    TaskToTasksDao taskToTasksDao_;

    @Override
    public void setUp() {
        this.include("dicon/contents/task/taskDao.dicon");
    }

    /**
     * test #insert.
     * 
     */
    public void testInsertTx() {
        super.readXlsWriteDb("tasks.xls");

        TaskToTask taskToTask = new TaskToTask();
        taskToTask.setSourceTaskId(9990);
        taskToTask.setDestinationTaskId(9991);
        this.taskToTasksDao_.insert(taskToTask);
    }

    /**
     * test #delete.
     * 
     */
    public void testDeleteTx() {
        super.readXlsWriteDb("tasks.xls");
        TaskToTask taskToTask = new TaskToTask();
        taskToTask.setSourceTaskId(9990);
        taskToTask.setDestinationTaskId(9991);
        this.taskToTasksDao_.insert(taskToTask);

        int result = this.taskToTasksDao_.delete(taskToTask);
        super.assertEquals("[OK]", 1, result);
    }

    /**
     * test #findTaskToTasksByTaskId.
     * 
     */
    public void testFindTaskToTasksByTaskIdTx() {
        super.readXlsWriteDb("tasks.xls");
        TaskToTask taskToTask = new TaskToTask();
        taskToTask.setSourceTaskId(9990);
        taskToTask.setDestinationTaskId(9991);
        this.taskToTasksDao_.insert(taskToTask);

        taskToTask = new TaskToTask();
        taskToTask.setSourceTaskId(9991);
        taskToTask.setDestinationTaskId(9992);
        this.taskToTasksDao_.insert(taskToTask);

        TaskToTask[] tasks = this.taskToTasksDao_.findTaskToTasksByTaskId(9991);
        super.assertNotNull(tasks);
        super.assertEquals("[OK]", true, 0 < tasks.length);
        super.assertEquals("[OK]", 2, tasks.length);
    }
}
