package org.seasar.tugboat.gtd.mailservices.dao;

import org.seasar.dao.unit.S2DaoTestCase;
import org.seasar.tugboat.gtd.mailservices.entity.MeetingMail;

public class TestMeetingMailsDao extends S2DaoTestCase {
    MeetingMailsDao meetingMailsDao_;
    
    public void setUp() {
        this.include("dicon/mailservices/mailDao.dicon");
    }
    
    public void testInsertTx() {
        super.readXlsWriteDb("meeting_basics.xls");
        MeetingMail mail = new MeetingMail();
        mail.setBasicId(9990);
        mail.setSentBy(9990);
        mail.setMessageId("<XXXXXXXXXXXXXXXXXXX>");
        meetingMailsDao_.insert(mail);
        
    }

    public void testFindLatestByBasicIdTx() {
        super.readXlsWriteDb("meeting_basics.xls");
        String messageId = "<xxxxxxxxxxxxx@xxxx>";
        
        MeetingMail mail = new MeetingMail();
        mail.setBasicId(9990);
        mail.setSentBy(9990);
        mail.setMessageId(messageId);
        meetingMailsDao_.insert(mail);
        
        mail = meetingMailsDao_.findLatestByBasicId(-10);
        assertNull(mail);
        mail = meetingMailsDao_.findLatestByBasicId(9990);
        assertNotNull(mail);
        assertEquals(mail.getMessageId(),messageId);
        
        
    }

}
